// This file is generated by ./polymul_NxN-new.py


#include <immintrin.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "polymul_NxN.h"
#include "polymul_32x32.h"

void gf_polymul_32x32_avx2_uvqr_fg_x (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[4];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+2);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);

  gf_polymul_32x32_avx2_divR(ff,uvqr,f);
  gf_polymul_32x32_avx2_divR(t,uvqr+2,g);
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);

  ff[2]=_mm256_blendv_epi8(ff[2],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[3]=_mm256_blendv_epi8(ff[3],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);


  ff[0] = montproduct(ff[0],v4158_16); // <2295
  ff[1] = montproduct(ff[1],v4158_16); // <2295
  ff[2] = montproduct(ff[2],v4158_16); // <2295
  ff[3] = montproduct(ff[3],v4158_16); // <2295
}
void gf_polymul_32x32_avx2_uvqr_vr_x (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[4];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+2);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);
  __m256i f_mask = uv_over(f);

  gf_polymul_32x32_avx2_divR(ff,uvqr,f);
  ff[2]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[0]),ff[2]);
  ff[0]=_mm256_andnot_si256(f_mask,ff[0]);
  ff[3]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[1]),ff[3]);
  ff[1]=_mm256_andnot_si256(f_mask,ff[1]);
  gf_polymul_32x32_avx2_divR(t,uvqr+2,g);
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);

  ff[2]=_mm256_blendv_epi8(ff[2],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[3]=_mm256_blendv_epi8(ff[3],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);


  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);

  ff[0] = montproduct(ff[0],v4158_16); // <2295
  ff[1] = montproduct(ff[1],v4158_16); // <2295
  ff[2] = montproduct(ff[2],v4158_16); // <2295
  ff[3] = montproduct(ff[3],v4158_16); // <2295

  ff[0] = _mm256_or_si256(_mm256_and_si256(_mm256_and_si256(u_mask,f_mask),v01),ff[0]);
}
void gf_polymul_64x64_avx2_divR (__m256i *h, __m256i *f, __m256i *g){
  __m256i ff[5], gg[5], hh[10];
  __m256i t[4];

  ff[0]=_mm256_add_epi16(f[0],f[2]); // <5762
  gg[0]=_mm256_add_epi16(g[0],g[2]); // <5762
  ff[1]=_mm256_add_epi16(f[1],f[3]); // <5762
  gg[1]=_mm256_add_epi16(g[1],g[3]); // <5762

  gf_polymul_32x32_avx2_divR((h + 0),(g + 0),(f + 0));
  // h[0] <= 4321 h[1] <= 6347 h[2] <= 6221 h[3] <= 4194
  gf_polymul_32x32_avx2_divR((h + 4),(g + 2),(f + 2));
  // h[4] <= 4321 h[5] <= 6347 h[6] <= 6221 h[7] <= 4194
  gf_polymul_32x32_avx2_divR((hh + 0),(gg + 0),(ff + 0));
  // hh[0] <= 10400 hh[1] <= 18506 hh[2] <= 17999 hh[3] <= 9894

  hh[0] = barrett_fake(hh[0]); // <2430
  hh[1] = barrett_fake(hh[1]); // <2610
  hh[2] = barrett_fake(hh[2]); // <2610
  hh[3] = barrett_fake(hh[3]); // <2430
  t[0] = _mm256_sub_epi16(h[2],h[4]); // <10542
  t[1] = _mm256_sub_epi16(h[3],h[5]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[6]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[7]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[0]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[1]); // <16888
  h[4] = _mm256_sub_epi16(hh[2],t[2]); // <19373
  h[5] = _mm256_sub_epi16(hh[3],t[3]); // <17165
  h[2] = _mm256_add_epi16(hh[0],t[0]); // <17293
  h[3] = _mm256_add_epi16(hh[1],t[1]); // <19498

}
void gf_polymul_64x64_avx2 (__m256i *h, __m256i *f, __m256i *g){
  gf_polymul_64x64_avx2_divR(h,f,g);
  h[0]=montproduct(h[0],v4158_16); // <2340
  h[1]=montproduct(h[1],v4158_16); // <2340
  h[2]=montproduct(h[2],v4158_16); // <2610
  h[3]=montproduct(h[3],v4158_16); // <2610
  h[4]=montproduct(h[4],v4158_16); // <2610
  h[5]=montproduct(h[5],v4158_16); // <2610
  h[6]=montproduct(h[6],v4158_16); // <2340
  h[7]=montproduct(h[7],v4158_16); // <2340
}
void gf_polymul_64x64_avx2_uvqr_fg (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[8];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+4);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);

  gf_polymul_64x64_avx2_divR(ff,uvqr,f);
  gf_polymul_64x64_avx2_divR(t,uvqr+4,g);
  ff[2] = barrett_fake(ff[2]); // <2610
  t[2] = barrett_fake(t[2]); // <2610
  ff[3] = barrett_fake(ff[3]); // <2610
  t[3] = barrett_fake(t[3]); // <2610
  ff[4] = barrett_fake(ff[4]); // <2610
  t[4] = barrett_fake(t[4]); // <2610
  ff[5] = barrett_fake(ff[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);

  ff[4]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[0]),ff[4]);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[5]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[1]),ff[5]);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[6]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[2]),ff[6]);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[7]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[3]),ff[7]);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);

  gf_polymul_64x64_avx2_divR(gg,uvqr+8,f);
  gf_polymul_64x64_avx2_divR(t,uvqr+12,g);
  gg[2] = barrett_fake(gg[2]); // <2610
  t[2] = barrett_fake(t[2]); // <2610
  gg[3] = barrett_fake(gg[3]); // <2610
  t[3] = barrett_fake(t[3]); // <2610
  gg[4] = barrett_fake(gg[4]); // <2610
  t[4] = barrett_fake(t[4]); // <2610
  gg[5] = barrett_fake(gg[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610

  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  gg[0] = montproduct(gg[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  gg[1] = montproduct(gg[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  gg[2] = montproduct(gg[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  gg[3] = montproduct(gg[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2626
  gg[4] = montproduct(gg[4],v4158_16); // <2626
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  gg[5] = montproduct(gg[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <3084
  gg[6] = montproduct(gg[6],v4158_16); // <3084
  ff[7] = montproduct(ff[7],v4158_16); // <2827
  gg[7] = montproduct(gg[7],v4158_16); // <2827
}
void gf_polymul_64x64_avx2_uvqr_vr (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[8];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+4);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);
  __m256i f_mask = uv_over(f);

  gf_polymul_64x64_avx2_divR(ff,uvqr,f);
  ff[4]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[0]),ff[4]);
  ff[0]=_mm256_andnot_si256(f_mask,ff[0]);
  ff[5]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[1]),ff[5]);
  ff[1]=_mm256_andnot_si256(f_mask,ff[1]);
  ff[6]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[2]),ff[6]);
  ff[2]=_mm256_andnot_si256(f_mask,ff[2]);
  ff[7]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[3]),ff[7]);
  ff[3]=_mm256_andnot_si256(f_mask,ff[3]);
  gf_polymul_64x64_avx2_divR(t,uvqr+4,g);
  ff[2] = barrett_fake(ff[2]); // <2610
  t[2] = barrett_fake(t[2]); // <2610
  ff[3] = barrett_fake(ff[3]); // <2610
  t[3] = barrett_fake(t[3]); // <2610
  ff[4] = barrett_fake(ff[4]); // <2610
  t[4] = barrett_fake(t[4]); // <2610
  ff[5] = barrett_fake(ff[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);

  ff[4]=_mm256_blendv_epi8(ff[4],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[5]=_mm256_blendv_epi8(ff[5],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[6]=_mm256_blendv_epi8(ff[6],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[7]=_mm256_blendv_epi8(ff[7],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);

  gf_polymul_64x64_avx2_divR(gg,uvqr+8,f);
  gg[4]=_mm256_blendv_epi8(gg[4],gg[0],f_mask);
  gg[0]=_mm256_andnot_si256(f_mask,gg[0]);
  gg[5]=_mm256_blendv_epi8(gg[5],gg[1],f_mask);
  gg[1]=_mm256_andnot_si256(f_mask,gg[1]);
  gg[6]=_mm256_blendv_epi8(gg[6],gg[2],f_mask);
  gg[2]=_mm256_andnot_si256(f_mask,gg[2]);
  gg[7]=_mm256_blendv_epi8(gg[7],gg[3],f_mask);
  gg[3]=_mm256_andnot_si256(f_mask,gg[3]);
  gf_polymul_64x64_avx2_divR(t,uvqr+12,g);
  gg[2] = barrett_fake(gg[2]); // <2610
  t[2] = barrett_fake(t[2]); // <2610
  gg[3] = barrett_fake(gg[3]); // <2610
  t[3] = barrett_fake(t[3]); // <2610
  gg[4] = barrett_fake(gg[4]); // <2610
  t[4] = barrett_fake(t[4]); // <2610
  gg[5] = barrett_fake(gg[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610

  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  gg[0] = montproduct(gg[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  gg[1] = montproduct(gg[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  gg[2] = montproduct(gg[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  gg[3] = montproduct(gg[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2626
  gg[4] = montproduct(gg[4],v4158_16); // <2626
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  gg[5] = montproduct(gg[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <3084
  gg[6] = montproduct(gg[6],v4158_16); // <3084
  ff[7] = montproduct(ff[7],v4158_16); // <2827
  gg[7] = montproduct(gg[7],v4158_16); // <2827

  ff[0] = _mm256_blendv_epi8(ff[0],v01,u_mask&f_mask);
}
void gf_polymul_64x64_avx2_uvqr_fg_x (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[8];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+4);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);

  gf_polymul_64x64_avx2_divR(ff,uvqr,f);
  gf_polymul_64x64_avx2_divR(t,uvqr+4,g);
  ff[2] = barrett_fake(ff[2]); // <2610
  t[2] = barrett_fake(t[2]); // <2610
  ff[3] = barrett_fake(ff[3]); // <2610
  t[3] = barrett_fake(t[3]); // <2610
  ff[4] = barrett_fake(ff[4]); // <2610
  t[4] = barrett_fake(t[4]); // <2610
  ff[5] = barrett_fake(ff[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);

  ff[4]=_mm256_blendv_epi8(ff[4],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[5]=_mm256_blendv_epi8(ff[5],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[6]=_mm256_blendv_epi8(ff[6],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[7]=_mm256_blendv_epi8(ff[7],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);


  ff[0] = montproduct(ff[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2626
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <3084
  ff[7] = montproduct(ff[7],v4158_16); // <2827
}
void gf_polymul_64x64_avx2_uvqr_vr_x (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[8];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+4);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);
  __m256i f_mask = uv_over(f);

  gf_polymul_64x64_avx2_divR(ff,uvqr,f);
  ff[4]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[0]),ff[4]);
  ff[0]=_mm256_andnot_si256(f_mask,ff[0]);
  ff[5]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[1]),ff[5]);
  ff[1]=_mm256_andnot_si256(f_mask,ff[1]);
  ff[6]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[2]),ff[6]);
  ff[2]=_mm256_andnot_si256(f_mask,ff[2]);
  ff[7]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[3]),ff[7]);
  ff[3]=_mm256_andnot_si256(f_mask,ff[3]);
  gf_polymul_64x64_avx2_divR(t,uvqr+4,g);
  ff[2] = barrett_fake(ff[2]); // <2610
  t[2] = barrett_fake(t[2]); // <2610
  ff[3] = barrett_fake(ff[3]); // <2610
  t[3] = barrett_fake(t[3]); // <2610
  ff[4] = barrett_fake(ff[4]); // <2610
  t[4] = barrett_fake(t[4]); // <2610
  ff[5] = barrett_fake(ff[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);

  ff[4]=_mm256_blendv_epi8(ff[4],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[5]=_mm256_blendv_epi8(ff[5],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[6]=_mm256_blendv_epi8(ff[6],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[7]=_mm256_blendv_epi8(ff[7],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);


  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2626
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <3084
  ff[7] = montproduct(ff[7],v4158_16); // <2827

  ff[0] = _mm256_or_si256(_mm256_and_si256(_mm256_and_si256(u_mask,f_mask),v01),ff[0]);
}
void gf_polymul_128x128_avx2_divR (__m256i *h, __m256i *f, __m256i *g){
  __m256i ff[19], gg[19], hh[38];
  __m256i t[8];

  ff[0]=_mm256_add_epi16(f[0],f[4]); // <5762
  gg[0]=_mm256_add_epi16(g[0],g[4]); // <5762
  ff[1]=_mm256_add_epi16(f[1],f[5]); // <5762
  gg[1]=_mm256_add_epi16(g[1],g[5]); // <5762
  ff[2]=_mm256_add_epi16(f[2],f[6]); // <5762
  gg[2]=_mm256_add_epi16(g[2],g[6]); // <5762
  ff[3]=_mm256_add_epi16(f[3],f[7]); // <5762
  gg[3]=_mm256_add_epi16(g[3],g[7]); // <5762
  ff[4]=_mm256_add_epi16(f[0],f[2]); // <5762
  gg[4]=_mm256_add_epi16(g[0],g[2]); // <5762
  ff[5]=_mm256_add_epi16(f[1],f[3]); // <5762
  gg[5]=_mm256_add_epi16(g[1],g[3]); // <5762
  ff[6]=_mm256_add_epi16(f[4],f[6]); // <5762
  gg[6]=_mm256_add_epi16(g[4],g[6]); // <5762
  ff[7]=_mm256_add_epi16(f[5],f[7]); // <5762
  gg[7]=_mm256_add_epi16(g[5],g[7]); // <5762
  ff[8]=_mm256_add_epi16(ff[0],ff[2]); // <11524
  gg[8]=_mm256_add_epi16(gg[0],gg[2]); // <11524
  ff[9]=_mm256_add_epi16(ff[1],ff[3]); // <11524
  gg[9]=_mm256_add_epi16(gg[1],gg[3]); // <11524

  ff[8] = barrett_fake(ff[8]); // <2430
  gg[8] = barrett_fake(gg[8]); // <2430
  ff[9] = barrett_fake(ff[9]); // <2340
  gg[9] = barrett_fake(gg[9]); // <2340
  gf_polymul_32x32_avx2_divR((h + 0),(g + 0),(f + 0));
  // h[0] <= 4321 h[1] <= 6347 h[2] <= 6221 h[3] <= 4194
  gf_polymul_32x32_avx2_divR((h + 4),(g + 2),(f + 2));
  // h[4] <= 4321 h[5] <= 6347 h[6] <= 6221 h[7] <= 4194
  gf_polymul_32x32_avx2_divR((h + 8),(g + 4),(f + 4));
  // h[8] <= 4321 h[9] <= 6347 h[10] <= 6221 h[11] <= 4194
  gf_polymul_32x32_avx2_divR((h + 12),(g + 6),(f + 6));
  // h[12] <= 4321 h[13] <= 6347 h[14] <= 6221 h[15] <= 4194
  gf_polymul_32x32_avx2_divR((hh + 0),(gg + 0),(ff + 0));
  // hh[0] <= 10400 hh[1] <= 18506 hh[2] <= 17999 hh[3] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 4),(gg + 2),(ff + 2));
  // hh[4] <= 10400 hh[5] <= 18506 hh[6] <= 17999 hh[7] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 8),(gg + 4),(ff + 4));
  // hh[8] <= 10400 hh[9] <= 18506 hh[10] <= 17999 hh[11] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 12),(gg + 6),(ff + 6));
  // hh[12] <= 10400 hh[13] <= 18506 hh[14] <= 17999 hh[15] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 16),(gg + 8),(ff + 8));
  // hh[16] <= 3736 hh[17] <= 5178 hh[18] <= 5088 hh[19] <= 3646

  hh[0] = barrett_fake(hh[0]); // <2430
  hh[1] = barrett_fake(hh[1]); // <2610
  hh[2] = barrett_fake(hh[2]); // <2610
  hh[3] = barrett_fake(hh[3]); // <2430
  hh[4] = barrett_fake(hh[4]); // <2430
  hh[5] = barrett_fake(hh[5]); // <2610
  hh[6] = barrett_fake(hh[6]); // <2610
  hh[7] = barrett_fake(hh[7]); // <2430
  hh[8] = barrett_fake(hh[8]); // <2430
  hh[9] = barrett_fake(hh[9]); // <2610
  hh[10] = barrett_fake(hh[10]); // <2610
  hh[11] = barrett_fake(hh[11]); // <2430
  hh[12] = barrett_fake(hh[12]); // <2430
  hh[13] = barrett_fake(hh[13]); // <2610
  hh[14] = barrett_fake(hh[14]); // <2610
  hh[15] = barrett_fake(hh[15]); // <2430
  t[0] = _mm256_sub_epi16(h[2],h[4]); // <10542
  t[1] = _mm256_sub_epi16(h[3],h[5]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[6]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[7]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[0]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[1]); // <16888
  h[4] = _mm256_sub_epi16(hh[10],t[2]); // <19373
  h[5] = _mm256_sub_epi16(hh[11],t[3]); // <17165
  h[2] = _mm256_add_epi16(hh[8],t[0]); // <17293
  h[3] = _mm256_add_epi16(hh[9],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[10],h[12]); // <10542
  t[1] = _mm256_sub_epi16(h[11],h[13]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[14]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[15]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[8]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[9]); // <16888
  h[12] = _mm256_sub_epi16(hh[14],t[2]); // <19373
  h[13] = _mm256_sub_epi16(hh[15],t[3]); // <17165
  h[10] = _mm256_add_epi16(hh[12],t[0]); // <17293
  h[11] = _mm256_add_epi16(hh[13],t[1]); // <19498
  t[0] = _mm256_sub_epi16(hh[2],hh[4]); // <5040
  t[1] = _mm256_sub_epi16(hh[3],hh[5]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[6]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[7]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[0]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[1]); // <7650
  hh[4] = _mm256_sub_epi16(hh[18],t[2]); // <12738
  hh[5] = _mm256_sub_epi16(hh[19],t[3]); // <11116
  hh[2] = _mm256_add_epi16(hh[16],t[0]); // <11206
  hh[3] = _mm256_add_epi16(hh[17],t[1]); // <12828

  h[2] = barrett_fake(h[2]); // <2610
  h[3] = barrett_fake(h[3]); // <2610
  h[4] = barrett_fake(h[4]); // <2610
  h[5] = barrett_fake(h[5]); // <2610
  h[10] = barrett_fake(h[10]); // <2610
  h[11] = barrett_fake(h[11]); // <2610
  h[12] = barrett_fake(h[12]); // <2610
  h[13] = barrett_fake(h[13]); // <2610
  hh[2] = barrett_fake(hh[2]); // <2430
  hh[3] = barrett_fake(hh[3]); // <2520
  hh[4] = barrett_fake(hh[4]); // <2520
  hh[5] = barrett_fake(hh[5]); // <2430
  t[0] = _mm256_sub_epi16(h[4],h[8]); // <6931
  t[1] = _mm256_sub_epi16(h[5],h[9]); // <8957
  t[2] = _mm256_sub_epi16(h[6],h[10]); // <8831
  t[3] = _mm256_sub_epi16(h[7],h[11]); // <6804
  t[4] = _mm256_add_epi16(t[0],h[12]); // <9541
  t[5] = _mm256_add_epi16(t[1],h[13]); // <11567
  t[6] = _mm256_add_epi16(t[2],h[14]); // <15052
  t[7] = _mm256_add_epi16(t[3],h[15]); // <10998
  t[0] = _mm256_sub_epi16(t[0],h[0]); // <11252
  t[1] = _mm256_sub_epi16(t[1],h[1]); // <15304
  t[2] = _mm256_sub_epi16(t[2],h[2]); // <11441
  t[3] = _mm256_sub_epi16(t[3],h[3]); // <9414
  h[8] = _mm256_sub_epi16(hh[4],t[4]); // <12061
  h[9] = _mm256_sub_epi16(hh[5],t[5]); // <13997
  h[10] = _mm256_sub_epi16(hh[6],t[6]); // <17662
  h[11] = _mm256_sub_epi16(hh[7],t[7]); // <13428
  h[4] = _mm256_add_epi16(hh[0],t[0]); // <13682
  h[5] = _mm256_add_epi16(hh[1],t[1]); // <17914
  h[6] = _mm256_add_epi16(hh[2],t[2]); // <13871
  h[7] = _mm256_add_epi16(hh[3],t[3]); // <11934

}
void gf_polymul_128x128_avx2 (__m256i *h, __m256i *f, __m256i *g){
  gf_polymul_128x128_avx2_divR(h,f,g);
  h[0]=montproduct(h[0],v4158_16); // <2340
  h[1]=montproduct(h[1],v4158_16); // <2340
  h[2]=montproduct(h[2],v4158_16); // <2340
  h[3]=montproduct(h[3],v4158_16); // <2340
  h[4]=montproduct(h[4],v4158_16); // <2520
  h[5]=montproduct(h[5],v4158_16); // <2610
  h[6]=montproduct(h[6],v4158_16); // <2520
  h[7]=montproduct(h[7],v4158_16); // <2520
  h[8]=montproduct(h[8],v4158_16); // <2520
  h[9]=montproduct(h[9],v4158_16); // <2520
  h[10]=montproduct(h[10],v4158_16); // <2610
  h[11]=montproduct(h[11],v4158_16); // <2520
  h[12]=montproduct(h[12],v4158_16); // <2340
  h[13]=montproduct(h[13],v4158_16); // <2340
  h[14]=montproduct(h[14],v4158_16); // <2340
  h[15]=montproduct(h[15],v4158_16); // <2340
}
void gf_polymul_128x128_avx2_uvqr_fg (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[16];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+8);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);

  gf_polymul_128x128_avx2_divR(ff,uvqr,f);
  gf_polymul_128x128_avx2_divR(t,uvqr+8,g);
  ff[5] = barrett_fake(ff[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610
  ff[10] = barrett_fake(ff[10]); // <2610
  t[10] = barrett_fake(t[10]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);

  ff[8]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[0]),ff[8]);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[9]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[1]),ff[9]);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[10]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[2]),ff[10]);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[11]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[3]),ff[11]);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[12]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[4]),ff[12]);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[13]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[5]),ff[13]);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[14]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[6]),ff[14]);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[15]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[7]),ff[15]);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);

  gf_polymul_128x128_avx2_divR(gg,uvqr+16,f);
  gf_polymul_128x128_avx2_divR(t,uvqr+24,g);
  gg[5] = barrett_fake(gg[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610
  gg[10] = barrett_fake(gg[10]); // <2610
  t[10] = barrett_fake(t[10]); // <2610

  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);
  gg[8]=_mm256_add_epi16(gg[8],t[8]);
  gg[9]=_mm256_add_epi16(gg[9],t[9]);
  gg[10]=_mm256_add_epi16(gg[10],t[10]);
  gg[11]=_mm256_add_epi16(gg[11],t[11]);
  gg[12]=_mm256_add_epi16(gg[12],t[12]);
  gg[13]=_mm256_add_epi16(gg[13],t[13]);
  gg[14]=_mm256_add_epi16(gg[14],t[14]);
  gg[15]=_mm256_add_epi16(gg[15],t[15]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  gg[0] = montproduct(gg[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  gg[1] = montproduct(gg[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  gg[2] = montproduct(gg[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  gg[3] = montproduct(gg[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <4031
  gg[4] = montproduct(gg[4],v4158_16); // <4031
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  gg[5] = montproduct(gg[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <4055
  gg[6] = montproduct(gg[6],v4158_16); // <4055
  ff[7] = montproduct(ff[7],v4158_16); // <3809
  gg[7] = montproduct(gg[7],v4158_16); // <3809
  ff[8] = montproduct(ff[8],v4158_16); // <3825
  gg[8] = montproduct(gg[8],v4158_16); // <3825
  ff[9] = montproduct(ff[9],v4158_16); // <4071
  gg[9] = montproduct(gg[9],v4158_16); // <4071
  ff[10] = montproduct(ff[10],v4158_16); // <2626
  gg[10] = montproduct(gg[10],v4158_16); // <2626
  ff[11] = montproduct(ff[11],v4158_16); // <3998
  gg[11] = montproduct(gg[11],v4158_16); // <3998
  ff[12] = montproduct(ff[12],v4158_16); // <2626
  gg[12] = montproduct(gg[12],v4158_16); // <2626
  ff[13] = montproduct(ff[13],v4158_16); // <2626
  gg[13] = montproduct(gg[13],v4158_16); // <2626
  ff[14] = montproduct(ff[14],v4158_16); // <3084
  gg[14] = montproduct(gg[14],v4158_16); // <3084
  ff[15] = montproduct(ff[15],v4158_16); // <2827
  gg[15] = montproduct(gg[15],v4158_16); // <2827
}
void gf_polymul_128x128_avx2_uvqr_vr (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[16];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+8);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);
  __m256i f_mask = uv_over(f);

  gf_polymul_128x128_avx2_divR(ff,uvqr,f);
  ff[8]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[0]),ff[8]);
  ff[0]=_mm256_andnot_si256(f_mask,ff[0]);
  ff[9]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[1]),ff[9]);
  ff[1]=_mm256_andnot_si256(f_mask,ff[1]);
  ff[10]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[2]),ff[10]);
  ff[2]=_mm256_andnot_si256(f_mask,ff[2]);
  ff[11]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[3]),ff[11]);
  ff[3]=_mm256_andnot_si256(f_mask,ff[3]);
  ff[12]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[4]),ff[12]);
  ff[4]=_mm256_andnot_si256(f_mask,ff[4]);
  ff[13]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[5]),ff[13]);
  ff[5]=_mm256_andnot_si256(f_mask,ff[5]);
  ff[14]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[6]),ff[14]);
  ff[6]=_mm256_andnot_si256(f_mask,ff[6]);
  ff[15]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[7]),ff[15]);
  ff[7]=_mm256_andnot_si256(f_mask,ff[7]);
  gf_polymul_128x128_avx2_divR(t,uvqr+8,g);
  ff[5] = barrett_fake(ff[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610
  ff[10] = barrett_fake(ff[10]); // <2610
  t[10] = barrett_fake(t[10]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);

  ff[8]=_mm256_blendv_epi8(ff[8],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[9]=_mm256_blendv_epi8(ff[9],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[10]=_mm256_blendv_epi8(ff[10],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[11]=_mm256_blendv_epi8(ff[11],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[12]=_mm256_blendv_epi8(ff[12],ff[4],uv_mask);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[13]=_mm256_blendv_epi8(ff[13],ff[5],uv_mask);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[14]=_mm256_blendv_epi8(ff[14],ff[6],uv_mask);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[15]=_mm256_blendv_epi8(ff[15],ff[7],uv_mask);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);

  gf_polymul_128x128_avx2_divR(gg,uvqr+16,f);
  gg[8]=_mm256_blendv_epi8(gg[8],gg[0],f_mask);
  gg[0]=_mm256_andnot_si256(f_mask,gg[0]);
  gg[9]=_mm256_blendv_epi8(gg[9],gg[1],f_mask);
  gg[1]=_mm256_andnot_si256(f_mask,gg[1]);
  gg[10]=_mm256_blendv_epi8(gg[10],gg[2],f_mask);
  gg[2]=_mm256_andnot_si256(f_mask,gg[2]);
  gg[11]=_mm256_blendv_epi8(gg[11],gg[3],f_mask);
  gg[3]=_mm256_andnot_si256(f_mask,gg[3]);
  gg[12]=_mm256_blendv_epi8(gg[12],gg[4],f_mask);
  gg[4]=_mm256_andnot_si256(f_mask,gg[4]);
  gg[13]=_mm256_blendv_epi8(gg[13],gg[5],f_mask);
  gg[5]=_mm256_andnot_si256(f_mask,gg[5]);
  gg[14]=_mm256_blendv_epi8(gg[14],gg[6],f_mask);
  gg[6]=_mm256_andnot_si256(f_mask,gg[6]);
  gg[15]=_mm256_blendv_epi8(gg[15],gg[7],f_mask);
  gg[7]=_mm256_andnot_si256(f_mask,gg[7]);
  gf_polymul_128x128_avx2_divR(t,uvqr+24,g);
  gg[5] = barrett_fake(gg[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610
  gg[10] = barrett_fake(gg[10]); // <2610
  t[10] = barrett_fake(t[10]); // <2610

  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);
  gg[8]=_mm256_add_epi16(gg[8],t[8]);
  gg[9]=_mm256_add_epi16(gg[9],t[9]);
  gg[10]=_mm256_add_epi16(gg[10],t[10]);
  gg[11]=_mm256_add_epi16(gg[11],t[11]);
  gg[12]=_mm256_add_epi16(gg[12],t[12]);
  gg[13]=_mm256_add_epi16(gg[13],t[13]);
  gg[14]=_mm256_add_epi16(gg[14],t[14]);
  gg[15]=_mm256_add_epi16(gg[15],t[15]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  gg[0] = montproduct(gg[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  gg[1] = montproduct(gg[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  gg[2] = montproduct(gg[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  gg[3] = montproduct(gg[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <4031
  gg[4] = montproduct(gg[4],v4158_16); // <4031
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  gg[5] = montproduct(gg[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <4055
  gg[6] = montproduct(gg[6],v4158_16); // <4055
  ff[7] = montproduct(ff[7],v4158_16); // <3809
  gg[7] = montproduct(gg[7],v4158_16); // <3809
  ff[8] = montproduct(ff[8],v4158_16); // <3825
  gg[8] = montproduct(gg[8],v4158_16); // <3825
  ff[9] = montproduct(ff[9],v4158_16); // <4071
  gg[9] = montproduct(gg[9],v4158_16); // <4071
  ff[10] = montproduct(ff[10],v4158_16); // <2626
  gg[10] = montproduct(gg[10],v4158_16); // <2626
  ff[11] = montproduct(ff[11],v4158_16); // <3998
  gg[11] = montproduct(gg[11],v4158_16); // <3998
  ff[12] = montproduct(ff[12],v4158_16); // <2626
  gg[12] = montproduct(gg[12],v4158_16); // <2626
  ff[13] = montproduct(ff[13],v4158_16); // <2626
  gg[13] = montproduct(gg[13],v4158_16); // <2626
  ff[14] = montproduct(ff[14],v4158_16); // <3084
  gg[14] = montproduct(gg[14],v4158_16); // <3084
  ff[15] = montproduct(ff[15],v4158_16); // <2827
  gg[15] = montproduct(gg[15],v4158_16); // <2827

  ff[0] = _mm256_blendv_epi8(ff[0],v01,u_mask&f_mask);
}
void gf_polymul_128x128_avx2_uvqr_fg_x (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[16];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+8);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);

  gf_polymul_128x128_avx2_divR(ff,uvqr,f);
  gf_polymul_128x128_avx2_divR(t,uvqr+8,g);
  ff[5] = barrett_fake(ff[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610
  ff[10] = barrett_fake(ff[10]); // <2610
  t[10] = barrett_fake(t[10]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);

  ff[8]=_mm256_blendv_epi8(ff[8],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[9]=_mm256_blendv_epi8(ff[9],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[10]=_mm256_blendv_epi8(ff[10],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[11]=_mm256_blendv_epi8(ff[11],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[12]=_mm256_blendv_epi8(ff[12],ff[4],uv_mask);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[13]=_mm256_blendv_epi8(ff[13],ff[5],uv_mask);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[14]=_mm256_blendv_epi8(ff[14],ff[6],uv_mask);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[15]=_mm256_blendv_epi8(ff[15],ff[7],uv_mask);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);


  ff[0] = montproduct(ff[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <4031
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <4055
  ff[7] = montproduct(ff[7],v4158_16); // <3809
  ff[8] = montproduct(ff[8],v4158_16); // <3825
  ff[9] = montproduct(ff[9],v4158_16); // <4071
  ff[10] = montproduct(ff[10],v4158_16); // <2626
  ff[11] = montproduct(ff[11],v4158_16); // <3998
  ff[12] = montproduct(ff[12],v4158_16); // <2626
  ff[13] = montproduct(ff[13],v4158_16); // <2626
  ff[14] = montproduct(ff[14],v4158_16); // <3084
  ff[15] = montproduct(ff[15],v4158_16); // <2827
}
void gf_polymul_128x128_avx2_uvqr_vr_x (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[16];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+8);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);
  __m256i f_mask = uv_over(f);

  gf_polymul_128x128_avx2_divR(ff,uvqr,f);
  ff[8]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[0]),ff[8]);
  ff[0]=_mm256_andnot_si256(f_mask,ff[0]);
  ff[9]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[1]),ff[9]);
  ff[1]=_mm256_andnot_si256(f_mask,ff[1]);
  ff[10]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[2]),ff[10]);
  ff[2]=_mm256_andnot_si256(f_mask,ff[2]);
  ff[11]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[3]),ff[11]);
  ff[3]=_mm256_andnot_si256(f_mask,ff[3]);
  ff[12]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[4]),ff[12]);
  ff[4]=_mm256_andnot_si256(f_mask,ff[4]);
  ff[13]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[5]),ff[13]);
  ff[5]=_mm256_andnot_si256(f_mask,ff[5]);
  ff[14]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[6]),ff[14]);
  ff[6]=_mm256_andnot_si256(f_mask,ff[6]);
  ff[15]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[7]),ff[15]);
  ff[7]=_mm256_andnot_si256(f_mask,ff[7]);
  gf_polymul_128x128_avx2_divR(t,uvqr+8,g);
  ff[5] = barrett_fake(ff[5]); // <2610
  t[5] = barrett_fake(t[5]); // <2610
  ff[10] = barrett_fake(ff[10]); // <2610
  t[10] = barrett_fake(t[10]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);

  ff[8]=_mm256_blendv_epi8(ff[8],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[9]=_mm256_blendv_epi8(ff[9],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[10]=_mm256_blendv_epi8(ff[10],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[11]=_mm256_blendv_epi8(ff[11],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[12]=_mm256_blendv_epi8(ff[12],ff[4],uv_mask);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[13]=_mm256_blendv_epi8(ff[13],ff[5],uv_mask);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[14]=_mm256_blendv_epi8(ff[14],ff[6],uv_mask);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[15]=_mm256_blendv_epi8(ff[15],ff[7],uv_mask);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);


  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);
  gg[8]=_mm256_add_epi16(gg[8],t[8]);
  gg[9]=_mm256_add_epi16(gg[9],t[9]);
  gg[10]=_mm256_add_epi16(gg[10],t[10]);
  gg[11]=_mm256_add_epi16(gg[11],t[11]);
  gg[12]=_mm256_add_epi16(gg[12],t[12]);
  gg[13]=_mm256_add_epi16(gg[13],t[13]);
  gg[14]=_mm256_add_epi16(gg[14],t[14]);
  gg[15]=_mm256_add_epi16(gg[15],t[15]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <4031
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <4055
  ff[7] = montproduct(ff[7],v4158_16); // <3809
  ff[8] = montproduct(ff[8],v4158_16); // <3825
  ff[9] = montproduct(ff[9],v4158_16); // <4071
  ff[10] = montproduct(ff[10],v4158_16); // <2626
  ff[11] = montproduct(ff[11],v4158_16); // <3998
  ff[12] = montproduct(ff[12],v4158_16); // <2626
  ff[13] = montproduct(ff[13],v4158_16); // <2626
  ff[14] = montproduct(ff[14],v4158_16); // <3084
  ff[15] = montproduct(ff[15],v4158_16); // <2827

  ff[0] = _mm256_or_si256(_mm256_and_si256(_mm256_and_si256(u_mask,f_mask),v01),ff[0]);
}
void gf_polymul_256x256_avx2_divR (__m256i *h, __m256i *f, __m256i *g){
  __m256i ff[65], gg[65], hh[130];
  __m256i t[16];

  ff[0]=_mm256_add_epi16(f[0],f[8]); // <5762
  gg[0]=_mm256_add_epi16(g[0],g[8]); // <5762
  ff[1]=_mm256_add_epi16(f[1],f[9]); // <5762
  gg[1]=_mm256_add_epi16(g[1],g[9]); // <5762
  ff[2]=_mm256_add_epi16(f[2],f[10]); // <5762
  gg[2]=_mm256_add_epi16(g[2],g[10]); // <5762
  ff[3]=_mm256_add_epi16(f[3],f[11]); // <5762
  gg[3]=_mm256_add_epi16(g[3],g[11]); // <5762
  ff[4]=_mm256_add_epi16(f[4],f[12]); // <5762
  gg[4]=_mm256_add_epi16(g[4],g[12]); // <5762
  ff[5]=_mm256_add_epi16(f[5],f[13]); // <5762
  gg[5]=_mm256_add_epi16(g[5],g[13]); // <5762
  ff[6]=_mm256_add_epi16(f[6],f[14]); // <5762
  gg[6]=_mm256_add_epi16(g[6],g[14]); // <5762
  ff[7]=_mm256_add_epi16(f[7],f[15]); // <5762
  gg[7]=_mm256_add_epi16(g[7],g[15]); // <5762
  ff[8]=_mm256_add_epi16(f[0],f[4]); // <5762
  gg[8]=_mm256_add_epi16(g[0],g[4]); // <5762
  ff[9]=_mm256_add_epi16(f[1],f[5]); // <5762
  gg[9]=_mm256_add_epi16(g[1],g[5]); // <5762
  ff[10]=_mm256_add_epi16(f[2],f[6]); // <5762
  gg[10]=_mm256_add_epi16(g[2],g[6]); // <5762
  ff[11]=_mm256_add_epi16(f[3],f[7]); // <5762
  gg[11]=_mm256_add_epi16(g[3],g[7]); // <5762
  ff[12]=_mm256_add_epi16(f[8],f[12]); // <5762
  gg[12]=_mm256_add_epi16(g[8],g[12]); // <5762
  ff[13]=_mm256_add_epi16(f[9],f[13]); // <5762
  gg[13]=_mm256_add_epi16(g[9],g[13]); // <5762
  ff[14]=_mm256_add_epi16(f[10],f[14]); // <5762
  gg[14]=_mm256_add_epi16(g[10],g[14]); // <5762
  ff[15]=_mm256_add_epi16(f[11],f[15]); // <5762
  gg[15]=_mm256_add_epi16(g[11],g[15]); // <5762
  ff[16]=_mm256_add_epi16(ff[0],ff[4]); // <11524
  gg[16]=_mm256_add_epi16(gg[0],gg[4]); // <11524
  ff[17]=_mm256_add_epi16(ff[1],ff[5]); // <11524
  gg[17]=_mm256_add_epi16(gg[1],gg[5]); // <11524
  ff[18]=_mm256_add_epi16(ff[2],ff[6]); // <11524
  gg[18]=_mm256_add_epi16(gg[2],gg[6]); // <11524
  ff[19]=_mm256_add_epi16(ff[3],ff[7]); // <11524
  gg[19]=_mm256_add_epi16(gg[3],gg[7]); // <11524
  ff[20]=_mm256_add_epi16(f[0],f[2]); // <5762
  gg[20]=_mm256_add_epi16(g[0],g[2]); // <5762
  ff[21]=_mm256_add_epi16(f[1],f[3]); // <5762
  gg[21]=_mm256_add_epi16(g[1],g[3]); // <5762
  ff[22]=_mm256_add_epi16(f[4],f[6]); // <5762
  gg[22]=_mm256_add_epi16(g[4],g[6]); // <5762
  ff[23]=_mm256_add_epi16(f[5],f[7]); // <5762
  gg[23]=_mm256_add_epi16(g[5],g[7]); // <5762
  ff[24]=_mm256_add_epi16(f[8],f[10]); // <5762
  gg[24]=_mm256_add_epi16(g[8],g[10]); // <5762
  ff[25]=_mm256_add_epi16(f[9],f[11]); // <5762
  gg[25]=_mm256_add_epi16(g[9],g[11]); // <5762
  ff[26]=_mm256_add_epi16(f[12],f[14]); // <5762
  gg[26]=_mm256_add_epi16(g[12],g[14]); // <5762
  ff[27]=_mm256_add_epi16(f[13],f[15]); // <5762
  gg[27]=_mm256_add_epi16(g[13],g[15]); // <5762
  ff[28]=_mm256_add_epi16(ff[0],ff[2]); // <11524
  gg[28]=_mm256_add_epi16(gg[0],gg[2]); // <11524
  ff[29]=_mm256_add_epi16(ff[1],ff[3]); // <11524
  gg[29]=_mm256_add_epi16(gg[1],gg[3]); // <11524
  ff[30]=_mm256_add_epi16(ff[4],ff[6]); // <11524
  gg[30]=_mm256_add_epi16(gg[4],gg[6]); // <11524
  ff[31]=_mm256_add_epi16(ff[5],ff[7]); // <11524
  gg[31]=_mm256_add_epi16(gg[5],gg[7]); // <11524
  ff[32]=_mm256_add_epi16(ff[8],ff[10]); // <11524
  gg[32]=_mm256_add_epi16(gg[8],gg[10]); // <11524
  ff[33]=_mm256_add_epi16(ff[9],ff[11]); // <11524
  gg[33]=_mm256_add_epi16(gg[9],gg[11]); // <11524
  ff[34]=_mm256_add_epi16(ff[12],ff[14]); // <11524
  gg[34]=_mm256_add_epi16(gg[12],gg[14]); // <11524
  ff[35]=_mm256_add_epi16(ff[13],ff[15]); // <11524
  gg[35]=_mm256_add_epi16(gg[13],gg[15]); // <11524
  ff[36]=_mm256_add_epi16(ff[16],ff[18]); // <23048
  gg[36]=_mm256_add_epi16(gg[16],gg[18]); // <23048
  ff[37]=_mm256_add_epi16(ff[17],ff[19]); // <23048
  gg[37]=_mm256_add_epi16(gg[17],gg[19]); // <23048

  ff[16] = barrett_fake(ff[16]); // <2430
  gg[16] = barrett_fake(gg[16]); // <2430
  ff[17] = barrett_fake(ff[17]); // <2340
  gg[17] = barrett_fake(gg[17]); // <2340
  ff[18] = barrett_fake(ff[18]); // <2430
  gg[18] = barrett_fake(gg[18]); // <2430
  ff[19] = barrett_fake(ff[19]); // <2340
  gg[19] = barrett_fake(gg[19]); // <2340
  ff[28] = barrett_fake(ff[28]); // <2430
  gg[28] = barrett_fake(gg[28]); // <2430
  ff[29] = barrett_fake(ff[29]); // <2340
  gg[29] = barrett_fake(gg[29]); // <2340
  ff[30] = barrett_fake(ff[30]); // <2430
  gg[30] = barrett_fake(gg[30]); // <2430
  ff[31] = barrett_fake(ff[31]); // <2340
  gg[31] = barrett_fake(gg[31]); // <2340
  ff[32] = barrett_fake(ff[32]); // <2430
  gg[32] = barrett_fake(gg[32]); // <2430
  ff[33] = barrett_fake(ff[33]); // <2340
  gg[33] = barrett_fake(gg[33]); // <2340
  ff[34] = barrett_fake(ff[34]); // <2430
  gg[34] = barrett_fake(gg[34]); // <2430
  ff[35] = barrett_fake(ff[35]); // <2340
  gg[35] = barrett_fake(gg[35]); // <2340
  ff[36] = barrett_fake(ff[36]); // <2701
  gg[36] = barrett_fake(gg[36]); // <2701
  ff[37] = barrett_fake(ff[37]); // <2340
  gg[37] = barrett_fake(gg[37]); // <2340
  gf_polymul_32x32_avx2_divR((h + 0),(g + 0),(f + 0));
  // h[0] <= 4321 h[1] <= 6347 h[2] <= 6221 h[3] <= 4194
  gf_polymul_32x32_avx2_divR((h + 4),(g + 2),(f + 2));
  // h[4] <= 4321 h[5] <= 6347 h[6] <= 6221 h[7] <= 4194
  gf_polymul_32x32_avx2_divR((h + 8),(g + 4),(f + 4));
  // h[8] <= 4321 h[9] <= 6347 h[10] <= 6221 h[11] <= 4194
  gf_polymul_32x32_avx2_divR((h + 12),(g + 6),(f + 6));
  // h[12] <= 4321 h[13] <= 6347 h[14] <= 6221 h[15] <= 4194
  gf_polymul_32x32_avx2_divR((h + 16),(g + 8),(f + 8));
  // h[16] <= 4321 h[17] <= 6347 h[18] <= 6221 h[19] <= 4194
  gf_polymul_32x32_avx2_divR((h + 20),(g + 10),(f + 10));
  // h[20] <= 4321 h[21] <= 6347 h[22] <= 6221 h[23] <= 4194
  gf_polymul_32x32_avx2_divR((h + 24),(g + 12),(f + 12));
  // h[24] <= 4321 h[25] <= 6347 h[26] <= 6221 h[27] <= 4194
  gf_polymul_32x32_avx2_divR((h + 28),(g + 14),(f + 14));
  // h[28] <= 4321 h[29] <= 6347 h[30] <= 6221 h[31] <= 4194
  gf_polymul_32x32_avx2_divR((hh + 0),(gg + 0),(ff + 0));
  // hh[0] <= 10400 hh[1] <= 18506 hh[2] <= 17999 hh[3] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 4),(gg + 2),(ff + 2));
  // hh[4] <= 10400 hh[5] <= 18506 hh[6] <= 17999 hh[7] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 8),(gg + 4),(ff + 4));
  // hh[8] <= 10400 hh[9] <= 18506 hh[10] <= 17999 hh[11] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 12),(gg + 6),(ff + 6));
  // hh[12] <= 10400 hh[13] <= 18506 hh[14] <= 17999 hh[15] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 16),(gg + 8),(ff + 8));
  // hh[16] <= 10400 hh[17] <= 18506 hh[18] <= 17999 hh[19] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 20),(gg + 10),(ff + 10));
  // hh[20] <= 10400 hh[21] <= 18506 hh[22] <= 17999 hh[23] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 24),(gg + 12),(ff + 12));
  // hh[24] <= 10400 hh[25] <= 18506 hh[26] <= 17999 hh[27] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 28),(gg + 14),(ff + 14));
  // hh[28] <= 10400 hh[29] <= 18506 hh[30] <= 17999 hh[31] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 32),(gg + 16),(ff + 16));
  // hh[32] <= 3736 hh[33] <= 5178 hh[34] <= 5088 hh[35] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 36),(gg + 18),(ff + 18));
  // hh[36] <= 3736 hh[37] <= 5178 hh[38] <= 5088 hh[39] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 40),(gg + 20),(ff + 20));
  // hh[40] <= 10400 hh[41] <= 18506 hh[42] <= 17999 hh[43] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 44),(gg + 22),(ff + 22));
  // hh[44] <= 10400 hh[45] <= 18506 hh[46] <= 17999 hh[47] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 48),(gg + 24),(ff + 24));
  // hh[48] <= 10400 hh[49] <= 18506 hh[50] <= 17999 hh[51] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 52),(gg + 26),(ff + 26));
  // hh[52] <= 10400 hh[53] <= 18506 hh[54] <= 17999 hh[55] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 56),(gg + 28),(ff + 28));
  // hh[56] <= 3736 hh[57] <= 5178 hh[58] <= 5088 hh[59] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 60),(gg + 30),(ff + 30));
  // hh[60] <= 3736 hh[61] <= 5178 hh[62] <= 5088 hh[63] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 64),(gg + 32),(ff + 32));
  // hh[64] <= 3736 hh[65] <= 5178 hh[66] <= 5088 hh[67] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 68),(gg + 34),(ff + 34));
  // hh[68] <= 3736 hh[69] <= 5178 hh[70] <= 5088 hh[71] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 72),(gg + 36),(ff + 36));
  // hh[72] <= 4076 hh[73] <= 5857 hh[74] <= 5745 hh[75] <= 3964

  hh[0] = barrett_fake(hh[0]); // <2430
  hh[1] = barrett_fake(hh[1]); // <2610
  hh[2] = barrett_fake(hh[2]); // <2610
  hh[3] = barrett_fake(hh[3]); // <2430
  hh[4] = barrett_fake(hh[4]); // <2430
  hh[5] = barrett_fake(hh[5]); // <2610
  hh[6] = barrett_fake(hh[6]); // <2610
  hh[7] = barrett_fake(hh[7]); // <2430
  hh[8] = barrett_fake(hh[8]); // <2430
  hh[9] = barrett_fake(hh[9]); // <2610
  hh[10] = barrett_fake(hh[10]); // <2610
  hh[11] = barrett_fake(hh[11]); // <2430
  hh[12] = barrett_fake(hh[12]); // <2430
  hh[13] = barrett_fake(hh[13]); // <2610
  hh[14] = barrett_fake(hh[14]); // <2610
  hh[15] = barrett_fake(hh[15]); // <2430
  hh[16] = barrett_fake(hh[16]); // <2430
  hh[17] = barrett_fake(hh[17]); // <2610
  hh[18] = barrett_fake(hh[18]); // <2610
  hh[19] = barrett_fake(hh[19]); // <2430
  hh[20] = barrett_fake(hh[20]); // <2430
  hh[21] = barrett_fake(hh[21]); // <2610
  hh[22] = barrett_fake(hh[22]); // <2610
  hh[23] = barrett_fake(hh[23]); // <2430
  hh[24] = barrett_fake(hh[24]); // <2430
  hh[25] = barrett_fake(hh[25]); // <2610
  hh[26] = barrett_fake(hh[26]); // <2610
  hh[27] = barrett_fake(hh[27]); // <2430
  hh[28] = barrett_fake(hh[28]); // <2430
  hh[29] = barrett_fake(hh[29]); // <2610
  hh[30] = barrett_fake(hh[30]); // <2610
  hh[31] = barrett_fake(hh[31]); // <2430
  hh[40] = barrett_fake(hh[40]); // <2430
  hh[41] = barrett_fake(hh[41]); // <2610
  hh[42] = barrett_fake(hh[42]); // <2610
  hh[43] = barrett_fake(hh[43]); // <2430
  hh[44] = barrett_fake(hh[44]); // <2430
  hh[45] = barrett_fake(hh[45]); // <2610
  hh[46] = barrett_fake(hh[46]); // <2610
  hh[47] = barrett_fake(hh[47]); // <2430
  hh[48] = barrett_fake(hh[48]); // <2430
  hh[49] = barrett_fake(hh[49]); // <2610
  hh[50] = barrett_fake(hh[50]); // <2610
  hh[51] = barrett_fake(hh[51]); // <2430
  hh[52] = barrett_fake(hh[52]); // <2430
  hh[53] = barrett_fake(hh[53]); // <2610
  hh[54] = barrett_fake(hh[54]); // <2610
  hh[55] = barrett_fake(hh[55]); // <2430
  t[0] = _mm256_sub_epi16(h[2],h[4]); // <10542
  t[1] = _mm256_sub_epi16(h[3],h[5]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[6]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[7]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[0]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[1]); // <16888
  h[4] = _mm256_sub_epi16(hh[42],t[2]); // <19373
  h[5] = _mm256_sub_epi16(hh[43],t[3]); // <17165
  h[2] = _mm256_add_epi16(hh[40],t[0]); // <17293
  h[3] = _mm256_add_epi16(hh[41],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[10],h[12]); // <10542
  t[1] = _mm256_sub_epi16(h[11],h[13]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[14]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[15]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[8]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[9]); // <16888
  h[12] = _mm256_sub_epi16(hh[46],t[2]); // <19373
  h[13] = _mm256_sub_epi16(hh[47],t[3]); // <17165
  h[10] = _mm256_add_epi16(hh[44],t[0]); // <17293
  h[11] = _mm256_add_epi16(hh[45],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[18],h[20]); // <10542
  t[1] = _mm256_sub_epi16(h[19],h[21]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[22]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[23]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[16]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[17]); // <16888
  h[20] = _mm256_sub_epi16(hh[50],t[2]); // <19373
  h[21] = _mm256_sub_epi16(hh[51],t[3]); // <17165
  h[18] = _mm256_add_epi16(hh[48],t[0]); // <17293
  h[19] = _mm256_add_epi16(hh[49],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[26],h[28]); // <10542
  t[1] = _mm256_sub_epi16(h[27],h[29]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[30]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[31]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[24]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[25]); // <16888
  h[28] = _mm256_sub_epi16(hh[54],t[2]); // <19373
  h[29] = _mm256_sub_epi16(hh[55],t[3]); // <17165
  h[26] = _mm256_add_epi16(hh[52],t[0]); // <17293
  h[27] = _mm256_add_epi16(hh[53],t[1]); // <19498
  t[0] = _mm256_sub_epi16(hh[2],hh[4]); // <5040
  t[1] = _mm256_sub_epi16(hh[3],hh[5]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[6]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[7]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[0]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[1]); // <7650
  hh[4] = _mm256_sub_epi16(hh[58],t[2]); // <12738
  hh[5] = _mm256_sub_epi16(hh[59],t[3]); // <11116
  hh[2] = _mm256_add_epi16(hh[56],t[0]); // <11206
  hh[3] = _mm256_add_epi16(hh[57],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[10],hh[12]); // <5040
  t[1] = _mm256_sub_epi16(hh[11],hh[13]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[14]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[15]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[8]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[9]); // <7650
  hh[12] = _mm256_sub_epi16(hh[62],t[2]); // <12738
  hh[13] = _mm256_sub_epi16(hh[63],t[3]); // <11116
  hh[10] = _mm256_add_epi16(hh[60],t[0]); // <11206
  hh[11] = _mm256_add_epi16(hh[61],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[18],hh[20]); // <5040
  t[1] = _mm256_sub_epi16(hh[19],hh[21]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[22]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[23]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[16]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[17]); // <7650
  hh[20] = _mm256_sub_epi16(hh[66],t[2]); // <12738
  hh[21] = _mm256_sub_epi16(hh[67],t[3]); // <11116
  hh[18] = _mm256_add_epi16(hh[64],t[0]); // <11206
  hh[19] = _mm256_add_epi16(hh[65],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[26],hh[28]); // <5040
  t[1] = _mm256_sub_epi16(hh[27],hh[29]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[30]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[31]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[24]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[25]); // <7650
  hh[28] = _mm256_sub_epi16(hh[70],t[2]); // <12738
  hh[29] = _mm256_sub_epi16(hh[71],t[3]); // <11116
  hh[26] = _mm256_add_epi16(hh[68],t[0]); // <11206
  hh[27] = _mm256_add_epi16(hh[69],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[34],hh[36]); // <8824
  t[1] = _mm256_sub_epi16(hh[35],hh[37]); // <8824
  t[2] = _mm256_add_epi16(t[0],hh[38]); // <13912
  t[3] = _mm256_add_epi16(t[1],hh[39]); // <12470
  t[0] = _mm256_sub_epi16(t[0],hh[32]); // <12560
  t[1] = _mm256_sub_epi16(t[1],hh[33]); // <14002
  hh[36] = _mm256_sub_epi16(hh[74],t[2]); // <19657
  hh[37] = _mm256_sub_epi16(hh[75],t[3]); // <16434
  hh[34] = _mm256_add_epi16(hh[72],t[0]); // <16636
  hh[35] = _mm256_add_epi16(hh[73],t[1]); // <19859

  h[2] = barrett_fake(h[2]); // <2610
  h[3] = barrett_fake(h[3]); // <2610
  h[4] = barrett_fake(h[4]); // <2610
  h[5] = barrett_fake(h[5]); // <2610
  h[10] = barrett_fake(h[10]); // <2610
  h[11] = barrett_fake(h[11]); // <2610
  h[12] = barrett_fake(h[12]); // <2610
  h[13] = barrett_fake(h[13]); // <2610
  h[18] = barrett_fake(h[18]); // <2610
  h[19] = barrett_fake(h[19]); // <2610
  h[20] = barrett_fake(h[20]); // <2610
  h[21] = barrett_fake(h[21]); // <2610
  h[26] = barrett_fake(h[26]); // <2610
  h[27] = barrett_fake(h[27]); // <2610
  h[28] = barrett_fake(h[28]); // <2610
  h[29] = barrett_fake(h[29]); // <2610
  hh[2] = barrett_fake(hh[2]); // <2430
  hh[3] = barrett_fake(hh[3]); // <2520
  hh[4] = barrett_fake(hh[4]); // <2520
  hh[5] = barrett_fake(hh[5]); // <2430
  hh[10] = barrett_fake(hh[10]); // <2430
  hh[11] = barrett_fake(hh[11]); // <2520
  hh[12] = barrett_fake(hh[12]); // <2520
  hh[13] = barrett_fake(hh[13]); // <2430
  hh[18] = barrett_fake(hh[18]); // <2430
  hh[19] = barrett_fake(hh[19]); // <2520
  hh[20] = barrett_fake(hh[20]); // <2520
  hh[21] = barrett_fake(hh[21]); // <2430
  hh[26] = barrett_fake(hh[26]); // <2430
  hh[27] = barrett_fake(hh[27]); // <2520
  hh[28] = barrett_fake(hh[28]); // <2520
  hh[29] = barrett_fake(hh[29]); // <2430
  hh[34] = barrett_fake(hh[34]); // <2610
  hh[35] = barrett_fake(hh[35]); // <2610
  hh[36] = barrett_fake(hh[36]); // <2610
  hh[37] = barrett_fake(hh[37]); // <2610
  t[0] = _mm256_sub_epi16(h[4],h[8]); // <6931
  t[1] = _mm256_sub_epi16(h[5],h[9]); // <8957
  t[2] = _mm256_sub_epi16(h[6],h[10]); // <8831
  t[3] = _mm256_sub_epi16(h[7],h[11]); // <6804
  t[4] = _mm256_add_epi16(t[0],h[12]); // <9541
  t[5] = _mm256_add_epi16(t[1],h[13]); // <11567
  t[6] = _mm256_add_epi16(t[2],h[14]); // <15052
  t[7] = _mm256_add_epi16(t[3],h[15]); // <10998
  t[0] = _mm256_sub_epi16(t[0],h[0]); // <11252
  t[1] = _mm256_sub_epi16(t[1],h[1]); // <15304
  t[2] = _mm256_sub_epi16(t[2],h[2]); // <11441
  t[3] = _mm256_sub_epi16(t[3],h[3]); // <9414
  h[8] = _mm256_sub_epi16(hh[20],t[4]); // <12061
  h[9] = _mm256_sub_epi16(hh[21],t[5]); // <13997
  h[10] = _mm256_sub_epi16(hh[22],t[6]); // <17662
  h[11] = _mm256_sub_epi16(hh[23],t[7]); // <13428
  h[4] = _mm256_add_epi16(hh[16],t[0]); // <13682
  h[5] = _mm256_add_epi16(hh[17],t[1]); // <17914
  h[6] = _mm256_add_epi16(hh[18],t[2]); // <13871
  h[7] = _mm256_add_epi16(hh[19],t[3]); // <11934
  t[0] = _mm256_sub_epi16(h[20],h[24]); // <6931
  t[1] = _mm256_sub_epi16(h[21],h[25]); // <8957
  t[2] = _mm256_sub_epi16(h[22],h[26]); // <8831
  t[3] = _mm256_sub_epi16(h[23],h[27]); // <6804
  t[4] = _mm256_add_epi16(t[0],h[28]); // <9541
  t[5] = _mm256_add_epi16(t[1],h[29]); // <11567
  t[6] = _mm256_add_epi16(t[2],h[30]); // <15052
  t[7] = _mm256_add_epi16(t[3],h[31]); // <10998
  t[0] = _mm256_sub_epi16(t[0],h[16]); // <11252
  t[1] = _mm256_sub_epi16(t[1],h[17]); // <15304
  t[2] = _mm256_sub_epi16(t[2],h[18]); // <11441
  t[3] = _mm256_sub_epi16(t[3],h[19]); // <9414
  h[24] = _mm256_sub_epi16(hh[28],t[4]); // <12061
  h[25] = _mm256_sub_epi16(hh[29],t[5]); // <13997
  h[26] = _mm256_sub_epi16(hh[30],t[6]); // <17662
  h[27] = _mm256_sub_epi16(hh[31],t[7]); // <13428
  h[20] = _mm256_add_epi16(hh[24],t[0]); // <13682
  h[21] = _mm256_add_epi16(hh[25],t[1]); // <17914
  h[22] = _mm256_add_epi16(hh[26],t[2]); // <13871
  h[23] = _mm256_add_epi16(hh[27],t[3]); // <11934
  t[0] = _mm256_sub_epi16(hh[4],hh[8]); // <4950
  t[1] = _mm256_sub_epi16(hh[5],hh[9]); // <5040
  t[2] = _mm256_sub_epi16(hh[6],hh[10]); // <5040
  t[3] = _mm256_sub_epi16(hh[7],hh[11]); // <4950
  t[4] = _mm256_add_epi16(t[0],hh[12]); // <7470
  t[5] = _mm256_add_epi16(t[1],hh[13]); // <7470
  t[6] = _mm256_add_epi16(t[2],hh[14]); // <7650
  t[7] = _mm256_add_epi16(t[3],hh[15]); // <7380
  t[0] = _mm256_sub_epi16(t[0],hh[0]); // <7380
  t[1] = _mm256_sub_epi16(t[1],hh[1]); // <7650
  t[2] = _mm256_sub_epi16(t[2],hh[2]); // <7470
  t[3] = _mm256_sub_epi16(t[3],hh[3]); // <7470
  hh[8] = _mm256_sub_epi16(hh[36],t[4]); // <10080
  hh[9] = _mm256_sub_epi16(hh[37],t[5]); // <10080
  hh[10] = _mm256_sub_epi16(hh[38],t[6]); // <12738
  hh[11] = _mm256_sub_epi16(hh[39],t[7]); // <11026
  hh[4] = _mm256_add_epi16(hh[32],t[0]); // <11116
  hh[5] = _mm256_add_epi16(hh[33],t[1]); // <12828
  hh[6] = _mm256_add_epi16(hh[34],t[2]); // <10080
  hh[7] = _mm256_add_epi16(hh[35],t[3]); // <10080

  h[4] = barrett_fake(h[4]); // <2520
  h[5] = barrett_fake(h[5]); // <2610
  h[6] = barrett_fake(h[6]); // <2520
  h[7] = barrett_fake(h[7]); // <2520
  h[8] = barrett_fake(h[8]); // <2520
  h[9] = barrett_fake(h[9]); // <2520
  h[10] = barrett_fake(h[10]); // <2610
  h[11] = barrett_fake(h[11]); // <2520
  h[20] = barrett_fake(h[20]); // <2520
  h[21] = barrett_fake(h[21]); // <2610
  h[22] = barrett_fake(h[22]); // <2520
  h[23] = barrett_fake(h[23]); // <2520
  h[24] = barrett_fake(h[24]); // <2520
  h[25] = barrett_fake(h[25]); // <2520
  h[26] = barrett_fake(h[26]); // <2610
  h[27] = barrett_fake(h[27]); // <2520
  hh[4] = barrett_fake(hh[4]); // <2430
  hh[5] = barrett_fake(hh[5]); // <2520
  hh[6] = barrett_fake(hh[6]); // <2430
  hh[7] = barrett_fake(hh[7]); // <2430
  hh[8] = barrett_fake(hh[8]); // <2430
  hh[9] = barrett_fake(hh[9]); // <2430
  hh[10] = barrett_fake(hh[10]); // <2520
  hh[11] = barrett_fake(hh[11]); // <2430
  t[0] = _mm256_sub_epi16(h[8],h[16]); // <6841
  t[1] = _mm256_sub_epi16(h[9],h[17]); // <8867
  t[2] = _mm256_sub_epi16(h[10],h[18]); // <5220
  t[3] = _mm256_sub_epi16(h[11],h[19]); // <5130
  t[4] = _mm256_sub_epi16(h[12],h[20]); // <5130
  t[5] = _mm256_sub_epi16(h[13],h[21]); // <5220
  t[6] = _mm256_sub_epi16(h[14],h[22]); // <8741
  t[7] = _mm256_sub_epi16(h[15],h[23]); // <6714
  t[8] = _mm256_add_epi16(t[0],h[24]); // <9361
  t[9] = _mm256_add_epi16(t[1],h[25]); // <11387
  t[10] = _mm256_add_epi16(t[2],h[26]); // <7830
  t[11] = _mm256_add_epi16(t[3],h[27]); // <7650
  t[12] = _mm256_add_epi16(t[4],h[28]); // <7740
  t[13] = _mm256_add_epi16(t[5],h[29]); // <7830
  t[14] = _mm256_add_epi16(t[6],h[30]); // <14962
  t[15] = _mm256_add_epi16(t[7],h[31]); // <10908
  t[0] = _mm256_sub_epi16(t[0],h[0]); // <11162
  t[1] = _mm256_sub_epi16(t[1],h[1]); // <15214
  t[2] = _mm256_sub_epi16(t[2],h[2]); // <7830
  t[3] = _mm256_sub_epi16(t[3],h[3]); // <7740
  t[4] = _mm256_sub_epi16(t[4],h[4]); // <7650
  t[5] = _mm256_sub_epi16(t[5],h[5]); // <7830
  t[6] = _mm256_sub_epi16(t[6],h[6]); // <11261
  t[7] = _mm256_sub_epi16(t[7],h[7]); // <9234
  h[16] = _mm256_sub_epi16(hh[8],t[8]); // <11791
  h[17] = _mm256_sub_epi16(hh[9],t[9]); // <13817
  h[18] = _mm256_sub_epi16(hh[10],t[10]); // <10350
  h[19] = _mm256_sub_epi16(hh[11],t[11]); // <10080
  h[20] = _mm256_sub_epi16(hh[12],t[12]); // <10260
  h[21] = _mm256_sub_epi16(hh[13],t[13]); // <10260
  h[22] = _mm256_sub_epi16(hh[14],t[14]); // <17572
  h[23] = _mm256_sub_epi16(hh[15],t[15]); // <13338
  h[8] = _mm256_add_epi16(hh[0],t[0]); // <13592
  h[9] = _mm256_add_epi16(hh[1],t[1]); // <17824
  h[10] = _mm256_add_epi16(hh[2],t[2]); // <10260
  h[11] = _mm256_add_epi16(hh[3],t[3]); // <10260
  h[12] = _mm256_add_epi16(hh[4],t[4]); // <10080
  h[13] = _mm256_add_epi16(hh[5],t[5]); // <10350
  h[14] = _mm256_add_epi16(hh[6],t[6]); // <13691
  h[15] = _mm256_add_epi16(hh[7],t[7]); // <11664

}
void gf_polymul_256x256_avx2 (__m256i *h, __m256i *f, __m256i *g){
  gf_polymul_256x256_avx2_divR(h,f,g);
  h[0]=montproduct(h[0],v4158_16); // <2340
  h[1]=montproduct(h[1],v4158_16); // <2340
  h[2]=montproduct(h[2],v4158_16); // <2340
  h[3]=montproduct(h[3],v4158_16); // <2340
  h[4]=montproduct(h[4],v4158_16); // <2340
  h[5]=montproduct(h[5],v4158_16); // <2340
  h[6]=montproduct(h[6],v4158_16); // <2340
  h[7]=montproduct(h[7],v4158_16); // <2340
  h[8]=montproduct(h[8],v4158_16); // <2520
  h[9]=montproduct(h[9],v4158_16); // <2610
  h[10]=montproduct(h[10],v4158_16); // <2430
  h[11]=montproduct(h[11],v4158_16); // <2430
  h[12]=montproduct(h[12],v4158_16); // <2430
  h[13]=montproduct(h[13],v4158_16); // <2430
  h[14]=montproduct(h[14],v4158_16); // <2520
  h[15]=montproduct(h[15],v4158_16); // <2430
  h[16]=montproduct(h[16],v4158_16); // <2520
  h[17]=montproduct(h[17],v4158_16); // <2520
  h[18]=montproduct(h[18],v4158_16); // <2430
  h[19]=montproduct(h[19],v4158_16); // <2430
  h[20]=montproduct(h[20],v4158_16); // <2430
  h[21]=montproduct(h[21],v4158_16); // <2430
  h[22]=montproduct(h[22],v4158_16); // <2610
  h[23]=montproduct(h[23],v4158_16); // <2520
  h[24]=montproduct(h[24],v4158_16); // <2340
  h[25]=montproduct(h[25],v4158_16); // <2340
  h[26]=montproduct(h[26],v4158_16); // <2340
  h[27]=montproduct(h[27],v4158_16); // <2340
  h[28]=montproduct(h[28],v4158_16); // <2340
  h[29]=montproduct(h[29],v4158_16); // <2340
  h[30]=montproduct(h[30],v4158_16); // <2340
  h[31]=montproduct(h[31],v4158_16); // <2340
}
void gf_polymul_256x256_avx2_uvqr_fg (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[32];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+16);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);

  gf_polymul_256x256_avx2_divR(ff,uvqr,f);
  gf_polymul_256x256_avx2_divR(t,uvqr+16,g);
  ff[9] = barrett_fake(ff[9]); // <2610
  t[9] = barrett_fake(t[9]); // <2610
  ff[22] = barrett_fake(ff[22]); // <2610
  t[22] = barrett_fake(t[22]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);
  ff[16]=_mm256_add_epi16(ff[16],t[16]);
  ff[17]=_mm256_add_epi16(ff[17],t[17]);
  ff[18]=_mm256_add_epi16(ff[18],t[18]);
  ff[19]=_mm256_add_epi16(ff[19],t[19]);
  ff[20]=_mm256_add_epi16(ff[20],t[20]);
  ff[21]=_mm256_add_epi16(ff[21],t[21]);
  ff[22]=_mm256_add_epi16(ff[22],t[22]);
  ff[23]=_mm256_add_epi16(ff[23],t[23]);
  ff[24]=_mm256_add_epi16(ff[24],t[24]);
  ff[25]=_mm256_add_epi16(ff[25],t[25]);
  ff[26]=_mm256_add_epi16(ff[26],t[26]);
  ff[27]=_mm256_add_epi16(ff[27],t[27]);
  ff[28]=_mm256_add_epi16(ff[28],t[28]);
  ff[29]=_mm256_add_epi16(ff[29],t[29]);
  ff[30]=_mm256_add_epi16(ff[30],t[30]);
  ff[31]=_mm256_add_epi16(ff[31],t[31]);

  ff[16]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[0]),ff[16]);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[17]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[1]),ff[17]);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[18]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[2]),ff[18]);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[19]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[3]),ff[19]);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[20]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[4]),ff[20]);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[21]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[5]),ff[21]);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[22]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[6]),ff[22]);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[23]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[7]),ff[23]);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);
  ff[24]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[8]),ff[24]);
  ff[8]=_mm256_andnot_si256(uv_mask,ff[8]);
  ff[25]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[9]),ff[25]);
  ff[9]=_mm256_andnot_si256(uv_mask,ff[9]);
  ff[26]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[10]),ff[26]);
  ff[10]=_mm256_andnot_si256(uv_mask,ff[10]);
  ff[27]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[11]),ff[27]);
  ff[11]=_mm256_andnot_si256(uv_mask,ff[11]);
  ff[28]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[12]),ff[28]);
  ff[12]=_mm256_andnot_si256(uv_mask,ff[12]);
  ff[29]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[13]),ff[29]);
  ff[13]=_mm256_andnot_si256(uv_mask,ff[13]);
  ff[30]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[14]),ff[30]);
  ff[14]=_mm256_andnot_si256(uv_mask,ff[14]);
  ff[31]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[15]),ff[31]);
  ff[15]=_mm256_andnot_si256(uv_mask,ff[15]);

  gf_polymul_256x256_avx2_divR(gg,uvqr+32,f);
  gf_polymul_256x256_avx2_divR(t,uvqr+48,g);
  gg[9] = barrett_fake(gg[9]); // <2610
  t[9] = barrett_fake(t[9]); // <2610
  gg[22] = barrett_fake(gg[22]); // <2610
  t[22] = barrett_fake(t[22]); // <2610

  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);
  gg[8]=_mm256_add_epi16(gg[8],t[8]);
  gg[9]=_mm256_add_epi16(gg[9],t[9]);
  gg[10]=_mm256_add_epi16(gg[10],t[10]);
  gg[11]=_mm256_add_epi16(gg[11],t[11]);
  gg[12]=_mm256_add_epi16(gg[12],t[12]);
  gg[13]=_mm256_add_epi16(gg[13],t[13]);
  gg[14]=_mm256_add_epi16(gg[14],t[14]);
  gg[15]=_mm256_add_epi16(gg[15],t[15]);
  gg[16]=_mm256_add_epi16(gg[16],t[16]);
  gg[17]=_mm256_add_epi16(gg[17],t[17]);
  gg[18]=_mm256_add_epi16(gg[18],t[18]);
  gg[19]=_mm256_add_epi16(gg[19],t[19]);
  gg[20]=_mm256_add_epi16(gg[20],t[20]);
  gg[21]=_mm256_add_epi16(gg[21],t[21]);
  gg[22]=_mm256_add_epi16(gg[22],t[22]);
  gg[23]=_mm256_add_epi16(gg[23],t[23]);
  gg[24]=_mm256_add_epi16(gg[24],t[24]);
  gg[25]=_mm256_add_epi16(gg[25],t[25]);
  gg[26]=_mm256_add_epi16(gg[26],t[26]);
  gg[27]=_mm256_add_epi16(gg[27],t[27]);
  gg[28]=_mm256_add_epi16(gg[28],t[28]);
  gg[29]=_mm256_add_epi16(gg[29],t[29]);
  gg[30]=_mm256_add_epi16(gg[30],t[30]);
  gg[31]=_mm256_add_epi16(gg[31],t[31]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  gg[0] = montproduct(gg[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  gg[1] = montproduct(gg[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  gg[2] = montproduct(gg[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  gg[3] = montproduct(gg[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2614
  gg[4] = montproduct(gg[4],v4158_16); // <2614
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  gg[5] = montproduct(gg[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <2614
  gg[6] = montproduct(gg[6],v4158_16); // <2614
  ff[7] = montproduct(ff[7],v4158_16); // <2614
  gg[7] = montproduct(gg[7],v4158_16); // <2614
  ff[8] = montproduct(ff[8],v4158_16); // <4019
  gg[8] = montproduct(gg[8],v4158_16); // <4019
  ff[9] = montproduct(ff[9],v4158_16); // <2626
  gg[9] = montproduct(gg[9],v4158_16); // <2626
  ff[10] = montproduct(ff[10],v4158_16); // <3596
  gg[10] = montproduct(gg[10],v4158_16); // <3596
  ff[11] = montproduct(ff[11],v4158_16); // <3596
  gg[11] = montproduct(gg[11],v4158_16); // <3596
  ff[12] = montproduct(ff[12],v4158_16); // <3574
  gg[12] = montproduct(gg[12],v4158_16); // <3574
  ff[13] = montproduct(ff[13],v4158_16); // <3608
  gg[13] = montproduct(gg[13],v4158_16); // <3608
  ff[14] = montproduct(ff[14],v4158_16); // <4032
  gg[14] = montproduct(gg[14],v4158_16); // <4032
  ff[15] = montproduct(ff[15],v4158_16); // <3775
  gg[15] = montproduct(gg[15],v4158_16); // <3775
  ff[16] = montproduct(ff[16],v4158_16); // <3791
  gg[16] = montproduct(gg[16],v4158_16); // <3791
  ff[17] = montproduct(ff[17],v4158_16); // <4048
  gg[17] = montproduct(gg[17],v4158_16); // <4048
  ff[18] = montproduct(ff[18],v4158_16); // <3608
  gg[18] = montproduct(gg[18],v4158_16); // <3608
  ff[19] = montproduct(ff[19],v4158_16); // <3574
  gg[19] = montproduct(gg[19],v4158_16); // <3574
  ff[20] = montproduct(ff[20],v4158_16); // <3596
  gg[20] = montproduct(gg[20],v4158_16); // <3596
  ff[21] = montproduct(ff[21],v4158_16); // <3596
  gg[21] = montproduct(gg[21],v4158_16); // <3596
  ff[22] = montproduct(ff[22],v4158_16); // <2626
  gg[22] = montproduct(gg[22],v4158_16); // <2626
  ff[23] = montproduct(ff[23],v4158_16); // <3987
  gg[23] = montproduct(gg[23],v4158_16); // <3987
  ff[24] = montproduct(ff[24],v4158_16); // <2614
  gg[24] = montproduct(gg[24],v4158_16); // <2614
  ff[25] = montproduct(ff[25],v4158_16); // <2614
  gg[25] = montproduct(gg[25],v4158_16); // <2614
  ff[26] = montproduct(ff[26],v4158_16); // <2626
  gg[26] = montproduct(gg[26],v4158_16); // <2626
  ff[27] = montproduct(ff[27],v4158_16); // <2614
  gg[27] = montproduct(gg[27],v4158_16); // <2614
  ff[28] = montproduct(ff[28],v4158_16); // <2626
  gg[28] = montproduct(gg[28],v4158_16); // <2626
  ff[29] = montproduct(ff[29],v4158_16); // <2626
  gg[29] = montproduct(gg[29],v4158_16); // <2626
  ff[30] = montproduct(ff[30],v4158_16); // <3084
  gg[30] = montproduct(gg[30],v4158_16); // <3084
  ff[31] = montproduct(ff[31],v4158_16); // <2827
  gg[31] = montproduct(gg[31],v4158_16); // <2827
}
void gf_polymul_256x256_avx2_uvqr_vr (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[32];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+16);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);
  __m256i f_mask = uv_over(f);

  gf_polymul_256x256_avx2_divR(ff,uvqr,f);
  ff[16]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[0]),ff[16]);
  ff[0]=_mm256_andnot_si256(f_mask,ff[0]);
  ff[17]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[1]),ff[17]);
  ff[1]=_mm256_andnot_si256(f_mask,ff[1]);
  ff[18]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[2]),ff[18]);
  ff[2]=_mm256_andnot_si256(f_mask,ff[2]);
  ff[19]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[3]),ff[19]);
  ff[3]=_mm256_andnot_si256(f_mask,ff[3]);
  ff[20]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[4]),ff[20]);
  ff[4]=_mm256_andnot_si256(f_mask,ff[4]);
  ff[21]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[5]),ff[21]);
  ff[5]=_mm256_andnot_si256(f_mask,ff[5]);
  ff[22]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[6]),ff[22]);
  ff[6]=_mm256_andnot_si256(f_mask,ff[6]);
  ff[23]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[7]),ff[23]);
  ff[7]=_mm256_andnot_si256(f_mask,ff[7]);
  ff[24]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[8]),ff[24]);
  ff[8]=_mm256_andnot_si256(f_mask,ff[8]);
  ff[25]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[9]),ff[25]);
  ff[9]=_mm256_andnot_si256(f_mask,ff[9]);
  ff[26]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[10]),ff[26]);
  ff[10]=_mm256_andnot_si256(f_mask,ff[10]);
  ff[27]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[11]),ff[27]);
  ff[11]=_mm256_andnot_si256(f_mask,ff[11]);
  ff[28]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[12]),ff[28]);
  ff[12]=_mm256_andnot_si256(f_mask,ff[12]);
  ff[29]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[13]),ff[29]);
  ff[13]=_mm256_andnot_si256(f_mask,ff[13]);
  ff[30]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[14]),ff[30]);
  ff[14]=_mm256_andnot_si256(f_mask,ff[14]);
  ff[31]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[15]),ff[31]);
  ff[15]=_mm256_andnot_si256(f_mask,ff[15]);
  gf_polymul_256x256_avx2_divR(t,uvqr+16,g);
  ff[9] = barrett_fake(ff[9]); // <2610
  t[9] = barrett_fake(t[9]); // <2610
  ff[22] = barrett_fake(ff[22]); // <2610
  t[22] = barrett_fake(t[22]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);
  ff[16]=_mm256_add_epi16(ff[16],t[16]);
  ff[17]=_mm256_add_epi16(ff[17],t[17]);
  ff[18]=_mm256_add_epi16(ff[18],t[18]);
  ff[19]=_mm256_add_epi16(ff[19],t[19]);
  ff[20]=_mm256_add_epi16(ff[20],t[20]);
  ff[21]=_mm256_add_epi16(ff[21],t[21]);
  ff[22]=_mm256_add_epi16(ff[22],t[22]);
  ff[23]=_mm256_add_epi16(ff[23],t[23]);
  ff[24]=_mm256_add_epi16(ff[24],t[24]);
  ff[25]=_mm256_add_epi16(ff[25],t[25]);
  ff[26]=_mm256_add_epi16(ff[26],t[26]);
  ff[27]=_mm256_add_epi16(ff[27],t[27]);
  ff[28]=_mm256_add_epi16(ff[28],t[28]);
  ff[29]=_mm256_add_epi16(ff[29],t[29]);
  ff[30]=_mm256_add_epi16(ff[30],t[30]);
  ff[31]=_mm256_add_epi16(ff[31],t[31]);

  ff[16]=_mm256_blendv_epi8(ff[16],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[17]=_mm256_blendv_epi8(ff[17],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[18]=_mm256_blendv_epi8(ff[18],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[19]=_mm256_blendv_epi8(ff[19],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[20]=_mm256_blendv_epi8(ff[20],ff[4],uv_mask);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[21]=_mm256_blendv_epi8(ff[21],ff[5],uv_mask);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[22]=_mm256_blendv_epi8(ff[22],ff[6],uv_mask);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[23]=_mm256_blendv_epi8(ff[23],ff[7],uv_mask);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);
  ff[24]=_mm256_blendv_epi8(ff[24],ff[8],uv_mask);
  ff[8]=_mm256_andnot_si256(uv_mask,ff[8]);
  ff[25]=_mm256_blendv_epi8(ff[25],ff[9],uv_mask);
  ff[9]=_mm256_andnot_si256(uv_mask,ff[9]);
  ff[26]=_mm256_blendv_epi8(ff[26],ff[10],uv_mask);
  ff[10]=_mm256_andnot_si256(uv_mask,ff[10]);
  ff[27]=_mm256_blendv_epi8(ff[27],ff[11],uv_mask);
  ff[11]=_mm256_andnot_si256(uv_mask,ff[11]);
  ff[28]=_mm256_blendv_epi8(ff[28],ff[12],uv_mask);
  ff[12]=_mm256_andnot_si256(uv_mask,ff[12]);
  ff[29]=_mm256_blendv_epi8(ff[29],ff[13],uv_mask);
  ff[13]=_mm256_andnot_si256(uv_mask,ff[13]);
  ff[30]=_mm256_blendv_epi8(ff[30],ff[14],uv_mask);
  ff[14]=_mm256_andnot_si256(uv_mask,ff[14]);
  ff[31]=_mm256_blendv_epi8(ff[31],ff[15],uv_mask);
  ff[15]=_mm256_andnot_si256(uv_mask,ff[15]);

  gf_polymul_256x256_avx2_divR(gg,uvqr+32,f);
  gg[16]=_mm256_blendv_epi8(gg[16],gg[0],f_mask);
  gg[0]=_mm256_andnot_si256(f_mask,gg[0]);
  gg[17]=_mm256_blendv_epi8(gg[17],gg[1],f_mask);
  gg[1]=_mm256_andnot_si256(f_mask,gg[1]);
  gg[18]=_mm256_blendv_epi8(gg[18],gg[2],f_mask);
  gg[2]=_mm256_andnot_si256(f_mask,gg[2]);
  gg[19]=_mm256_blendv_epi8(gg[19],gg[3],f_mask);
  gg[3]=_mm256_andnot_si256(f_mask,gg[3]);
  gg[20]=_mm256_blendv_epi8(gg[20],gg[4],f_mask);
  gg[4]=_mm256_andnot_si256(f_mask,gg[4]);
  gg[21]=_mm256_blendv_epi8(gg[21],gg[5],f_mask);
  gg[5]=_mm256_andnot_si256(f_mask,gg[5]);
  gg[22]=_mm256_blendv_epi8(gg[22],gg[6],f_mask);
  gg[6]=_mm256_andnot_si256(f_mask,gg[6]);
  gg[23]=_mm256_blendv_epi8(gg[23],gg[7],f_mask);
  gg[7]=_mm256_andnot_si256(f_mask,gg[7]);
  gg[24]=_mm256_blendv_epi8(gg[24],gg[8],f_mask);
  gg[8]=_mm256_andnot_si256(f_mask,gg[8]);
  gg[25]=_mm256_blendv_epi8(gg[25],gg[9],f_mask);
  gg[9]=_mm256_andnot_si256(f_mask,gg[9]);
  gg[26]=_mm256_blendv_epi8(gg[26],gg[10],f_mask);
  gg[10]=_mm256_andnot_si256(f_mask,gg[10]);
  gg[27]=_mm256_blendv_epi8(gg[27],gg[11],f_mask);
  gg[11]=_mm256_andnot_si256(f_mask,gg[11]);
  gg[28]=_mm256_blendv_epi8(gg[28],gg[12],f_mask);
  gg[12]=_mm256_andnot_si256(f_mask,gg[12]);
  gg[29]=_mm256_blendv_epi8(gg[29],gg[13],f_mask);
  gg[13]=_mm256_andnot_si256(f_mask,gg[13]);
  gg[30]=_mm256_blendv_epi8(gg[30],gg[14],f_mask);
  gg[14]=_mm256_andnot_si256(f_mask,gg[14]);
  gg[31]=_mm256_blendv_epi8(gg[31],gg[15],f_mask);
  gg[15]=_mm256_andnot_si256(f_mask,gg[15]);
  gf_polymul_256x256_avx2_divR(t,uvqr+48,g);
  gg[9] = barrett_fake(gg[9]); // <2610
  t[9] = barrett_fake(t[9]); // <2610
  gg[22] = barrett_fake(gg[22]); // <2610
  t[22] = barrett_fake(t[22]); // <2610

  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);
  gg[8]=_mm256_add_epi16(gg[8],t[8]);
  gg[9]=_mm256_add_epi16(gg[9],t[9]);
  gg[10]=_mm256_add_epi16(gg[10],t[10]);
  gg[11]=_mm256_add_epi16(gg[11],t[11]);
  gg[12]=_mm256_add_epi16(gg[12],t[12]);
  gg[13]=_mm256_add_epi16(gg[13],t[13]);
  gg[14]=_mm256_add_epi16(gg[14],t[14]);
  gg[15]=_mm256_add_epi16(gg[15],t[15]);
  gg[16]=_mm256_add_epi16(gg[16],t[16]);
  gg[17]=_mm256_add_epi16(gg[17],t[17]);
  gg[18]=_mm256_add_epi16(gg[18],t[18]);
  gg[19]=_mm256_add_epi16(gg[19],t[19]);
  gg[20]=_mm256_add_epi16(gg[20],t[20]);
  gg[21]=_mm256_add_epi16(gg[21],t[21]);
  gg[22]=_mm256_add_epi16(gg[22],t[22]);
  gg[23]=_mm256_add_epi16(gg[23],t[23]);
  gg[24]=_mm256_add_epi16(gg[24],t[24]);
  gg[25]=_mm256_add_epi16(gg[25],t[25]);
  gg[26]=_mm256_add_epi16(gg[26],t[26]);
  gg[27]=_mm256_add_epi16(gg[27],t[27]);
  gg[28]=_mm256_add_epi16(gg[28],t[28]);
  gg[29]=_mm256_add_epi16(gg[29],t[29]);
  gg[30]=_mm256_add_epi16(gg[30],t[30]);
  gg[31]=_mm256_add_epi16(gg[31],t[31]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  gg[0] = montproduct(gg[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  gg[1] = montproduct(gg[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  gg[2] = montproduct(gg[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  gg[3] = montproduct(gg[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2614
  gg[4] = montproduct(gg[4],v4158_16); // <2614
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  gg[5] = montproduct(gg[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <2614
  gg[6] = montproduct(gg[6],v4158_16); // <2614
  ff[7] = montproduct(ff[7],v4158_16); // <2614
  gg[7] = montproduct(gg[7],v4158_16); // <2614
  ff[8] = montproduct(ff[8],v4158_16); // <4019
  gg[8] = montproduct(gg[8],v4158_16); // <4019
  ff[9] = montproduct(ff[9],v4158_16); // <2626
  gg[9] = montproduct(gg[9],v4158_16); // <2626
  ff[10] = montproduct(ff[10],v4158_16); // <3596
  gg[10] = montproduct(gg[10],v4158_16); // <3596
  ff[11] = montproduct(ff[11],v4158_16); // <3596
  gg[11] = montproduct(gg[11],v4158_16); // <3596
  ff[12] = montproduct(ff[12],v4158_16); // <3574
  gg[12] = montproduct(gg[12],v4158_16); // <3574
  ff[13] = montproduct(ff[13],v4158_16); // <3608
  gg[13] = montproduct(gg[13],v4158_16); // <3608
  ff[14] = montproduct(ff[14],v4158_16); // <4032
  gg[14] = montproduct(gg[14],v4158_16); // <4032
  ff[15] = montproduct(ff[15],v4158_16); // <3775
  gg[15] = montproduct(gg[15],v4158_16); // <3775
  ff[16] = montproduct(ff[16],v4158_16); // <3791
  gg[16] = montproduct(gg[16],v4158_16); // <3791
  ff[17] = montproduct(ff[17],v4158_16); // <4048
  gg[17] = montproduct(gg[17],v4158_16); // <4048
  ff[18] = montproduct(ff[18],v4158_16); // <3608
  gg[18] = montproduct(gg[18],v4158_16); // <3608
  ff[19] = montproduct(ff[19],v4158_16); // <3574
  gg[19] = montproduct(gg[19],v4158_16); // <3574
  ff[20] = montproduct(ff[20],v4158_16); // <3596
  gg[20] = montproduct(gg[20],v4158_16); // <3596
  ff[21] = montproduct(ff[21],v4158_16); // <3596
  gg[21] = montproduct(gg[21],v4158_16); // <3596
  ff[22] = montproduct(ff[22],v4158_16); // <2626
  gg[22] = montproduct(gg[22],v4158_16); // <2626
  ff[23] = montproduct(ff[23],v4158_16); // <3987
  gg[23] = montproduct(gg[23],v4158_16); // <3987
  ff[24] = montproduct(ff[24],v4158_16); // <2614
  gg[24] = montproduct(gg[24],v4158_16); // <2614
  ff[25] = montproduct(ff[25],v4158_16); // <2614
  gg[25] = montproduct(gg[25],v4158_16); // <2614
  ff[26] = montproduct(ff[26],v4158_16); // <2626
  gg[26] = montproduct(gg[26],v4158_16); // <2626
  ff[27] = montproduct(ff[27],v4158_16); // <2614
  gg[27] = montproduct(gg[27],v4158_16); // <2614
  ff[28] = montproduct(ff[28],v4158_16); // <2626
  gg[28] = montproduct(gg[28],v4158_16); // <2626
  ff[29] = montproduct(ff[29],v4158_16); // <2626
  gg[29] = montproduct(gg[29],v4158_16); // <2626
  ff[30] = montproduct(ff[30],v4158_16); // <3084
  gg[30] = montproduct(gg[30],v4158_16); // <3084
  ff[31] = montproduct(ff[31],v4158_16); // <2827
  gg[31] = montproduct(gg[31],v4158_16); // <2827

  ff[0] = _mm256_blendv_epi8(ff[0],v01,u_mask&f_mask);
}
void gf_polymul_256x256_avx2_uvqr_fg_x (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[32];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+16);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);

  gf_polymul_256x256_avx2_divR(ff,uvqr,f);
  gf_polymul_256x256_avx2_divR(t,uvqr+16,g);
  ff[9] = barrett_fake(ff[9]); // <2610
  t[9] = barrett_fake(t[9]); // <2610
  ff[22] = barrett_fake(ff[22]); // <2610
  t[22] = barrett_fake(t[22]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);
  ff[16]=_mm256_add_epi16(ff[16],t[16]);
  ff[17]=_mm256_add_epi16(ff[17],t[17]);
  ff[18]=_mm256_add_epi16(ff[18],t[18]);
  ff[19]=_mm256_add_epi16(ff[19],t[19]);
  ff[20]=_mm256_add_epi16(ff[20],t[20]);
  ff[21]=_mm256_add_epi16(ff[21],t[21]);
  ff[22]=_mm256_add_epi16(ff[22],t[22]);
  ff[23]=_mm256_add_epi16(ff[23],t[23]);
  ff[24]=_mm256_add_epi16(ff[24],t[24]);
  ff[25]=_mm256_add_epi16(ff[25],t[25]);
  ff[26]=_mm256_add_epi16(ff[26],t[26]);
  ff[27]=_mm256_add_epi16(ff[27],t[27]);
  ff[28]=_mm256_add_epi16(ff[28],t[28]);
  ff[29]=_mm256_add_epi16(ff[29],t[29]);
  ff[30]=_mm256_add_epi16(ff[30],t[30]);
  ff[31]=_mm256_add_epi16(ff[31],t[31]);

  ff[16]=_mm256_blendv_epi8(ff[16],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[17]=_mm256_blendv_epi8(ff[17],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[18]=_mm256_blendv_epi8(ff[18],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[19]=_mm256_blendv_epi8(ff[19],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[20]=_mm256_blendv_epi8(ff[20],ff[4],uv_mask);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[21]=_mm256_blendv_epi8(ff[21],ff[5],uv_mask);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[22]=_mm256_blendv_epi8(ff[22],ff[6],uv_mask);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[23]=_mm256_blendv_epi8(ff[23],ff[7],uv_mask);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);
  ff[24]=_mm256_blendv_epi8(ff[24],ff[8],uv_mask);
  ff[8]=_mm256_andnot_si256(uv_mask,ff[8]);
  ff[25]=_mm256_blendv_epi8(ff[25],ff[9],uv_mask);
  ff[9]=_mm256_andnot_si256(uv_mask,ff[9]);
  ff[26]=_mm256_blendv_epi8(ff[26],ff[10],uv_mask);
  ff[10]=_mm256_andnot_si256(uv_mask,ff[10]);
  ff[27]=_mm256_blendv_epi8(ff[27],ff[11],uv_mask);
  ff[11]=_mm256_andnot_si256(uv_mask,ff[11]);
  ff[28]=_mm256_blendv_epi8(ff[28],ff[12],uv_mask);
  ff[12]=_mm256_andnot_si256(uv_mask,ff[12]);
  ff[29]=_mm256_blendv_epi8(ff[29],ff[13],uv_mask);
  ff[13]=_mm256_andnot_si256(uv_mask,ff[13]);
  ff[30]=_mm256_blendv_epi8(ff[30],ff[14],uv_mask);
  ff[14]=_mm256_andnot_si256(uv_mask,ff[14]);
  ff[31]=_mm256_blendv_epi8(ff[31],ff[15],uv_mask);
  ff[15]=_mm256_andnot_si256(uv_mask,ff[15]);


  ff[0] = montproduct(ff[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2614
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <2614
  ff[7] = montproduct(ff[7],v4158_16); // <2614
  ff[8] = montproduct(ff[8],v4158_16); // <4019
  ff[9] = montproduct(ff[9],v4158_16); // <2626
  ff[10] = montproduct(ff[10],v4158_16); // <3596
  ff[11] = montproduct(ff[11],v4158_16); // <3596
  ff[12] = montproduct(ff[12],v4158_16); // <3574
  ff[13] = montproduct(ff[13],v4158_16); // <3608
  ff[14] = montproduct(ff[14],v4158_16); // <4032
  ff[15] = montproduct(ff[15],v4158_16); // <3775
  ff[16] = montproduct(ff[16],v4158_16); // <3791
  ff[17] = montproduct(ff[17],v4158_16); // <4048
  ff[18] = montproduct(ff[18],v4158_16); // <3608
  ff[19] = montproduct(ff[19],v4158_16); // <3574
  ff[20] = montproduct(ff[20],v4158_16); // <3596
  ff[21] = montproduct(ff[21],v4158_16); // <3596
  ff[22] = montproduct(ff[22],v4158_16); // <2626
  ff[23] = montproduct(ff[23],v4158_16); // <3987
  ff[24] = montproduct(ff[24],v4158_16); // <2614
  ff[25] = montproduct(ff[25],v4158_16); // <2614
  ff[26] = montproduct(ff[26],v4158_16); // <2626
  ff[27] = montproduct(ff[27],v4158_16); // <2614
  ff[28] = montproduct(ff[28],v4158_16); // <2626
  ff[29] = montproduct(ff[29],v4158_16); // <2626
  ff[30] = montproduct(ff[30],v4158_16); // <3084
  ff[31] = montproduct(ff[31],v4158_16); // <2827
}
void gf_polymul_256x256_avx2_uvqr_vr_x (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[32];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+16);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);
  __m256i f_mask = uv_over(f);

  gf_polymul_256x256_avx2_divR(ff,uvqr,f);
  ff[16]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[0]),ff[16]);
  ff[0]=_mm256_andnot_si256(f_mask,ff[0]);
  ff[17]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[1]),ff[17]);
  ff[1]=_mm256_andnot_si256(f_mask,ff[1]);
  ff[18]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[2]),ff[18]);
  ff[2]=_mm256_andnot_si256(f_mask,ff[2]);
  ff[19]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[3]),ff[19]);
  ff[3]=_mm256_andnot_si256(f_mask,ff[3]);
  ff[20]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[4]),ff[20]);
  ff[4]=_mm256_andnot_si256(f_mask,ff[4]);
  ff[21]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[5]),ff[21]);
  ff[5]=_mm256_andnot_si256(f_mask,ff[5]);
  ff[22]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[6]),ff[22]);
  ff[6]=_mm256_andnot_si256(f_mask,ff[6]);
  ff[23]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[7]),ff[23]);
  ff[7]=_mm256_andnot_si256(f_mask,ff[7]);
  ff[24]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[8]),ff[24]);
  ff[8]=_mm256_andnot_si256(f_mask,ff[8]);
  ff[25]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[9]),ff[25]);
  ff[9]=_mm256_andnot_si256(f_mask,ff[9]);
  ff[26]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[10]),ff[26]);
  ff[10]=_mm256_andnot_si256(f_mask,ff[10]);
  ff[27]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[11]),ff[27]);
  ff[11]=_mm256_andnot_si256(f_mask,ff[11]);
  ff[28]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[12]),ff[28]);
  ff[12]=_mm256_andnot_si256(f_mask,ff[12]);
  ff[29]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[13]),ff[29]);
  ff[13]=_mm256_andnot_si256(f_mask,ff[13]);
  ff[30]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[14]),ff[30]);
  ff[14]=_mm256_andnot_si256(f_mask,ff[14]);
  ff[31]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[15]),ff[31]);
  ff[15]=_mm256_andnot_si256(f_mask,ff[15]);
  gf_polymul_256x256_avx2_divR(t,uvqr+16,g);
  ff[9] = barrett_fake(ff[9]); // <2610
  t[9] = barrett_fake(t[9]); // <2610
  ff[22] = barrett_fake(ff[22]); // <2610
  t[22] = barrett_fake(t[22]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);
  ff[16]=_mm256_add_epi16(ff[16],t[16]);
  ff[17]=_mm256_add_epi16(ff[17],t[17]);
  ff[18]=_mm256_add_epi16(ff[18],t[18]);
  ff[19]=_mm256_add_epi16(ff[19],t[19]);
  ff[20]=_mm256_add_epi16(ff[20],t[20]);
  ff[21]=_mm256_add_epi16(ff[21],t[21]);
  ff[22]=_mm256_add_epi16(ff[22],t[22]);
  ff[23]=_mm256_add_epi16(ff[23],t[23]);
  ff[24]=_mm256_add_epi16(ff[24],t[24]);
  ff[25]=_mm256_add_epi16(ff[25],t[25]);
  ff[26]=_mm256_add_epi16(ff[26],t[26]);
  ff[27]=_mm256_add_epi16(ff[27],t[27]);
  ff[28]=_mm256_add_epi16(ff[28],t[28]);
  ff[29]=_mm256_add_epi16(ff[29],t[29]);
  ff[30]=_mm256_add_epi16(ff[30],t[30]);
  ff[31]=_mm256_add_epi16(ff[31],t[31]);

  ff[16]=_mm256_blendv_epi8(ff[16],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[17]=_mm256_blendv_epi8(ff[17],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[18]=_mm256_blendv_epi8(ff[18],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[19]=_mm256_blendv_epi8(ff[19],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[20]=_mm256_blendv_epi8(ff[20],ff[4],uv_mask);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[21]=_mm256_blendv_epi8(ff[21],ff[5],uv_mask);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[22]=_mm256_blendv_epi8(ff[22],ff[6],uv_mask);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[23]=_mm256_blendv_epi8(ff[23],ff[7],uv_mask);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);
  ff[24]=_mm256_blendv_epi8(ff[24],ff[8],uv_mask);
  ff[8]=_mm256_andnot_si256(uv_mask,ff[8]);
  ff[25]=_mm256_blendv_epi8(ff[25],ff[9],uv_mask);
  ff[9]=_mm256_andnot_si256(uv_mask,ff[9]);
  ff[26]=_mm256_blendv_epi8(ff[26],ff[10],uv_mask);
  ff[10]=_mm256_andnot_si256(uv_mask,ff[10]);
  ff[27]=_mm256_blendv_epi8(ff[27],ff[11],uv_mask);
  ff[11]=_mm256_andnot_si256(uv_mask,ff[11]);
  ff[28]=_mm256_blendv_epi8(ff[28],ff[12],uv_mask);
  ff[12]=_mm256_andnot_si256(uv_mask,ff[12]);
  ff[29]=_mm256_blendv_epi8(ff[29],ff[13],uv_mask);
  ff[13]=_mm256_andnot_si256(uv_mask,ff[13]);
  ff[30]=_mm256_blendv_epi8(ff[30],ff[14],uv_mask);
  ff[14]=_mm256_andnot_si256(uv_mask,ff[14]);
  ff[31]=_mm256_blendv_epi8(ff[31],ff[15],uv_mask);
  ff[15]=_mm256_andnot_si256(uv_mask,ff[15]);


  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);
  gg[8]=_mm256_add_epi16(gg[8],t[8]);
  gg[9]=_mm256_add_epi16(gg[9],t[9]);
  gg[10]=_mm256_add_epi16(gg[10],t[10]);
  gg[11]=_mm256_add_epi16(gg[11],t[11]);
  gg[12]=_mm256_add_epi16(gg[12],t[12]);
  gg[13]=_mm256_add_epi16(gg[13],t[13]);
  gg[14]=_mm256_add_epi16(gg[14],t[14]);
  gg[15]=_mm256_add_epi16(gg[15],t[15]);
  gg[16]=_mm256_add_epi16(gg[16],t[16]);
  gg[17]=_mm256_add_epi16(gg[17],t[17]);
  gg[18]=_mm256_add_epi16(gg[18],t[18]);
  gg[19]=_mm256_add_epi16(gg[19],t[19]);
  gg[20]=_mm256_add_epi16(gg[20],t[20]);
  gg[21]=_mm256_add_epi16(gg[21],t[21]);
  gg[22]=_mm256_add_epi16(gg[22],t[22]);
  gg[23]=_mm256_add_epi16(gg[23],t[23]);
  gg[24]=_mm256_add_epi16(gg[24],t[24]);
  gg[25]=_mm256_add_epi16(gg[25],t[25]);
  gg[26]=_mm256_add_epi16(gg[26],t[26]);
  gg[27]=_mm256_add_epi16(gg[27],t[27]);
  gg[28]=_mm256_add_epi16(gg[28],t[28]);
  gg[29]=_mm256_add_epi16(gg[29],t[29]);
  gg[30]=_mm256_add_epi16(gg[30],t[30]);
  gg[31]=_mm256_add_epi16(gg[31],t[31]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2614
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <2614
  ff[7] = montproduct(ff[7],v4158_16); // <2614
  ff[8] = montproduct(ff[8],v4158_16); // <4019
  ff[9] = montproduct(ff[9],v4158_16); // <2626
  ff[10] = montproduct(ff[10],v4158_16); // <3596
  ff[11] = montproduct(ff[11],v4158_16); // <3596
  ff[12] = montproduct(ff[12],v4158_16); // <3574
  ff[13] = montproduct(ff[13],v4158_16); // <3608
  ff[14] = montproduct(ff[14],v4158_16); // <4032
  ff[15] = montproduct(ff[15],v4158_16); // <3775
  ff[16] = montproduct(ff[16],v4158_16); // <3791
  ff[17] = montproduct(ff[17],v4158_16); // <4048
  ff[18] = montproduct(ff[18],v4158_16); // <3608
  ff[19] = montproduct(ff[19],v4158_16); // <3574
  ff[20] = montproduct(ff[20],v4158_16); // <3596
  ff[21] = montproduct(ff[21],v4158_16); // <3596
  ff[22] = montproduct(ff[22],v4158_16); // <2626
  ff[23] = montproduct(ff[23],v4158_16); // <3987
  ff[24] = montproduct(ff[24],v4158_16); // <2614
  ff[25] = montproduct(ff[25],v4158_16); // <2614
  ff[26] = montproduct(ff[26],v4158_16); // <2626
  ff[27] = montproduct(ff[27],v4158_16); // <2614
  ff[28] = montproduct(ff[28],v4158_16); // <2626
  ff[29] = montproduct(ff[29],v4158_16); // <2626
  ff[30] = montproduct(ff[30],v4158_16); // <3084
  ff[31] = montproduct(ff[31],v4158_16); // <2827

  ff[0] = _mm256_or_si256(_mm256_and_si256(_mm256_and_si256(u_mask,f_mask),v01),ff[0]);
}
void gf_polymul_512x512_avx2_divR (__m256i *h, __m256i *f, __m256i *g){
  __m256i ff[211], gg[211], hh[422];
  __m256i t[32];

  ff[0]=_mm256_add_epi16(f[0],f[16]); // <5762
  gg[0]=_mm256_add_epi16(g[0],g[16]); // <5762
  ff[1]=_mm256_add_epi16(f[1],f[17]); // <5762
  gg[1]=_mm256_add_epi16(g[1],g[17]); // <5762
  ff[2]=_mm256_add_epi16(f[2],f[18]); // <5762
  gg[2]=_mm256_add_epi16(g[2],g[18]); // <5762
  ff[3]=_mm256_add_epi16(f[3],f[19]); // <5762
  gg[3]=_mm256_add_epi16(g[3],g[19]); // <5762
  ff[4]=_mm256_add_epi16(f[4],f[20]); // <5762
  gg[4]=_mm256_add_epi16(g[4],g[20]); // <5762
  ff[5]=_mm256_add_epi16(f[5],f[21]); // <5762
  gg[5]=_mm256_add_epi16(g[5],g[21]); // <5762
  ff[6]=_mm256_add_epi16(f[6],f[22]); // <5762
  gg[6]=_mm256_add_epi16(g[6],g[22]); // <5762
  ff[7]=_mm256_add_epi16(f[7],f[23]); // <5762
  gg[7]=_mm256_add_epi16(g[7],g[23]); // <5762
  ff[8]=_mm256_add_epi16(f[8],f[24]); // <5762
  gg[8]=_mm256_add_epi16(g[8],g[24]); // <5762
  ff[9]=_mm256_add_epi16(f[9],f[25]); // <5762
  gg[9]=_mm256_add_epi16(g[9],g[25]); // <5762
  ff[10]=_mm256_add_epi16(f[10],f[26]); // <5762
  gg[10]=_mm256_add_epi16(g[10],g[26]); // <5762
  ff[11]=_mm256_add_epi16(f[11],f[27]); // <5762
  gg[11]=_mm256_add_epi16(g[11],g[27]); // <5762
  ff[12]=_mm256_add_epi16(f[12],f[28]); // <5762
  gg[12]=_mm256_add_epi16(g[12],g[28]); // <5762
  ff[13]=_mm256_add_epi16(f[13],f[29]); // <5762
  gg[13]=_mm256_add_epi16(g[13],g[29]); // <5762
  ff[14]=_mm256_add_epi16(f[14],f[30]); // <5762
  gg[14]=_mm256_add_epi16(g[14],g[30]); // <5762
  ff[15]=_mm256_add_epi16(f[15],f[31]); // <5762
  gg[15]=_mm256_add_epi16(g[15],g[31]); // <5762
  ff[16]=_mm256_add_epi16(f[0],f[8]); // <5762
  gg[16]=_mm256_add_epi16(g[0],g[8]); // <5762
  ff[17]=_mm256_add_epi16(f[1],f[9]); // <5762
  gg[17]=_mm256_add_epi16(g[1],g[9]); // <5762
  ff[18]=_mm256_add_epi16(f[2],f[10]); // <5762
  gg[18]=_mm256_add_epi16(g[2],g[10]); // <5762
  ff[19]=_mm256_add_epi16(f[3],f[11]); // <5762
  gg[19]=_mm256_add_epi16(g[3],g[11]); // <5762
  ff[20]=_mm256_add_epi16(f[4],f[12]); // <5762
  gg[20]=_mm256_add_epi16(g[4],g[12]); // <5762
  ff[21]=_mm256_add_epi16(f[5],f[13]); // <5762
  gg[21]=_mm256_add_epi16(g[5],g[13]); // <5762
  ff[22]=_mm256_add_epi16(f[6],f[14]); // <5762
  gg[22]=_mm256_add_epi16(g[6],g[14]); // <5762
  ff[23]=_mm256_add_epi16(f[7],f[15]); // <5762
  gg[23]=_mm256_add_epi16(g[7],g[15]); // <5762
  ff[24]=_mm256_add_epi16(f[16],f[24]); // <5762
  gg[24]=_mm256_add_epi16(g[16],g[24]); // <5762
  ff[25]=_mm256_add_epi16(f[17],f[25]); // <5762
  gg[25]=_mm256_add_epi16(g[17],g[25]); // <5762
  ff[26]=_mm256_add_epi16(f[18],f[26]); // <5762
  gg[26]=_mm256_add_epi16(g[18],g[26]); // <5762
  ff[27]=_mm256_add_epi16(f[19],f[27]); // <5762
  gg[27]=_mm256_add_epi16(g[19],g[27]); // <5762
  ff[28]=_mm256_add_epi16(f[20],f[28]); // <5762
  gg[28]=_mm256_add_epi16(g[20],g[28]); // <5762
  ff[29]=_mm256_add_epi16(f[21],f[29]); // <5762
  gg[29]=_mm256_add_epi16(g[21],g[29]); // <5762
  ff[30]=_mm256_add_epi16(f[22],f[30]); // <5762
  gg[30]=_mm256_add_epi16(g[22],g[30]); // <5762
  ff[31]=_mm256_add_epi16(f[23],f[31]); // <5762
  gg[31]=_mm256_add_epi16(g[23],g[31]); // <5762
  ff[32]=_mm256_add_epi16(ff[0],ff[8]); // <11524
  gg[32]=_mm256_add_epi16(gg[0],gg[8]); // <11524
  ff[33]=_mm256_add_epi16(ff[1],ff[9]); // <11524
  gg[33]=_mm256_add_epi16(gg[1],gg[9]); // <11524
  ff[34]=_mm256_add_epi16(ff[2],ff[10]); // <11524
  gg[34]=_mm256_add_epi16(gg[2],gg[10]); // <11524
  ff[35]=_mm256_add_epi16(ff[3],ff[11]); // <11524
  gg[35]=_mm256_add_epi16(gg[3],gg[11]); // <11524
  ff[36]=_mm256_add_epi16(ff[4],ff[12]); // <11524
  gg[36]=_mm256_add_epi16(gg[4],gg[12]); // <11524
  ff[37]=_mm256_add_epi16(ff[5],ff[13]); // <11524
  gg[37]=_mm256_add_epi16(gg[5],gg[13]); // <11524
  ff[38]=_mm256_add_epi16(ff[6],ff[14]); // <11524
  gg[38]=_mm256_add_epi16(gg[6],gg[14]); // <11524
  ff[39]=_mm256_add_epi16(ff[7],ff[15]); // <11524
  gg[39]=_mm256_add_epi16(gg[7],gg[15]); // <11524
  ff[40]=_mm256_add_epi16(f[0],f[4]); // <5762
  gg[40]=_mm256_add_epi16(g[0],g[4]); // <5762
  ff[41]=_mm256_add_epi16(f[1],f[5]); // <5762
  gg[41]=_mm256_add_epi16(g[1],g[5]); // <5762
  ff[42]=_mm256_add_epi16(f[2],f[6]); // <5762
  gg[42]=_mm256_add_epi16(g[2],g[6]); // <5762
  ff[43]=_mm256_add_epi16(f[3],f[7]); // <5762
  gg[43]=_mm256_add_epi16(g[3],g[7]); // <5762
  ff[44]=_mm256_add_epi16(f[8],f[12]); // <5762
  gg[44]=_mm256_add_epi16(g[8],g[12]); // <5762
  ff[45]=_mm256_add_epi16(f[9],f[13]); // <5762
  gg[45]=_mm256_add_epi16(g[9],g[13]); // <5762
  ff[46]=_mm256_add_epi16(f[10],f[14]); // <5762
  gg[46]=_mm256_add_epi16(g[10],g[14]); // <5762
  ff[47]=_mm256_add_epi16(f[11],f[15]); // <5762
  gg[47]=_mm256_add_epi16(g[11],g[15]); // <5762
  ff[48]=_mm256_add_epi16(f[16],f[20]); // <5762
  gg[48]=_mm256_add_epi16(g[16],g[20]); // <5762
  ff[49]=_mm256_add_epi16(f[17],f[21]); // <5762
  gg[49]=_mm256_add_epi16(g[17],g[21]); // <5762
  ff[50]=_mm256_add_epi16(f[18],f[22]); // <5762
  gg[50]=_mm256_add_epi16(g[18],g[22]); // <5762
  ff[51]=_mm256_add_epi16(f[19],f[23]); // <5762
  gg[51]=_mm256_add_epi16(g[19],g[23]); // <5762
  ff[52]=_mm256_add_epi16(f[24],f[28]); // <5762
  gg[52]=_mm256_add_epi16(g[24],g[28]); // <5762
  ff[53]=_mm256_add_epi16(f[25],f[29]); // <5762
  gg[53]=_mm256_add_epi16(g[25],g[29]); // <5762
  ff[54]=_mm256_add_epi16(f[26],f[30]); // <5762
  gg[54]=_mm256_add_epi16(g[26],g[30]); // <5762
  ff[55]=_mm256_add_epi16(f[27],f[31]); // <5762
  gg[55]=_mm256_add_epi16(g[27],g[31]); // <5762
  ff[56]=_mm256_add_epi16(ff[0],ff[4]); // <11524
  gg[56]=_mm256_add_epi16(gg[0],gg[4]); // <11524
  ff[57]=_mm256_add_epi16(ff[1],ff[5]); // <11524
  gg[57]=_mm256_add_epi16(gg[1],gg[5]); // <11524
  ff[58]=_mm256_add_epi16(ff[2],ff[6]); // <11524
  gg[58]=_mm256_add_epi16(gg[2],gg[6]); // <11524
  ff[59]=_mm256_add_epi16(ff[3],ff[7]); // <11524
  gg[59]=_mm256_add_epi16(gg[3],gg[7]); // <11524
  ff[60]=_mm256_add_epi16(ff[8],ff[12]); // <11524
  gg[60]=_mm256_add_epi16(gg[8],gg[12]); // <11524
  ff[61]=_mm256_add_epi16(ff[9],ff[13]); // <11524
  gg[61]=_mm256_add_epi16(gg[9],gg[13]); // <11524
  ff[62]=_mm256_add_epi16(ff[10],ff[14]); // <11524
  gg[62]=_mm256_add_epi16(gg[10],gg[14]); // <11524
  ff[63]=_mm256_add_epi16(ff[11],ff[15]); // <11524
  gg[63]=_mm256_add_epi16(gg[11],gg[15]); // <11524
  ff[64]=_mm256_add_epi16(ff[16],ff[20]); // <11524
  gg[64]=_mm256_add_epi16(gg[16],gg[20]); // <11524
  ff[65]=_mm256_add_epi16(ff[17],ff[21]); // <11524
  gg[65]=_mm256_add_epi16(gg[17],gg[21]); // <11524
  ff[66]=_mm256_add_epi16(ff[18],ff[22]); // <11524
  gg[66]=_mm256_add_epi16(gg[18],gg[22]); // <11524
  ff[67]=_mm256_add_epi16(ff[19],ff[23]); // <11524
  gg[67]=_mm256_add_epi16(gg[19],gg[23]); // <11524
  ff[68]=_mm256_add_epi16(ff[24],ff[28]); // <11524
  gg[68]=_mm256_add_epi16(gg[24],gg[28]); // <11524
  ff[69]=_mm256_add_epi16(ff[25],ff[29]); // <11524
  gg[69]=_mm256_add_epi16(gg[25],gg[29]); // <11524
  ff[70]=_mm256_add_epi16(ff[26],ff[30]); // <11524
  gg[70]=_mm256_add_epi16(gg[26],gg[30]); // <11524
  ff[71]=_mm256_add_epi16(ff[27],ff[31]); // <11524
  gg[71]=_mm256_add_epi16(gg[27],gg[31]); // <11524
  ff[72]=_mm256_add_epi16(ff[32],ff[36]); // <23048
  gg[72]=_mm256_add_epi16(gg[32],gg[36]); // <23048
  ff[73]=_mm256_add_epi16(ff[33],ff[37]); // <23048
  gg[73]=_mm256_add_epi16(gg[33],gg[37]); // <23048
  ff[74]=_mm256_add_epi16(ff[34],ff[38]); // <23048
  gg[74]=_mm256_add_epi16(gg[34],gg[38]); // <23048
  ff[75]=_mm256_add_epi16(ff[35],ff[39]); // <23048
  gg[75]=_mm256_add_epi16(gg[35],gg[39]); // <23048
  ff[72] = barrett_fake(ff[72]); // <2701
  ff[74] = barrett_fake(ff[74]); // <2701
  gg[72] = barrett_fake(gg[72]); // <2340
  gg[74] = barrett_fake(gg[74]); // <2340
  ff[73] = barrett_fake(ff[73]); // <2701
  ff[75] = barrett_fake(ff[75]); // <2701
  gg[73] = barrett_fake(gg[73]); // <2340
  gg[75] = barrett_fake(gg[75]); // <2340
  ff[76]=_mm256_add_epi16(f[0],f[2]); // <5762
  gg[76]=_mm256_add_epi16(g[0],g[2]); // <5762
  ff[77]=_mm256_add_epi16(f[1],f[3]); // <5762
  gg[77]=_mm256_add_epi16(g[1],g[3]); // <5762
  ff[78]=_mm256_add_epi16(f[4],f[6]); // <5762
  gg[78]=_mm256_add_epi16(g[4],g[6]); // <5762
  ff[79]=_mm256_add_epi16(f[5],f[7]); // <5762
  gg[79]=_mm256_add_epi16(g[5],g[7]); // <5762
  ff[80]=_mm256_add_epi16(f[8],f[10]); // <5762
  gg[80]=_mm256_add_epi16(g[8],g[10]); // <5762
  ff[81]=_mm256_add_epi16(f[9],f[11]); // <5762
  gg[81]=_mm256_add_epi16(g[9],g[11]); // <5762
  ff[82]=_mm256_add_epi16(f[12],f[14]); // <5762
  gg[82]=_mm256_add_epi16(g[12],g[14]); // <5762
  ff[83]=_mm256_add_epi16(f[13],f[15]); // <5762
  gg[83]=_mm256_add_epi16(g[13],g[15]); // <5762
  ff[84]=_mm256_add_epi16(f[16],f[18]); // <5762
  gg[84]=_mm256_add_epi16(g[16],g[18]); // <5762
  ff[85]=_mm256_add_epi16(f[17],f[19]); // <5762
  gg[85]=_mm256_add_epi16(g[17],g[19]); // <5762
  ff[86]=_mm256_add_epi16(f[20],f[22]); // <5762
  gg[86]=_mm256_add_epi16(g[20],g[22]); // <5762
  ff[87]=_mm256_add_epi16(f[21],f[23]); // <5762
  gg[87]=_mm256_add_epi16(g[21],g[23]); // <5762
  ff[88]=_mm256_add_epi16(f[24],f[26]); // <5762
  gg[88]=_mm256_add_epi16(g[24],g[26]); // <5762
  ff[89]=_mm256_add_epi16(f[25],f[27]); // <5762
  gg[89]=_mm256_add_epi16(g[25],g[27]); // <5762
  ff[90]=_mm256_add_epi16(f[28],f[30]); // <5762
  gg[90]=_mm256_add_epi16(g[28],g[30]); // <5762
  ff[91]=_mm256_add_epi16(f[29],f[31]); // <5762
  gg[91]=_mm256_add_epi16(g[29],g[31]); // <5762
  ff[92]=_mm256_add_epi16(ff[0],ff[2]); // <11524
  gg[92]=_mm256_add_epi16(gg[0],gg[2]); // <11524
  ff[93]=_mm256_add_epi16(ff[1],ff[3]); // <11524
  gg[93]=_mm256_add_epi16(gg[1],gg[3]); // <11524
  ff[94]=_mm256_add_epi16(ff[4],ff[6]); // <11524
  gg[94]=_mm256_add_epi16(gg[4],gg[6]); // <11524
  ff[95]=_mm256_add_epi16(ff[5],ff[7]); // <11524
  gg[95]=_mm256_add_epi16(gg[5],gg[7]); // <11524
  ff[96]=_mm256_add_epi16(ff[8],ff[10]); // <11524
  gg[96]=_mm256_add_epi16(gg[8],gg[10]); // <11524
  ff[97]=_mm256_add_epi16(ff[9],ff[11]); // <11524
  gg[97]=_mm256_add_epi16(gg[9],gg[11]); // <11524
  ff[98]=_mm256_add_epi16(ff[12],ff[14]); // <11524
  gg[98]=_mm256_add_epi16(gg[12],gg[14]); // <11524
  ff[99]=_mm256_add_epi16(ff[13],ff[15]); // <11524
  gg[99]=_mm256_add_epi16(gg[13],gg[15]); // <11524
  ff[100]=_mm256_add_epi16(ff[16],ff[18]); // <11524
  gg[100]=_mm256_add_epi16(gg[16],gg[18]); // <11524
  ff[101]=_mm256_add_epi16(ff[17],ff[19]); // <11524
  gg[101]=_mm256_add_epi16(gg[17],gg[19]); // <11524
  ff[102]=_mm256_add_epi16(ff[20],ff[22]); // <11524
  gg[102]=_mm256_add_epi16(gg[20],gg[22]); // <11524
  ff[103]=_mm256_add_epi16(ff[21],ff[23]); // <11524
  gg[103]=_mm256_add_epi16(gg[21],gg[23]); // <11524
  ff[104]=_mm256_add_epi16(ff[24],ff[26]); // <11524
  gg[104]=_mm256_add_epi16(gg[24],gg[26]); // <11524
  ff[105]=_mm256_add_epi16(ff[25],ff[27]); // <11524
  gg[105]=_mm256_add_epi16(gg[25],gg[27]); // <11524
  ff[106]=_mm256_add_epi16(ff[28],ff[30]); // <11524
  gg[106]=_mm256_add_epi16(gg[28],gg[30]); // <11524
  ff[107]=_mm256_add_epi16(ff[29],ff[31]); // <11524
  gg[107]=_mm256_add_epi16(gg[29],gg[31]); // <11524
  ff[108]=_mm256_add_epi16(ff[32],ff[34]); // <23048
  gg[108]=_mm256_add_epi16(gg[32],gg[34]); // <23048
  ff[109]=_mm256_add_epi16(ff[33],ff[35]); // <23048
  gg[109]=_mm256_add_epi16(gg[33],gg[35]); // <23048
  ff[110]=_mm256_add_epi16(ff[36],ff[38]); // <23048
  gg[110]=_mm256_add_epi16(gg[36],gg[38]); // <23048
  ff[111]=_mm256_add_epi16(ff[37],ff[39]); // <23048
  gg[111]=_mm256_add_epi16(gg[37],gg[39]); // <23048
  ff[112]=_mm256_add_epi16(ff[40],ff[42]); // <11524
  gg[112]=_mm256_add_epi16(gg[40],gg[42]); // <11524
  ff[113]=_mm256_add_epi16(ff[41],ff[43]); // <11524
  gg[113]=_mm256_add_epi16(gg[41],gg[43]); // <11524
  ff[114]=_mm256_add_epi16(ff[44],ff[46]); // <11524
  gg[114]=_mm256_add_epi16(gg[44],gg[46]); // <11524
  ff[115]=_mm256_add_epi16(ff[45],ff[47]); // <11524
  gg[115]=_mm256_add_epi16(gg[45],gg[47]); // <11524
  ff[116]=_mm256_add_epi16(ff[48],ff[50]); // <11524
  gg[116]=_mm256_add_epi16(gg[48],gg[50]); // <11524
  ff[117]=_mm256_add_epi16(ff[49],ff[51]); // <11524
  gg[117]=_mm256_add_epi16(gg[49],gg[51]); // <11524
  ff[118]=_mm256_add_epi16(ff[52],ff[54]); // <11524
  gg[118]=_mm256_add_epi16(gg[52],gg[54]); // <11524
  ff[119]=_mm256_add_epi16(ff[53],ff[55]); // <11524
  gg[119]=_mm256_add_epi16(gg[53],gg[55]); // <11524
  ff[120]=_mm256_add_epi16(ff[56],ff[58]); // <23048
  gg[120]=_mm256_add_epi16(gg[56],gg[58]); // <23048
  ff[121]=_mm256_add_epi16(ff[57],ff[59]); // <23048
  gg[121]=_mm256_add_epi16(gg[57],gg[59]); // <23048
  ff[122]=_mm256_add_epi16(ff[60],ff[62]); // <23048
  gg[122]=_mm256_add_epi16(gg[60],gg[62]); // <23048
  ff[123]=_mm256_add_epi16(ff[61],ff[63]); // <23048
  gg[123]=_mm256_add_epi16(gg[61],gg[63]); // <23048
  ff[124]=_mm256_add_epi16(ff[64],ff[66]); // <23048
  gg[124]=_mm256_add_epi16(gg[64],gg[66]); // <23048
  ff[125]=_mm256_add_epi16(ff[65],ff[67]); // <23048
  gg[125]=_mm256_add_epi16(gg[65],gg[67]); // <23048
  ff[126]=_mm256_add_epi16(ff[68],ff[70]); // <23048
  gg[126]=_mm256_add_epi16(gg[68],gg[70]); // <23048
  ff[127]=_mm256_add_epi16(ff[69],ff[71]); // <23048
  gg[127]=_mm256_add_epi16(gg[69],gg[71]); // <23048
  ff[128]=_mm256_add_epi16(ff[72],ff[74]); // <4680
  gg[128]=_mm256_add_epi16(gg[72],gg[74]); // <4680
  ff[129]=_mm256_add_epi16(ff[73],ff[75]); // <4680
  gg[129]=_mm256_add_epi16(gg[73],gg[75]); // <4680

  ff[32] = barrett_fake(ff[32]); // <2430
  gg[32] = barrett_fake(gg[32]); // <2430
  ff[33] = barrett_fake(ff[33]); // <2340
  gg[33] = barrett_fake(gg[33]); // <2340
  ff[34] = barrett_fake(ff[34]); // <2430
  gg[34] = barrett_fake(gg[34]); // <2430
  ff[35] = barrett_fake(ff[35]); // <2340
  gg[35] = barrett_fake(gg[35]); // <2340
  ff[36] = barrett_fake(ff[36]); // <2430
  gg[36] = barrett_fake(gg[36]); // <2430
  ff[37] = barrett_fake(ff[37]); // <2340
  gg[37] = barrett_fake(gg[37]); // <2340
  ff[38] = barrett_fake(ff[38]); // <2430
  gg[38] = barrett_fake(gg[38]); // <2430
  ff[39] = barrett_fake(ff[39]); // <2340
  gg[39] = barrett_fake(gg[39]); // <2340
  ff[56] = barrett_fake(ff[56]); // <2430
  gg[56] = barrett_fake(gg[56]); // <2430
  ff[57] = barrett_fake(ff[57]); // <2340
  gg[57] = barrett_fake(gg[57]); // <2340
  ff[58] = barrett_fake(ff[58]); // <2430
  gg[58] = barrett_fake(gg[58]); // <2430
  ff[59] = barrett_fake(ff[59]); // <2340
  gg[59] = barrett_fake(gg[59]); // <2340
  ff[60] = barrett_fake(ff[60]); // <2430
  gg[60] = barrett_fake(gg[60]); // <2430
  ff[61] = barrett_fake(ff[61]); // <2340
  gg[61] = barrett_fake(gg[61]); // <2340
  ff[62] = barrett_fake(ff[62]); // <2430
  gg[62] = barrett_fake(gg[62]); // <2430
  ff[63] = barrett_fake(ff[63]); // <2340
  gg[63] = barrett_fake(gg[63]); // <2340
  ff[64] = barrett_fake(ff[64]); // <2430
  gg[64] = barrett_fake(gg[64]); // <2430
  ff[65] = barrett_fake(ff[65]); // <2340
  gg[65] = barrett_fake(gg[65]); // <2340
  ff[66] = barrett_fake(ff[66]); // <2430
  gg[66] = barrett_fake(gg[66]); // <2430
  ff[67] = barrett_fake(ff[67]); // <2340
  gg[67] = barrett_fake(gg[67]); // <2340
  ff[68] = barrett_fake(ff[68]); // <2430
  gg[68] = barrett_fake(gg[68]); // <2430
  ff[69] = barrett_fake(ff[69]); // <2340
  gg[69] = barrett_fake(gg[69]); // <2340
  ff[70] = barrett_fake(ff[70]); // <2430
  gg[70] = barrett_fake(gg[70]); // <2430
  ff[71] = barrett_fake(ff[71]); // <2340
  gg[71] = barrett_fake(gg[71]); // <2340
  ff[92] = barrett_fake(ff[92]); // <2430
  gg[92] = barrett_fake(gg[92]); // <2430
  ff[93] = barrett_fake(ff[93]); // <2340
  gg[93] = barrett_fake(gg[93]); // <2340
  ff[94] = barrett_fake(ff[94]); // <2430
  gg[94] = barrett_fake(gg[94]); // <2430
  ff[95] = barrett_fake(ff[95]); // <2340
  gg[95] = barrett_fake(gg[95]); // <2340
  ff[96] = barrett_fake(ff[96]); // <2430
  gg[96] = barrett_fake(gg[96]); // <2430
  ff[97] = barrett_fake(ff[97]); // <2340
  gg[97] = barrett_fake(gg[97]); // <2340
  ff[98] = barrett_fake(ff[98]); // <2430
  gg[98] = barrett_fake(gg[98]); // <2430
  ff[99] = barrett_fake(ff[99]); // <2340
  gg[99] = barrett_fake(gg[99]); // <2340
  ff[100] = barrett_fake(ff[100]); // <2430
  gg[100] = barrett_fake(gg[100]); // <2430
  ff[101] = barrett_fake(ff[101]); // <2340
  gg[101] = barrett_fake(gg[101]); // <2340
  ff[102] = barrett_fake(ff[102]); // <2430
  gg[102] = barrett_fake(gg[102]); // <2430
  ff[103] = barrett_fake(ff[103]); // <2340
  gg[103] = barrett_fake(gg[103]); // <2340
  ff[104] = barrett_fake(ff[104]); // <2430
  gg[104] = barrett_fake(gg[104]); // <2430
  ff[105] = barrett_fake(ff[105]); // <2340
  gg[105] = barrett_fake(gg[105]); // <2340
  ff[106] = barrett_fake(ff[106]); // <2430
  gg[106] = barrett_fake(gg[106]); // <2430
  ff[107] = barrett_fake(ff[107]); // <2340
  gg[107] = barrett_fake(gg[107]); // <2340
  ff[108] = barrett_fake(ff[108]); // <2701
  gg[108] = barrett_fake(gg[108]); // <2701
  ff[109] = barrett_fake(ff[109]); // <2340
  gg[109] = barrett_fake(gg[109]); // <2340
  ff[110] = barrett_fake(ff[110]); // <2701
  gg[110] = barrett_fake(gg[110]); // <2701
  ff[111] = barrett_fake(ff[111]); // <2340
  gg[111] = barrett_fake(gg[111]); // <2340
  ff[112] = barrett_fake(ff[112]); // <2430
  gg[112] = barrett_fake(gg[112]); // <2430
  ff[113] = barrett_fake(ff[113]); // <2340
  gg[113] = barrett_fake(gg[113]); // <2340
  ff[114] = barrett_fake(ff[114]); // <2430
  gg[114] = barrett_fake(gg[114]); // <2430
  ff[115] = barrett_fake(ff[115]); // <2340
  gg[115] = barrett_fake(gg[115]); // <2340
  ff[116] = barrett_fake(ff[116]); // <2430
  gg[116] = barrett_fake(gg[116]); // <2430
  ff[117] = barrett_fake(ff[117]); // <2340
  gg[117] = barrett_fake(gg[117]); // <2340
  ff[118] = barrett_fake(ff[118]); // <2430
  gg[118] = barrett_fake(gg[118]); // <2430
  ff[119] = barrett_fake(ff[119]); // <2340
  gg[119] = barrett_fake(gg[119]); // <2340
  ff[120] = barrett_fake(ff[120]); // <2701
  gg[120] = barrett_fake(gg[120]); // <2701
  ff[121] = barrett_fake(ff[121]); // <2340
  gg[121] = barrett_fake(gg[121]); // <2340
  ff[122] = barrett_fake(ff[122]); // <2701
  gg[122] = barrett_fake(gg[122]); // <2701
  ff[123] = barrett_fake(ff[123]); // <2340
  gg[123] = barrett_fake(gg[123]); // <2340
  ff[124] = barrett_fake(ff[124]); // <2701
  gg[124] = barrett_fake(gg[124]); // <2701
  ff[125] = barrett_fake(ff[125]); // <2340
  gg[125] = barrett_fake(gg[125]); // <2340
  ff[126] = barrett_fake(ff[126]); // <2701
  gg[126] = barrett_fake(gg[126]); // <2701
  ff[127] = barrett_fake(ff[127]); // <2340
  gg[127] = barrett_fake(gg[127]); // <2340
  gf_polymul_32x32_avx2_divR((h + 0),(g + 0),(f + 0));
  // h[0] <= 4321 h[1] <= 6347 h[2] <= 6221 h[3] <= 4194
  gf_polymul_32x32_avx2_divR((h + 4),(g + 2),(f + 2));
  // h[4] <= 4321 h[5] <= 6347 h[6] <= 6221 h[7] <= 4194
  gf_polymul_32x32_avx2_divR((h + 8),(g + 4),(f + 4));
  // h[8] <= 4321 h[9] <= 6347 h[10] <= 6221 h[11] <= 4194
  gf_polymul_32x32_avx2_divR((h + 12),(g + 6),(f + 6));
  // h[12] <= 4321 h[13] <= 6347 h[14] <= 6221 h[15] <= 4194
  gf_polymul_32x32_avx2_divR((h + 16),(g + 8),(f + 8));
  // h[16] <= 4321 h[17] <= 6347 h[18] <= 6221 h[19] <= 4194
  gf_polymul_32x32_avx2_divR((h + 20),(g + 10),(f + 10));
  // h[20] <= 4321 h[21] <= 6347 h[22] <= 6221 h[23] <= 4194
  gf_polymul_32x32_avx2_divR((h + 24),(g + 12),(f + 12));
  // h[24] <= 4321 h[25] <= 6347 h[26] <= 6221 h[27] <= 4194
  gf_polymul_32x32_avx2_divR((h + 28),(g + 14),(f + 14));
  // h[28] <= 4321 h[29] <= 6347 h[30] <= 6221 h[31] <= 4194
  gf_polymul_32x32_avx2_divR((h + 32),(g + 16),(f + 16));
  // h[32] <= 4321 h[33] <= 6347 h[34] <= 6221 h[35] <= 4194
  gf_polymul_32x32_avx2_divR((h + 36),(g + 18),(f + 18));
  // h[36] <= 4321 h[37] <= 6347 h[38] <= 6221 h[39] <= 4194
  gf_polymul_32x32_avx2_divR((h + 40),(g + 20),(f + 20));
  // h[40] <= 4321 h[41] <= 6347 h[42] <= 6221 h[43] <= 4194
  gf_polymul_32x32_avx2_divR((h + 44),(g + 22),(f + 22));
  // h[44] <= 4321 h[45] <= 6347 h[46] <= 6221 h[47] <= 4194
  gf_polymul_32x32_avx2_divR((h + 48),(g + 24),(f + 24));
  // h[48] <= 4321 h[49] <= 6347 h[50] <= 6221 h[51] <= 4194
  gf_polymul_32x32_avx2_divR((h + 52),(g + 26),(f + 26));
  // h[52] <= 4321 h[53] <= 6347 h[54] <= 6221 h[55] <= 4194
  gf_polymul_32x32_avx2_divR((h + 56),(g + 28),(f + 28));
  // h[56] <= 4321 h[57] <= 6347 h[58] <= 6221 h[59] <= 4194
  gf_polymul_32x32_avx2_divR((h + 60),(g + 30),(f + 30));
  // h[60] <= 4321 h[61] <= 6347 h[62] <= 6221 h[63] <= 4194
  gf_polymul_32x32_avx2_divR((hh + 0),(gg + 0),(ff + 0));
  // hh[0] <= 10400 hh[1] <= 18506 hh[2] <= 17999 hh[3] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 4),(gg + 2),(ff + 2));
  // hh[4] <= 10400 hh[5] <= 18506 hh[6] <= 17999 hh[7] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 8),(gg + 4),(ff + 4));
  // hh[8] <= 10400 hh[9] <= 18506 hh[10] <= 17999 hh[11] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 12),(gg + 6),(ff + 6));
  // hh[12] <= 10400 hh[13] <= 18506 hh[14] <= 17999 hh[15] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 16),(gg + 8),(ff + 8));
  // hh[16] <= 10400 hh[17] <= 18506 hh[18] <= 17999 hh[19] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 20),(gg + 10),(ff + 10));
  // hh[20] <= 10400 hh[21] <= 18506 hh[22] <= 17999 hh[23] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 24),(gg + 12),(ff + 12));
  // hh[24] <= 10400 hh[25] <= 18506 hh[26] <= 17999 hh[27] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 28),(gg + 14),(ff + 14));
  // hh[28] <= 10400 hh[29] <= 18506 hh[30] <= 17999 hh[31] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 32),(gg + 16),(ff + 16));
  // hh[32] <= 10400 hh[33] <= 18506 hh[34] <= 17999 hh[35] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 36),(gg + 18),(ff + 18));
  // hh[36] <= 10400 hh[37] <= 18506 hh[38] <= 17999 hh[39] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 40),(gg + 20),(ff + 20));
  // hh[40] <= 10400 hh[41] <= 18506 hh[42] <= 17999 hh[43] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 44),(gg + 22),(ff + 22));
  // hh[44] <= 10400 hh[45] <= 18506 hh[46] <= 17999 hh[47] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 48),(gg + 24),(ff + 24));
  // hh[48] <= 10400 hh[49] <= 18506 hh[50] <= 17999 hh[51] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 52),(gg + 26),(ff + 26));
  // hh[52] <= 10400 hh[53] <= 18506 hh[54] <= 17999 hh[55] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 56),(gg + 28),(ff + 28));
  // hh[56] <= 10400 hh[57] <= 18506 hh[58] <= 17999 hh[59] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 60),(gg + 30),(ff + 30));
  // hh[60] <= 10400 hh[61] <= 18506 hh[62] <= 17999 hh[63] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 64),(gg + 32),(ff + 32));
  // hh[64] <= 3736 hh[65] <= 5178 hh[66] <= 5088 hh[67] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 68),(gg + 34),(ff + 34));
  // hh[68] <= 3736 hh[69] <= 5178 hh[70] <= 5088 hh[71] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 72),(gg + 36),(ff + 36));
  // hh[72] <= 3736 hh[73] <= 5178 hh[74] <= 5088 hh[75] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 76),(gg + 38),(ff + 38));
  // hh[76] <= 3736 hh[77] <= 5178 hh[78] <= 5088 hh[79] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 80),(gg + 40),(ff + 40));
  // hh[80] <= 10400 hh[81] <= 18506 hh[82] <= 17999 hh[83] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 84),(gg + 42),(ff + 42));
  // hh[84] <= 10400 hh[85] <= 18506 hh[86] <= 17999 hh[87] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 88),(gg + 44),(ff + 44));
  // hh[88] <= 10400 hh[89] <= 18506 hh[90] <= 17999 hh[91] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 92),(gg + 46),(ff + 46));
  // hh[92] <= 10400 hh[93] <= 18506 hh[94] <= 17999 hh[95] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 96),(gg + 48),(ff + 48));
  // hh[96] <= 10400 hh[97] <= 18506 hh[98] <= 17999 hh[99] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 100),(gg + 50),(ff + 50));
  // hh[100] <= 10400 hh[101] <= 18506 hh[102] <= 17999 hh[103] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 104),(gg + 52),(ff + 52));
  // hh[104] <= 10400 hh[105] <= 18506 hh[106] <= 17999 hh[107] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 108),(gg + 54),(ff + 54));
  // hh[108] <= 10400 hh[109] <= 18506 hh[110] <= 17999 hh[111] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 112),(gg + 56),(ff + 56));
  // hh[112] <= 3736 hh[113] <= 5178 hh[114] <= 5088 hh[115] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 116),(gg + 58),(ff + 58));
  // hh[116] <= 3736 hh[117] <= 5178 hh[118] <= 5088 hh[119] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 120),(gg + 60),(ff + 60));
  // hh[120] <= 3736 hh[121] <= 5178 hh[122] <= 5088 hh[123] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 124),(gg + 62),(ff + 62));
  // hh[124] <= 3736 hh[125] <= 5178 hh[126] <= 5088 hh[127] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 128),(gg + 64),(ff + 64));
  // hh[128] <= 3736 hh[129] <= 5178 hh[130] <= 5088 hh[131] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 132),(gg + 66),(ff + 66));
  // hh[132] <= 3736 hh[133] <= 5178 hh[134] <= 5088 hh[135] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 136),(gg + 68),(ff + 68));
  // hh[136] <= 3736 hh[137] <= 5178 hh[138] <= 5088 hh[139] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 140),(gg + 70),(ff + 70));
  // hh[140] <= 3736 hh[141] <= 5178 hh[142] <= 5088 hh[143] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 144),(gg + 72),(ff + 72));
  // hh[144] <= 3631 hh[145] <= 4968 hh[146] <= 4885 hh[147] <= 3548
  gf_polymul_32x32_avx2_divR((hh + 148),(gg + 74),(ff + 74));
  // hh[148] <= 3631 hh[149] <= 4968 hh[150] <= 4885 hh[151] <= 3548
  gf_polymul_32x32_avx2_divR((hh + 152),(gg + 76),(ff + 76));
  // hh[152] <= 10400 hh[153] <= 18506 hh[154] <= 17999 hh[155] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 156),(gg + 78),(ff + 78));
  // hh[156] <= 10400 hh[157] <= 18506 hh[158] <= 17999 hh[159] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 160),(gg + 80),(ff + 80));
  // hh[160] <= 10400 hh[161] <= 18506 hh[162] <= 17999 hh[163] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 164),(gg + 82),(ff + 82));
  // hh[164] <= 10400 hh[165] <= 18506 hh[166] <= 17999 hh[167] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 168),(gg + 84),(ff + 84));
  // hh[168] <= 10400 hh[169] <= 18506 hh[170] <= 17999 hh[171] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 172),(gg + 86),(ff + 86));
  // hh[172] <= 10400 hh[173] <= 18506 hh[174] <= 17999 hh[175] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 176),(gg + 88),(ff + 88));
  // hh[176] <= 10400 hh[177] <= 18506 hh[178] <= 17999 hh[179] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 180),(gg + 90),(ff + 90));
  // hh[180] <= 10400 hh[181] <= 18506 hh[182] <= 17999 hh[183] <= 9894
  gf_polymul_32x32_avx2_divR((hh + 184),(gg + 92),(ff + 92));
  // hh[184] <= 3736 hh[185] <= 5178 hh[186] <= 5088 hh[187] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 188),(gg + 94),(ff + 94));
  // hh[188] <= 3736 hh[189] <= 5178 hh[190] <= 5088 hh[191] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 192),(gg + 96),(ff + 96));
  // hh[192] <= 3736 hh[193] <= 5178 hh[194] <= 5088 hh[195] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 196),(gg + 98),(ff + 98));
  // hh[196] <= 3736 hh[197] <= 5178 hh[198] <= 5088 hh[199] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 200),(gg + 100),(ff + 100));
  // hh[200] <= 3736 hh[201] <= 5178 hh[202] <= 5088 hh[203] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 204),(gg + 102),(ff + 102));
  // hh[204] <= 3736 hh[205] <= 5178 hh[206] <= 5088 hh[207] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 208),(gg + 104),(ff + 104));
  // hh[208] <= 3736 hh[209] <= 5178 hh[210] <= 5088 hh[211] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 212),(gg + 106),(ff + 106));
  // hh[212] <= 3736 hh[213] <= 5178 hh[214] <= 5088 hh[215] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 216),(gg + 108),(ff + 108));
  // hh[216] <= 4076 hh[217] <= 5857 hh[218] <= 5745 hh[219] <= 3964
  gf_polymul_32x32_avx2_divR((hh + 220),(gg + 110),(ff + 110));
  // hh[220] <= 4076 hh[221] <= 5857 hh[222] <= 5745 hh[223] <= 3964
  gf_polymul_32x32_avx2_divR((hh + 224),(gg + 112),(ff + 112));
  // hh[224] <= 3736 hh[225] <= 5178 hh[226] <= 5088 hh[227] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 228),(gg + 114),(ff + 114));
  // hh[228] <= 3736 hh[229] <= 5178 hh[230] <= 5088 hh[231] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 232),(gg + 116),(ff + 116));
  // hh[232] <= 3736 hh[233] <= 5178 hh[234] <= 5088 hh[235] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 236),(gg + 118),(ff + 118));
  // hh[236] <= 3736 hh[237] <= 5178 hh[238] <= 5088 hh[239] <= 3646
  gf_polymul_32x32_avx2_divR((hh + 240),(gg + 120),(ff + 120));
  // hh[240] <= 4076 hh[241] <= 5857 hh[242] <= 5745 hh[243] <= 3964
  gf_polymul_32x32_avx2_divR((hh + 244),(gg + 122),(ff + 122));
  // hh[244] <= 4076 hh[245] <= 5857 hh[246] <= 5745 hh[247] <= 3964
  gf_polymul_32x32_avx2_divR((hh + 248),(gg + 124),(ff + 124));
  // hh[248] <= 4076 hh[249] <= 5857 hh[250] <= 5745 hh[251] <= 3964
  gf_polymul_32x32_avx2_divR((hh + 252),(gg + 126),(ff + 126));
  // hh[252] <= 4076 hh[253] <= 5857 hh[254] <= 5745 hh[255] <= 3964
  gf_polymul_32x32_avx2_divR((hh + 256),(gg + 128),(ff + 128));
  // hh[256] <= 7642 hh[257] <= 12989 hh[258] <= 12655 hh[259] <= 7308

  hh[0] = barrett_fake(hh[0]); // <2430
  hh[1] = barrett_fake(hh[1]); // <2610
  hh[2] = barrett_fake(hh[2]); // <2610
  hh[3] = barrett_fake(hh[3]); // <2430
  hh[4] = barrett_fake(hh[4]); // <2430
  hh[5] = barrett_fake(hh[5]); // <2610
  hh[6] = barrett_fake(hh[6]); // <2610
  hh[7] = barrett_fake(hh[7]); // <2430
  hh[8] = barrett_fake(hh[8]); // <2430
  hh[9] = barrett_fake(hh[9]); // <2610
  hh[10] = barrett_fake(hh[10]); // <2610
  hh[11] = barrett_fake(hh[11]); // <2430
  hh[12] = barrett_fake(hh[12]); // <2430
  hh[13] = barrett_fake(hh[13]); // <2610
  hh[14] = barrett_fake(hh[14]); // <2610
  hh[15] = barrett_fake(hh[15]); // <2430
  hh[16] = barrett_fake(hh[16]); // <2430
  hh[17] = barrett_fake(hh[17]); // <2610
  hh[18] = barrett_fake(hh[18]); // <2610
  hh[19] = barrett_fake(hh[19]); // <2430
  hh[20] = barrett_fake(hh[20]); // <2430
  hh[21] = barrett_fake(hh[21]); // <2610
  hh[22] = barrett_fake(hh[22]); // <2610
  hh[23] = barrett_fake(hh[23]); // <2430
  hh[24] = barrett_fake(hh[24]); // <2430
  hh[25] = barrett_fake(hh[25]); // <2610
  hh[26] = barrett_fake(hh[26]); // <2610
  hh[27] = barrett_fake(hh[27]); // <2430
  hh[28] = barrett_fake(hh[28]); // <2430
  hh[29] = barrett_fake(hh[29]); // <2610
  hh[30] = barrett_fake(hh[30]); // <2610
  hh[31] = barrett_fake(hh[31]); // <2430
  hh[32] = barrett_fake(hh[32]); // <2430
  hh[33] = barrett_fake(hh[33]); // <2610
  hh[34] = barrett_fake(hh[34]); // <2610
  hh[35] = barrett_fake(hh[35]); // <2430
  hh[36] = barrett_fake(hh[36]); // <2430
  hh[37] = barrett_fake(hh[37]); // <2610
  hh[38] = barrett_fake(hh[38]); // <2610
  hh[39] = barrett_fake(hh[39]); // <2430
  hh[40] = barrett_fake(hh[40]); // <2430
  hh[41] = barrett_fake(hh[41]); // <2610
  hh[42] = barrett_fake(hh[42]); // <2610
  hh[43] = barrett_fake(hh[43]); // <2430
  hh[44] = barrett_fake(hh[44]); // <2430
  hh[45] = barrett_fake(hh[45]); // <2610
  hh[46] = barrett_fake(hh[46]); // <2610
  hh[47] = barrett_fake(hh[47]); // <2430
  hh[48] = barrett_fake(hh[48]); // <2430
  hh[49] = barrett_fake(hh[49]); // <2610
  hh[50] = barrett_fake(hh[50]); // <2610
  hh[51] = barrett_fake(hh[51]); // <2430
  hh[52] = barrett_fake(hh[52]); // <2430
  hh[53] = barrett_fake(hh[53]); // <2610
  hh[54] = barrett_fake(hh[54]); // <2610
  hh[55] = barrett_fake(hh[55]); // <2430
  hh[56] = barrett_fake(hh[56]); // <2430
  hh[57] = barrett_fake(hh[57]); // <2610
  hh[58] = barrett_fake(hh[58]); // <2610
  hh[59] = barrett_fake(hh[59]); // <2430
  hh[60] = barrett_fake(hh[60]); // <2430
  hh[61] = barrett_fake(hh[61]); // <2610
  hh[62] = barrett_fake(hh[62]); // <2610
  hh[63] = barrett_fake(hh[63]); // <2430
  hh[80] = barrett_fake(hh[80]); // <2430
  hh[81] = barrett_fake(hh[81]); // <2610
  hh[82] = barrett_fake(hh[82]); // <2610
  hh[83] = barrett_fake(hh[83]); // <2430
  hh[84] = barrett_fake(hh[84]); // <2430
  hh[85] = barrett_fake(hh[85]); // <2610
  hh[86] = barrett_fake(hh[86]); // <2610
  hh[87] = barrett_fake(hh[87]); // <2430
  hh[88] = barrett_fake(hh[88]); // <2430
  hh[89] = barrett_fake(hh[89]); // <2610
  hh[90] = barrett_fake(hh[90]); // <2610
  hh[91] = barrett_fake(hh[91]); // <2430
  hh[92] = barrett_fake(hh[92]); // <2430
  hh[93] = barrett_fake(hh[93]); // <2610
  hh[94] = barrett_fake(hh[94]); // <2610
  hh[95] = barrett_fake(hh[95]); // <2430
  hh[96] = barrett_fake(hh[96]); // <2430
  hh[97] = barrett_fake(hh[97]); // <2610
  hh[98] = barrett_fake(hh[98]); // <2610
  hh[99] = barrett_fake(hh[99]); // <2430
  hh[100] = barrett_fake(hh[100]); // <2430
  hh[101] = barrett_fake(hh[101]); // <2610
  hh[102] = barrett_fake(hh[102]); // <2610
  hh[103] = barrett_fake(hh[103]); // <2430
  hh[104] = barrett_fake(hh[104]); // <2430
  hh[105] = barrett_fake(hh[105]); // <2610
  hh[106] = barrett_fake(hh[106]); // <2610
  hh[107] = barrett_fake(hh[107]); // <2430
  hh[108] = barrett_fake(hh[108]); // <2430
  hh[109] = barrett_fake(hh[109]); // <2610
  hh[110] = barrett_fake(hh[110]); // <2610
  hh[111] = barrett_fake(hh[111]); // <2430
  hh[152] = barrett_fake(hh[152]); // <2430
  hh[153] = barrett_fake(hh[153]); // <2610
  hh[154] = barrett_fake(hh[154]); // <2610
  hh[155] = barrett_fake(hh[155]); // <2430
  hh[156] = barrett_fake(hh[156]); // <2430
  hh[157] = barrett_fake(hh[157]); // <2610
  hh[158] = barrett_fake(hh[158]); // <2610
  hh[159] = barrett_fake(hh[159]); // <2430
  hh[160] = barrett_fake(hh[160]); // <2430
  hh[161] = barrett_fake(hh[161]); // <2610
  hh[162] = barrett_fake(hh[162]); // <2610
  hh[163] = barrett_fake(hh[163]); // <2430
  hh[164] = barrett_fake(hh[164]); // <2430
  hh[165] = barrett_fake(hh[165]); // <2610
  hh[166] = barrett_fake(hh[166]); // <2610
  hh[167] = barrett_fake(hh[167]); // <2430
  hh[168] = barrett_fake(hh[168]); // <2430
  hh[169] = barrett_fake(hh[169]); // <2610
  hh[170] = barrett_fake(hh[170]); // <2610
  hh[171] = barrett_fake(hh[171]); // <2430
  hh[172] = barrett_fake(hh[172]); // <2430
  hh[173] = barrett_fake(hh[173]); // <2610
  hh[174] = barrett_fake(hh[174]); // <2610
  hh[175] = barrett_fake(hh[175]); // <2430
  hh[176] = barrett_fake(hh[176]); // <2430
  hh[177] = barrett_fake(hh[177]); // <2610
  hh[178] = barrett_fake(hh[178]); // <2610
  hh[179] = barrett_fake(hh[179]); // <2430
  hh[180] = barrett_fake(hh[180]); // <2430
  hh[181] = barrett_fake(hh[181]); // <2610
  hh[182] = barrett_fake(hh[182]); // <2610
  hh[183] = barrett_fake(hh[183]); // <2430
  t[0] = _mm256_sub_epi16(h[2],h[4]); // <10542
  t[1] = _mm256_sub_epi16(h[3],h[5]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[6]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[7]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[0]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[1]); // <16888
  h[4] = _mm256_sub_epi16(hh[154],t[2]); // <19373
  h[5] = _mm256_sub_epi16(hh[155],t[3]); // <17165
  h[2] = _mm256_add_epi16(hh[152],t[0]); // <17293
  h[3] = _mm256_add_epi16(hh[153],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[10],h[12]); // <10542
  t[1] = _mm256_sub_epi16(h[11],h[13]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[14]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[15]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[8]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[9]); // <16888
  h[12] = _mm256_sub_epi16(hh[158],t[2]); // <19373
  h[13] = _mm256_sub_epi16(hh[159],t[3]); // <17165
  h[10] = _mm256_add_epi16(hh[156],t[0]); // <17293
  h[11] = _mm256_add_epi16(hh[157],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[18],h[20]); // <10542
  t[1] = _mm256_sub_epi16(h[19],h[21]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[22]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[23]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[16]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[17]); // <16888
  h[20] = _mm256_sub_epi16(hh[162],t[2]); // <19373
  h[21] = _mm256_sub_epi16(hh[163],t[3]); // <17165
  h[18] = _mm256_add_epi16(hh[160],t[0]); // <17293
  h[19] = _mm256_add_epi16(hh[161],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[26],h[28]); // <10542
  t[1] = _mm256_sub_epi16(h[27],h[29]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[30]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[31]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[24]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[25]); // <16888
  h[28] = _mm256_sub_epi16(hh[166],t[2]); // <19373
  h[29] = _mm256_sub_epi16(hh[167],t[3]); // <17165
  h[26] = _mm256_add_epi16(hh[164],t[0]); // <17293
  h[27] = _mm256_add_epi16(hh[165],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[34],h[36]); // <10542
  t[1] = _mm256_sub_epi16(h[35],h[37]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[38]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[39]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[32]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[33]); // <16888
  h[36] = _mm256_sub_epi16(hh[170],t[2]); // <19373
  h[37] = _mm256_sub_epi16(hh[171],t[3]); // <17165
  h[34] = _mm256_add_epi16(hh[168],t[0]); // <17293
  h[35] = _mm256_add_epi16(hh[169],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[42],h[44]); // <10542
  t[1] = _mm256_sub_epi16(h[43],h[45]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[46]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[47]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[40]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[41]); // <16888
  h[44] = _mm256_sub_epi16(hh[174],t[2]); // <19373
  h[45] = _mm256_sub_epi16(hh[175],t[3]); // <17165
  h[42] = _mm256_add_epi16(hh[172],t[0]); // <17293
  h[43] = _mm256_add_epi16(hh[173],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[50],h[52]); // <10542
  t[1] = _mm256_sub_epi16(h[51],h[53]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[54]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[55]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[48]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[49]); // <16888
  h[52] = _mm256_sub_epi16(hh[178],t[2]); // <19373
  h[53] = _mm256_sub_epi16(hh[179],t[3]); // <17165
  h[50] = _mm256_add_epi16(hh[176],t[0]); // <17293
  h[51] = _mm256_add_epi16(hh[177],t[1]); // <19498
  t[0] = _mm256_sub_epi16(h[58],h[60]); // <10542
  t[1] = _mm256_sub_epi16(h[59],h[61]); // <10541
  t[2] = _mm256_add_epi16(t[0],h[62]); // <16763
  t[3] = _mm256_add_epi16(t[1],h[63]); // <14735
  t[0] = _mm256_sub_epi16(t[0],h[56]); // <14863
  t[1] = _mm256_sub_epi16(t[1],h[57]); // <16888
  h[60] = _mm256_sub_epi16(hh[182],t[2]); // <19373
  h[61] = _mm256_sub_epi16(hh[183],t[3]); // <17165
  h[58] = _mm256_add_epi16(hh[180],t[0]); // <17293
  h[59] = _mm256_add_epi16(hh[181],t[1]); // <19498
  t[0] = _mm256_sub_epi16(hh[2],hh[4]); // <5040
  t[1] = _mm256_sub_epi16(hh[3],hh[5]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[6]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[7]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[0]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[1]); // <7650
  hh[4] = _mm256_sub_epi16(hh[186],t[2]); // <12738
  hh[5] = _mm256_sub_epi16(hh[187],t[3]); // <11116
  hh[2] = _mm256_add_epi16(hh[184],t[0]); // <11206
  hh[3] = _mm256_add_epi16(hh[185],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[10],hh[12]); // <5040
  t[1] = _mm256_sub_epi16(hh[11],hh[13]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[14]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[15]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[8]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[9]); // <7650
  hh[12] = _mm256_sub_epi16(hh[190],t[2]); // <12738
  hh[13] = _mm256_sub_epi16(hh[191],t[3]); // <11116
  hh[10] = _mm256_add_epi16(hh[188],t[0]); // <11206
  hh[11] = _mm256_add_epi16(hh[189],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[18],hh[20]); // <5040
  t[1] = _mm256_sub_epi16(hh[19],hh[21]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[22]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[23]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[16]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[17]); // <7650
  hh[20] = _mm256_sub_epi16(hh[194],t[2]); // <12738
  hh[21] = _mm256_sub_epi16(hh[195],t[3]); // <11116
  hh[18] = _mm256_add_epi16(hh[192],t[0]); // <11206
  hh[19] = _mm256_add_epi16(hh[193],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[26],hh[28]); // <5040
  t[1] = _mm256_sub_epi16(hh[27],hh[29]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[30]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[31]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[24]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[25]); // <7650
  hh[28] = _mm256_sub_epi16(hh[198],t[2]); // <12738
  hh[29] = _mm256_sub_epi16(hh[199],t[3]); // <11116
  hh[26] = _mm256_add_epi16(hh[196],t[0]); // <11206
  hh[27] = _mm256_add_epi16(hh[197],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[34],hh[36]); // <5040
  t[1] = _mm256_sub_epi16(hh[35],hh[37]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[38]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[39]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[32]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[33]); // <7650
  hh[36] = _mm256_sub_epi16(hh[202],t[2]); // <12738
  hh[37] = _mm256_sub_epi16(hh[203],t[3]); // <11116
  hh[34] = _mm256_add_epi16(hh[200],t[0]); // <11206
  hh[35] = _mm256_add_epi16(hh[201],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[42],hh[44]); // <5040
  t[1] = _mm256_sub_epi16(hh[43],hh[45]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[46]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[47]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[40]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[41]); // <7650
  hh[44] = _mm256_sub_epi16(hh[206],t[2]); // <12738
  hh[45] = _mm256_sub_epi16(hh[207],t[3]); // <11116
  hh[42] = _mm256_add_epi16(hh[204],t[0]); // <11206
  hh[43] = _mm256_add_epi16(hh[205],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[50],hh[52]); // <5040
  t[1] = _mm256_sub_epi16(hh[51],hh[53]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[54]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[55]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[48]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[49]); // <7650
  hh[52] = _mm256_sub_epi16(hh[210],t[2]); // <12738
  hh[53] = _mm256_sub_epi16(hh[211],t[3]); // <11116
  hh[50] = _mm256_add_epi16(hh[208],t[0]); // <11206
  hh[51] = _mm256_add_epi16(hh[209],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[58],hh[60]); // <5040
  t[1] = _mm256_sub_epi16(hh[59],hh[61]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[62]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[63]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[56]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[57]); // <7650
  hh[60] = _mm256_sub_epi16(hh[214],t[2]); // <12738
  hh[61] = _mm256_sub_epi16(hh[215],t[3]); // <11116
  hh[58] = _mm256_add_epi16(hh[212],t[0]); // <11206
  hh[59] = _mm256_add_epi16(hh[213],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[66],hh[68]); // <8824
  t[1] = _mm256_sub_epi16(hh[67],hh[69]); // <8824
  t[2] = _mm256_add_epi16(t[0],hh[70]); // <13912
  t[3] = _mm256_add_epi16(t[1],hh[71]); // <12470
  t[0] = _mm256_sub_epi16(t[0],hh[64]); // <12560
  t[1] = _mm256_sub_epi16(t[1],hh[65]); // <14002
  hh[68] = _mm256_sub_epi16(hh[218],t[2]); // <19657
  hh[69] = _mm256_sub_epi16(hh[219],t[3]); // <16434
  hh[66] = _mm256_add_epi16(hh[216],t[0]); // <16636
  hh[67] = _mm256_add_epi16(hh[217],t[1]); // <19859
  t[0] = _mm256_sub_epi16(hh[74],hh[76]); // <8824
  t[1] = _mm256_sub_epi16(hh[75],hh[77]); // <8824
  t[2] = _mm256_add_epi16(t[0],hh[78]); // <13912
  t[3] = _mm256_add_epi16(t[1],hh[79]); // <12470
  t[0] = _mm256_sub_epi16(t[0],hh[72]); // <12560
  t[1] = _mm256_sub_epi16(t[1],hh[73]); // <14002
  hh[76] = _mm256_sub_epi16(hh[222],t[2]); // <19657
  hh[77] = _mm256_sub_epi16(hh[223],t[3]); // <16434
  hh[74] = _mm256_add_epi16(hh[220],t[0]); // <16636
  hh[75] = _mm256_add_epi16(hh[221],t[1]); // <19859
  t[0] = _mm256_sub_epi16(hh[82],hh[84]); // <5040
  t[1] = _mm256_sub_epi16(hh[83],hh[85]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[86]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[87]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[80]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[81]); // <7650
  hh[84] = _mm256_sub_epi16(hh[226],t[2]); // <12738
  hh[85] = _mm256_sub_epi16(hh[227],t[3]); // <11116
  hh[82] = _mm256_add_epi16(hh[224],t[0]); // <11206
  hh[83] = _mm256_add_epi16(hh[225],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[90],hh[92]); // <5040
  t[1] = _mm256_sub_epi16(hh[91],hh[93]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[94]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[95]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[88]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[89]); // <7650
  hh[92] = _mm256_sub_epi16(hh[230],t[2]); // <12738
  hh[93] = _mm256_sub_epi16(hh[231],t[3]); // <11116
  hh[90] = _mm256_add_epi16(hh[228],t[0]); // <11206
  hh[91] = _mm256_add_epi16(hh[229],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[98],hh[100]); // <5040
  t[1] = _mm256_sub_epi16(hh[99],hh[101]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[102]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[103]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[96]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[97]); // <7650
  hh[100] = _mm256_sub_epi16(hh[234],t[2]); // <12738
  hh[101] = _mm256_sub_epi16(hh[235],t[3]); // <11116
  hh[98] = _mm256_add_epi16(hh[232],t[0]); // <11206
  hh[99] = _mm256_add_epi16(hh[233],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[106],hh[108]); // <5040
  t[1] = _mm256_sub_epi16(hh[107],hh[109]); // <5040
  t[2] = _mm256_add_epi16(t[0],hh[110]); // <7650
  t[3] = _mm256_add_epi16(t[1],hh[111]); // <7470
  t[0] = _mm256_sub_epi16(t[0],hh[104]); // <7470
  t[1] = _mm256_sub_epi16(t[1],hh[105]); // <7650
  hh[108] = _mm256_sub_epi16(hh[238],t[2]); // <12738
  hh[109] = _mm256_sub_epi16(hh[239],t[3]); // <11116
  hh[106] = _mm256_add_epi16(hh[236],t[0]); // <11206
  hh[107] = _mm256_add_epi16(hh[237],t[1]); // <12828
  t[0] = _mm256_sub_epi16(hh[114],hh[116]); // <8824
  t[1] = _mm256_sub_epi16(hh[115],hh[117]); // <8824
  t[2] = _mm256_add_epi16(t[0],hh[118]); // <13912
  t[3] = _mm256_add_epi16(t[1],hh[119]); // <12470
  t[0] = _mm256_sub_epi16(t[0],hh[112]); // <12560
  t[1] = _mm256_sub_epi16(t[1],hh[113]); // <14002
  hh[116] = _mm256_sub_epi16(hh[242],t[2]); // <19657
  hh[117] = _mm256_sub_epi16(hh[243],t[3]); // <16434
  hh[114] = _mm256_add_epi16(hh[240],t[0]); // <16636
  hh[115] = _mm256_add_epi16(hh[241],t[1]); // <19859
  t[0] = _mm256_sub_epi16(hh[122],hh[124]); // <8824
  t[1] = _mm256_sub_epi16(hh[123],hh[125]); // <8824
  t[2] = _mm256_add_epi16(t[0],hh[126]); // <13912
  t[3] = _mm256_add_epi16(t[1],hh[127]); // <12470
  t[0] = _mm256_sub_epi16(t[0],hh[120]); // <12560
  t[1] = _mm256_sub_epi16(t[1],hh[121]); // <14002
  hh[124] = _mm256_sub_epi16(hh[246],t[2]); // <19657
  hh[125] = _mm256_sub_epi16(hh[247],t[3]); // <16434
  hh[122] = _mm256_add_epi16(hh[244],t[0]); // <16636
  hh[123] = _mm256_add_epi16(hh[245],t[1]); // <19859
  t[0] = _mm256_sub_epi16(hh[130],hh[132]); // <8824
  t[1] = _mm256_sub_epi16(hh[131],hh[133]); // <8824
  t[2] = _mm256_add_epi16(t[0],hh[134]); // <13912
  t[3] = _mm256_add_epi16(t[1],hh[135]); // <12470
  t[0] = _mm256_sub_epi16(t[0],hh[128]); // <12560
  t[1] = _mm256_sub_epi16(t[1],hh[129]); // <14002
  hh[132] = _mm256_sub_epi16(hh[250],t[2]); // <19657
  hh[133] = _mm256_sub_epi16(hh[251],t[3]); // <16434
  hh[130] = _mm256_add_epi16(hh[248],t[0]); // <16636
  hh[131] = _mm256_add_epi16(hh[249],t[1]); // <19859
  t[0] = _mm256_sub_epi16(hh[138],hh[140]); // <8824
  t[1] = _mm256_sub_epi16(hh[139],hh[141]); // <8824
  t[2] = _mm256_add_epi16(t[0],hh[142]); // <13912
  t[3] = _mm256_add_epi16(t[1],hh[143]); // <12470
  t[0] = _mm256_sub_epi16(t[0],hh[136]); // <12560
  t[1] = _mm256_sub_epi16(t[1],hh[137]); // <14002
  hh[140] = _mm256_sub_epi16(hh[254],t[2]); // <19657
  hh[141] = _mm256_sub_epi16(hh[255],t[3]); // <16434
  hh[138] = _mm256_add_epi16(hh[252],t[0]); // <16636
  hh[139] = _mm256_add_epi16(hh[253],t[1]); // <19859
  t[0] = _mm256_sub_epi16(hh[146],hh[148]); // <8516
  t[1] = _mm256_sub_epi16(hh[147],hh[149]); // <8516
  t[2] = _mm256_add_epi16(t[0],hh[150]); // <13401
  t[3] = _mm256_add_epi16(t[1],hh[151]); // <12064
  t[0] = _mm256_sub_epi16(t[0],hh[144]); // <12147
  t[1] = _mm256_sub_epi16(t[1],hh[145]); // <13484
  hh[148] = _mm256_sub_epi16(hh[258],t[2]); // <26056
  hh[149] = _mm256_sub_epi16(hh[259],t[3]); // <19372
  hh[146] = _mm256_add_epi16(hh[256],t[0]); // <19789
  hh[147] = _mm256_add_epi16(hh[257],t[1]); // <26473

  h[2] = barrett_fake(h[2]); // <2610
  h[3] = barrett_fake(h[3]); // <2610
  h[4] = barrett_fake(h[4]); // <2610
  h[5] = barrett_fake(h[5]); // <2610
  h[10] = barrett_fake(h[10]); // <2610
  h[11] = barrett_fake(h[11]); // <2610
  h[12] = barrett_fake(h[12]); // <2610
  h[13] = barrett_fake(h[13]); // <2610
  h[18] = barrett_fake(h[18]); // <2610
  h[19] = barrett_fake(h[19]); // <2610
  h[20] = barrett_fake(h[20]); // <2610
  h[21] = barrett_fake(h[21]); // <2610
  h[26] = barrett_fake(h[26]); // <2610
  h[27] = barrett_fake(h[27]); // <2610
  h[28] = barrett_fake(h[28]); // <2610
  h[29] = barrett_fake(h[29]); // <2610
  h[34] = barrett_fake(h[34]); // <2610
  h[35] = barrett_fake(h[35]); // <2610
  h[36] = barrett_fake(h[36]); // <2610
  h[37] = barrett_fake(h[37]); // <2610
  h[42] = barrett_fake(h[42]); // <2610
  h[43] = barrett_fake(h[43]); // <2610
  h[44] = barrett_fake(h[44]); // <2610
  h[45] = barrett_fake(h[45]); // <2610
  h[50] = barrett_fake(h[50]); // <2610
  h[51] = barrett_fake(h[51]); // <2610
  h[52] = barrett_fake(h[52]); // <2610
  h[53] = barrett_fake(h[53]); // <2610
  h[58] = barrett_fake(h[58]); // <2610
  h[59] = barrett_fake(h[59]); // <2610
  h[60] = barrett_fake(h[60]); // <2610
  h[61] = barrett_fake(h[61]); // <2610
  hh[2] = barrett_fake(hh[2]); // <2430
  hh[3] = barrett_fake(hh[3]); // <2520
  hh[4] = barrett_fake(hh[4]); // <2520
  hh[5] = barrett_fake(hh[5]); // <2430
  hh[10] = barrett_fake(hh[10]); // <2430
  hh[11] = barrett_fake(hh[11]); // <2520
  hh[12] = barrett_fake(hh[12]); // <2520
  hh[13] = barrett_fake(hh[13]); // <2430
  hh[18] = barrett_fake(hh[18]); // <2430
  hh[19] = barrett_fake(hh[19]); // <2520
  hh[20] = barrett_fake(hh[20]); // <2520
  hh[21] = barrett_fake(hh[21]); // <2430
  hh[26] = barrett_fake(hh[26]); // <2430
  hh[27] = barrett_fake(hh[27]); // <2520
  hh[28] = barrett_fake(hh[28]); // <2520
  hh[29] = barrett_fake(hh[29]); // <2430
  hh[34] = barrett_fake(hh[34]); // <2430
  hh[35] = barrett_fake(hh[35]); // <2520
  hh[36] = barrett_fake(hh[36]); // <2520
  hh[37] = barrett_fake(hh[37]); // <2430
  hh[42] = barrett_fake(hh[42]); // <2430
  hh[43] = barrett_fake(hh[43]); // <2520
  hh[44] = barrett_fake(hh[44]); // <2520
  hh[45] = barrett_fake(hh[45]); // <2430
  hh[50] = barrett_fake(hh[50]); // <2430
  hh[51] = barrett_fake(hh[51]); // <2520
  hh[52] = barrett_fake(hh[52]); // <2520
  hh[53] = barrett_fake(hh[53]); // <2430
  hh[58] = barrett_fake(hh[58]); // <2430
  hh[59] = barrett_fake(hh[59]); // <2520
  hh[60] = barrett_fake(hh[60]); // <2520
  hh[61] = barrett_fake(hh[61]); // <2430
  hh[66] = barrett_fake(hh[66]); // <2610
  hh[67] = barrett_fake(hh[67]); // <2610
  hh[68] = barrett_fake(hh[68]); // <2610
  hh[69] = barrett_fake(hh[69]); // <2610
  hh[74] = barrett_fake(hh[74]); // <2610
  hh[75] = barrett_fake(hh[75]); // <2610
  hh[76] = barrett_fake(hh[76]); // <2610
  hh[77] = barrett_fake(hh[77]); // <2610
  hh[82] = barrett_fake(hh[82]); // <2430
  hh[83] = barrett_fake(hh[83]); // <2520
  hh[84] = barrett_fake(hh[84]); // <2520
  hh[85] = barrett_fake(hh[85]); // <2430
  hh[90] = barrett_fake(hh[90]); // <2430
  hh[91] = barrett_fake(hh[91]); // <2520
  hh[92] = barrett_fake(hh[92]); // <2520
  hh[93] = barrett_fake(hh[93]); // <2430
  hh[98] = barrett_fake(hh[98]); // <2430
  hh[99] = barrett_fake(hh[99]); // <2520
  hh[100] = barrett_fake(hh[100]); // <2520
  hh[101] = barrett_fake(hh[101]); // <2430
  hh[106] = barrett_fake(hh[106]); // <2430
  hh[107] = barrett_fake(hh[107]); // <2520
  hh[108] = barrett_fake(hh[108]); // <2520
  hh[109] = barrett_fake(hh[109]); // <2430
  hh[114] = barrett_fake(hh[114]); // <2610
  hh[115] = barrett_fake(hh[115]); // <2610
  hh[116] = barrett_fake(hh[116]); // <2610
  hh[117] = barrett_fake(hh[117]); // <2610
  hh[122] = barrett_fake(hh[122]); // <2610
  hh[123] = barrett_fake(hh[123]); // <2610
  hh[124] = barrett_fake(hh[124]); // <2610
  hh[125] = barrett_fake(hh[125]); // <2610
  hh[130] = barrett_fake(hh[130]); // <2610
  hh[131] = barrett_fake(hh[131]); // <2610
  hh[132] = barrett_fake(hh[132]); // <2610
  hh[133] = barrett_fake(hh[133]); // <2610
  hh[138] = barrett_fake(hh[138]); // <2610
  hh[139] = barrett_fake(hh[139]); // <2610
  hh[140] = barrett_fake(hh[140]); // <2610
  hh[141] = barrett_fake(hh[141]); // <2610
  hh[146] = barrett_fake(hh[146]); // <2610
  hh[147] = barrett_fake(hh[147]); // <2791
  hh[148] = barrett_fake(hh[148]); // <2791
  hh[149] = barrett_fake(hh[149]); // <2610
  t[0] = _mm256_sub_epi16(h[4],h[8]); // <6931
  t[1] = _mm256_sub_epi16(h[5],h[9]); // <8957
  t[2] = _mm256_sub_epi16(h[6],h[10]); // <8831
  t[3] = _mm256_sub_epi16(h[7],h[11]); // <6804
  t[4] = _mm256_add_epi16(t[0],h[12]); // <9541
  t[5] = _mm256_add_epi16(t[1],h[13]); // <11567
  t[6] = _mm256_add_epi16(t[2],h[14]); // <15052
  t[7] = _mm256_add_epi16(t[3],h[15]); // <10998
  t[0] = _mm256_sub_epi16(t[0],h[0]); // <11252
  t[1] = _mm256_sub_epi16(t[1],h[1]); // <15304
  t[2] = _mm256_sub_epi16(t[2],h[2]); // <11441
  t[3] = _mm256_sub_epi16(t[3],h[3]); // <9414
  h[8] = _mm256_sub_epi16(hh[84],t[4]); // <12061
  h[9] = _mm256_sub_epi16(hh[85],t[5]); // <13997
  h[10] = _mm256_sub_epi16(hh[86],t[6]); // <17662
  h[11] = _mm256_sub_epi16(hh[87],t[7]); // <13428
  h[4] = _mm256_add_epi16(hh[80],t[0]); // <13682
  h[5] = _mm256_add_epi16(hh[81],t[1]); // <17914
  h[6] = _mm256_add_epi16(hh[82],t[2]); // <13871
  h[7] = _mm256_add_epi16(hh[83],t[3]); // <11934
  t[0] = _mm256_sub_epi16(h[20],h[24]); // <6931
  t[1] = _mm256_sub_epi16(h[21],h[25]); // <8957
  t[2] = _mm256_sub_epi16(h[22],h[26]); // <8831
  t[3] = _mm256_sub_epi16(h[23],h[27]); // <6804
  t[4] = _mm256_add_epi16(t[0],h[28]); // <9541
  t[5] = _mm256_add_epi16(t[1],h[29]); // <11567
  t[6] = _mm256_add_epi16(t[2],h[30]); // <15052
  t[7] = _mm256_add_epi16(t[3],h[31]); // <10998
  t[0] = _mm256_sub_epi16(t[0],h[16]); // <11252
  t[1] = _mm256_sub_epi16(t[1],h[17]); // <15304
  t[2] = _mm256_sub_epi16(t[2],h[18]); // <11441
  t[3] = _mm256_sub_epi16(t[3],h[19]); // <9414
  h[24] = _mm256_sub_epi16(hh[92],t[4]); // <12061
  h[25] = _mm256_sub_epi16(hh[93],t[5]); // <13997
  h[26] = _mm256_sub_epi16(hh[94],t[6]); // <17662
  h[27] = _mm256_sub_epi16(hh[95],t[7]); // <13428
  h[20] = _mm256_add_epi16(hh[88],t[0]); // <13682
  h[21] = _mm256_add_epi16(hh[89],t[1]); // <17914
  h[22] = _mm256_add_epi16(hh[90],t[2]); // <13871
  h[23] = _mm256_add_epi16(hh[91],t[3]); // <11934
  t[0] = _mm256_sub_epi16(h[36],h[40]); // <6931
  t[1] = _mm256_sub_epi16(h[37],h[41]); // <8957
  t[2] = _mm256_sub_epi16(h[38],h[42]); // <8831
  t[3] = _mm256_sub_epi16(h[39],h[43]); // <6804
  t[4] = _mm256_add_epi16(t[0],h[44]); // <9541
  t[5] = _mm256_add_epi16(t[1],h[45]); // <11567
  t[6] = _mm256_add_epi16(t[2],h[46]); // <15052
  t[7] = _mm256_add_epi16(t[3],h[47]); // <10998
  t[0] = _mm256_sub_epi16(t[0],h[32]); // <11252
  t[1] = _mm256_sub_epi16(t[1],h[33]); // <15304
  t[2] = _mm256_sub_epi16(t[2],h[34]); // <11441
  t[3] = _mm256_sub_epi16(t[3],h[35]); // <9414
  h[40] = _mm256_sub_epi16(hh[100],t[4]); // <12061
  h[41] = _mm256_sub_epi16(hh[101],t[5]); // <13997
  h[42] = _mm256_sub_epi16(hh[102],t[6]); // <17662
  h[43] = _mm256_sub_epi16(hh[103],t[7]); // <13428
  h[36] = _mm256_add_epi16(hh[96],t[0]); // <13682
  h[37] = _mm256_add_epi16(hh[97],t[1]); // <17914
  h[38] = _mm256_add_epi16(hh[98],t[2]); // <13871
  h[39] = _mm256_add_epi16(hh[99],t[3]); // <11934
  t[0] = _mm256_sub_epi16(h[52],h[56]); // <6931
  t[1] = _mm256_sub_epi16(h[53],h[57]); // <8957
  t[2] = _mm256_sub_epi16(h[54],h[58]); // <8831
  t[3] = _mm256_sub_epi16(h[55],h[59]); // <6804
  t[4] = _mm256_add_epi16(t[0],h[60]); // <9541
  t[5] = _mm256_add_epi16(t[1],h[61]); // <11567
  t[6] = _mm256_add_epi16(t[2],h[62]); // <15052
  t[7] = _mm256_add_epi16(t[3],h[63]); // <10998
  t[0] = _mm256_sub_epi16(t[0],h[48]); // <11252
  t[1] = _mm256_sub_epi16(t[1],h[49]); // <15304
  t[2] = _mm256_sub_epi16(t[2],h[50]); // <11441
  t[3] = _mm256_sub_epi16(t[3],h[51]); // <9414
  h[56] = _mm256_sub_epi16(hh[108],t[4]); // <12061
  h[57] = _mm256_sub_epi16(hh[109],t[5]); // <13997
  h[58] = _mm256_sub_epi16(hh[110],t[6]); // <17662
  h[59] = _mm256_sub_epi16(hh[111],t[7]); // <13428
  h[52] = _mm256_add_epi16(hh[104],t[0]); // <13682
  h[53] = _mm256_add_epi16(hh[105],t[1]); // <17914
  h[54] = _mm256_add_epi16(hh[106],t[2]); // <13871
  h[55] = _mm256_add_epi16(hh[107],t[3]); // <11934
  t[0] = _mm256_sub_epi16(hh[4],hh[8]); // <4950
  t[1] = _mm256_sub_epi16(hh[5],hh[9]); // <5040
  t[2] = _mm256_sub_epi16(hh[6],hh[10]); // <5040
  t[3] = _mm256_sub_epi16(hh[7],hh[11]); // <4950
  t[4] = _mm256_add_epi16(t[0],hh[12]); // <7470
  t[5] = _mm256_add_epi16(t[1],hh[13]); // <7470
  t[6] = _mm256_add_epi16(t[2],hh[14]); // <7650
  t[7] = _mm256_add_epi16(t[3],hh[15]); // <7380
  t[0] = _mm256_sub_epi16(t[0],hh[0]); // <7380
  t[1] = _mm256_sub_epi16(t[1],hh[1]); // <7650
  t[2] = _mm256_sub_epi16(t[2],hh[2]); // <7470
  t[3] = _mm256_sub_epi16(t[3],hh[3]); // <7470
  hh[8] = _mm256_sub_epi16(hh[116],t[4]); // <10080
  hh[9] = _mm256_sub_epi16(hh[117],t[5]); // <10080
  hh[10] = _mm256_sub_epi16(hh[118],t[6]); // <12738
  hh[11] = _mm256_sub_epi16(hh[119],t[7]); // <11026
  hh[4] = _mm256_add_epi16(hh[112],t[0]); // <11116
  hh[5] = _mm256_add_epi16(hh[113],t[1]); // <12828
  hh[6] = _mm256_add_epi16(hh[114],t[2]); // <10080
  hh[7] = _mm256_add_epi16(hh[115],t[3]); // <10080
  t[0] = _mm256_sub_epi16(hh[20],hh[24]); // <4950
  t[1] = _mm256_sub_epi16(hh[21],hh[25]); // <5040
  t[2] = _mm256_sub_epi16(hh[22],hh[26]); // <5040
  t[3] = _mm256_sub_epi16(hh[23],hh[27]); // <4950
  t[4] = _mm256_add_epi16(t[0],hh[28]); // <7470
  t[5] = _mm256_add_epi16(t[1],hh[29]); // <7470
  t[6] = _mm256_add_epi16(t[2],hh[30]); // <7650
  t[7] = _mm256_add_epi16(t[3],hh[31]); // <7380
  t[0] = _mm256_sub_epi16(t[0],hh[16]); // <7380
  t[1] = _mm256_sub_epi16(t[1],hh[17]); // <7650
  t[2] = _mm256_sub_epi16(t[2],hh[18]); // <7470
  t[3] = _mm256_sub_epi16(t[3],hh[19]); // <7470
  hh[24] = _mm256_sub_epi16(hh[124],t[4]); // <10080
  hh[25] = _mm256_sub_epi16(hh[125],t[5]); // <10080
  hh[26] = _mm256_sub_epi16(hh[126],t[6]); // <12738
  hh[27] = _mm256_sub_epi16(hh[127],t[7]); // <11026
  hh[20] = _mm256_add_epi16(hh[120],t[0]); // <11116
  hh[21] = _mm256_add_epi16(hh[121],t[1]); // <12828
  hh[22] = _mm256_add_epi16(hh[122],t[2]); // <10080
  hh[23] = _mm256_add_epi16(hh[123],t[3]); // <10080
  t[0] = _mm256_sub_epi16(hh[36],hh[40]); // <4950
  t[1] = _mm256_sub_epi16(hh[37],hh[41]); // <5040
  t[2] = _mm256_sub_epi16(hh[38],hh[42]); // <5040
  t[3] = _mm256_sub_epi16(hh[39],hh[43]); // <4950
  t[4] = _mm256_add_epi16(t[0],hh[44]); // <7470
  t[5] = _mm256_add_epi16(t[1],hh[45]); // <7470
  t[6] = _mm256_add_epi16(t[2],hh[46]); // <7650
  t[7] = _mm256_add_epi16(t[3],hh[47]); // <7380
  t[0] = _mm256_sub_epi16(t[0],hh[32]); // <7380
  t[1] = _mm256_sub_epi16(t[1],hh[33]); // <7650
  t[2] = _mm256_sub_epi16(t[2],hh[34]); // <7470
  t[3] = _mm256_sub_epi16(t[3],hh[35]); // <7470
  hh[40] = _mm256_sub_epi16(hh[132],t[4]); // <10080
  hh[41] = _mm256_sub_epi16(hh[133],t[5]); // <10080
  hh[42] = _mm256_sub_epi16(hh[134],t[6]); // <12738
  hh[43] = _mm256_sub_epi16(hh[135],t[7]); // <11026
  hh[36] = _mm256_add_epi16(hh[128],t[0]); // <11116
  hh[37] = _mm256_add_epi16(hh[129],t[1]); // <12828
  hh[38] = _mm256_add_epi16(hh[130],t[2]); // <10080
  hh[39] = _mm256_add_epi16(hh[131],t[3]); // <10080
  t[0] = _mm256_sub_epi16(hh[52],hh[56]); // <4950
  t[1] = _mm256_sub_epi16(hh[53],hh[57]); // <5040
  t[2] = _mm256_sub_epi16(hh[54],hh[58]); // <5040
  t[3] = _mm256_sub_epi16(hh[55],hh[59]); // <4950
  t[4] = _mm256_add_epi16(t[0],hh[60]); // <7470
  t[5] = _mm256_add_epi16(t[1],hh[61]); // <7470
  t[6] = _mm256_add_epi16(t[2],hh[62]); // <7650
  t[7] = _mm256_add_epi16(t[3],hh[63]); // <7380
  t[0] = _mm256_sub_epi16(t[0],hh[48]); // <7380
  t[1] = _mm256_sub_epi16(t[1],hh[49]); // <7650
  t[2] = _mm256_sub_epi16(t[2],hh[50]); // <7470
  t[3] = _mm256_sub_epi16(t[3],hh[51]); // <7470
  hh[56] = _mm256_sub_epi16(hh[140],t[4]); // <10080
  hh[57] = _mm256_sub_epi16(hh[141],t[5]); // <10080
  hh[58] = _mm256_sub_epi16(hh[142],t[6]); // <12738
  hh[59] = _mm256_sub_epi16(hh[143],t[7]); // <11026
  hh[52] = _mm256_add_epi16(hh[136],t[0]); // <11116
  hh[53] = _mm256_add_epi16(hh[137],t[1]); // <12828
  hh[54] = _mm256_add_epi16(hh[138],t[2]); // <10080
  hh[55] = _mm256_add_epi16(hh[139],t[3]); // <10080
  t[0] = _mm256_sub_epi16(hh[68],hh[72]); // <6346
  t[1] = _mm256_sub_epi16(hh[69],hh[73]); // <7788
  t[2] = _mm256_sub_epi16(hh[70],hh[74]); // <7698
  t[3] = _mm256_sub_epi16(hh[71],hh[75]); // <6256
  t[4] = _mm256_add_epi16(t[0],hh[76]); // <8956
  t[5] = _mm256_add_epi16(t[1],hh[77]); // <10398
  t[6] = _mm256_add_epi16(t[2],hh[78]); // <12786
  t[7] = _mm256_add_epi16(t[3],hh[79]); // <9902
  t[0] = _mm256_sub_epi16(t[0],hh[64]); // <10082
  t[1] = _mm256_sub_epi16(t[1],hh[65]); // <12966
  t[2] = _mm256_sub_epi16(t[2],hh[66]); // <10308
  t[3] = _mm256_sub_epi16(t[3],hh[67]); // <8866
  hh[72] = _mm256_sub_epi16(hh[148],t[4]); // <11747
  hh[73] = _mm256_sub_epi16(hh[149],t[5]); // <13008
  hh[74] = _mm256_sub_epi16(hh[150],t[6]); // <17671
  hh[75] = _mm256_sub_epi16(hh[151],t[7]); // <13450
  hh[68] = _mm256_add_epi16(hh[144],t[0]); // <13713
  hh[69] = _mm256_add_epi16(hh[145],t[1]); // <17934
  hh[70] = _mm256_add_epi16(hh[146],t[2]); // <12918
  hh[71] = _mm256_add_epi16(hh[147],t[3]); // <11657

  h[4] = barrett_fake(h[4]); // <2520
  h[5] = barrett_fake(h[5]); // <2610
  h[6] = barrett_fake(h[6]); // <2520
  h[7] = barrett_fake(h[7]); // <2520
  h[8] = barrett_fake(h[8]); // <2520
  h[9] = barrett_fake(h[9]); // <2520
  h[10] = barrett_fake(h[10]); // <2610
  h[11] = barrett_fake(h[11]); // <2520
  h[20] = barrett_fake(h[20]); // <2520
  h[21] = barrett_fake(h[21]); // <2610
  h[22] = barrett_fake(h[22]); // <2520
  h[23] = barrett_fake(h[23]); // <2520
  h[24] = barrett_fake(h[24]); // <2520
  h[25] = barrett_fake(h[25]); // <2520
  h[26] = barrett_fake(h[26]); // <2610
  h[27] = barrett_fake(h[27]); // <2520
  h[36] = barrett_fake(h[36]); // <2520
  h[37] = barrett_fake(h[37]); // <2610
  h[38] = barrett_fake(h[38]); // <2520
  h[39] = barrett_fake(h[39]); // <2520
  h[40] = barrett_fake(h[40]); // <2520
  h[41] = barrett_fake(h[41]); // <2520
  h[42] = barrett_fake(h[42]); // <2610
  h[43] = barrett_fake(h[43]); // <2520
  h[52] = barrett_fake(h[52]); // <2520
  h[53] = barrett_fake(h[53]); // <2610
  h[54] = barrett_fake(h[54]); // <2520
  h[55] = barrett_fake(h[55]); // <2520
  h[56] = barrett_fake(h[56]); // <2520
  h[57] = barrett_fake(h[57]); // <2520
  h[58] = barrett_fake(h[58]); // <2610
  h[59] = barrett_fake(h[59]); // <2520
  hh[4] = barrett_fake(hh[4]); // <2430
  hh[5] = barrett_fake(hh[5]); // <2520
  hh[6] = barrett_fake(hh[6]); // <2430
  hh[7] = barrett_fake(hh[7]); // <2430
  hh[8] = barrett_fake(hh[8]); // <2430
  hh[9] = barrett_fake(hh[9]); // <2430
  hh[10] = barrett_fake(hh[10]); // <2520
  hh[11] = barrett_fake(hh[11]); // <2430
  hh[20] = barrett_fake(hh[20]); // <2430
  hh[21] = barrett_fake(hh[21]); // <2520
  hh[22] = barrett_fake(hh[22]); // <2430
  hh[23] = barrett_fake(hh[23]); // <2430
  hh[24] = barrett_fake(hh[24]); // <2430
  hh[25] = barrett_fake(hh[25]); // <2430
  hh[26] = barrett_fake(hh[26]); // <2520
  hh[27] = barrett_fake(hh[27]); // <2430
  hh[36] = barrett_fake(hh[36]); // <2430
  hh[37] = barrett_fake(hh[37]); // <2520
  hh[38] = barrett_fake(hh[38]); // <2430
  hh[39] = barrett_fake(hh[39]); // <2430
  hh[40] = barrett_fake(hh[40]); // <2430
  hh[41] = barrett_fake(hh[41]); // <2430
  hh[42] = barrett_fake(hh[42]); // <2520
  hh[43] = barrett_fake(hh[43]); // <2430
  hh[52] = barrett_fake(hh[52]); // <2430
  hh[53] = barrett_fake(hh[53]); // <2520
  hh[54] = barrett_fake(hh[54]); // <2430
  hh[55] = barrett_fake(hh[55]); // <2430
  hh[56] = barrett_fake(hh[56]); // <2430
  hh[57] = barrett_fake(hh[57]); // <2430
  hh[58] = barrett_fake(hh[58]); // <2520
  hh[59] = barrett_fake(hh[59]); // <2430
  hh[68] = barrett_fake(hh[68]); // <2520
  hh[69] = barrett_fake(hh[69]); // <2610
  hh[70] = barrett_fake(hh[70]); // <2520
  hh[71] = barrett_fake(hh[71]); // <2430
  hh[72] = barrett_fake(hh[72]); // <2520
  hh[73] = barrett_fake(hh[73]); // <2520
  hh[74] = barrett_fake(hh[74]); // <2610
  hh[75] = barrett_fake(hh[75]); // <2520
  t[0] = _mm256_sub_epi16(h[8],h[16]); // <6841
  t[1] = _mm256_sub_epi16(h[9],h[17]); // <8867
  t[2] = _mm256_sub_epi16(h[10],h[18]); // <5220
  t[3] = _mm256_sub_epi16(h[11],h[19]); // <5130
  t[4] = _mm256_sub_epi16(h[12],h[20]); // <5130
  t[5] = _mm256_sub_epi16(h[13],h[21]); // <5220
  t[6] = _mm256_sub_epi16(h[14],h[22]); // <8741
  t[7] = _mm256_sub_epi16(h[15],h[23]); // <6714
  t[8] = _mm256_add_epi16(t[0],h[24]); // <9361
  t[9] = _mm256_add_epi16(t[1],h[25]); // <11387
  t[10] = _mm256_add_epi16(t[2],h[26]); // <7830
  t[11] = _mm256_add_epi16(t[3],h[27]); // <7650
  t[12] = _mm256_add_epi16(t[4],h[28]); // <7740
  t[13] = _mm256_add_epi16(t[5],h[29]); // <7830
  t[14] = _mm256_add_epi16(t[6],h[30]); // <14962
  t[15] = _mm256_add_epi16(t[7],h[31]); // <10908
  t[0] = _mm256_sub_epi16(t[0],h[0]); // <11162
  t[1] = _mm256_sub_epi16(t[1],h[1]); // <15214
  t[2] = _mm256_sub_epi16(t[2],h[2]); // <7830
  t[3] = _mm256_sub_epi16(t[3],h[3]); // <7740
  t[4] = _mm256_sub_epi16(t[4],h[4]); // <7650
  t[5] = _mm256_sub_epi16(t[5],h[5]); // <7830
  t[6] = _mm256_sub_epi16(t[6],h[6]); // <11261
  t[7] = _mm256_sub_epi16(t[7],h[7]); // <9234
  h[16] = _mm256_sub_epi16(hh[40],t[8]); // <11791
  h[17] = _mm256_sub_epi16(hh[41],t[9]); // <13817
  h[18] = _mm256_sub_epi16(hh[42],t[10]); // <10350
  h[19] = _mm256_sub_epi16(hh[43],t[11]); // <10080
  h[20] = _mm256_sub_epi16(hh[44],t[12]); // <10260
  h[21] = _mm256_sub_epi16(hh[45],t[13]); // <10260
  h[22] = _mm256_sub_epi16(hh[46],t[14]); // <17572
  h[23] = _mm256_sub_epi16(hh[47],t[15]); // <13338
  h[8] = _mm256_add_epi16(hh[32],t[0]); // <13592
  h[9] = _mm256_add_epi16(hh[33],t[1]); // <17824
  h[10] = _mm256_add_epi16(hh[34],t[2]); // <10260
  h[11] = _mm256_add_epi16(hh[35],t[3]); // <10260
  h[12] = _mm256_add_epi16(hh[36],t[4]); // <10080
  h[13] = _mm256_add_epi16(hh[37],t[5]); // <10350
  h[14] = _mm256_add_epi16(hh[38],t[6]); // <13691
  h[15] = _mm256_add_epi16(hh[39],t[7]); // <11664
  t[0] = _mm256_sub_epi16(h[40],h[48]); // <6841
  t[1] = _mm256_sub_epi16(h[41],h[49]); // <8867
  t[2] = _mm256_sub_epi16(h[42],h[50]); // <5220
  t[3] = _mm256_sub_epi16(h[43],h[51]); // <5130
  t[4] = _mm256_sub_epi16(h[44],h[52]); // <5130
  t[5] = _mm256_sub_epi16(h[45],h[53]); // <5220
  t[6] = _mm256_sub_epi16(h[46],h[54]); // <8741
  t[7] = _mm256_sub_epi16(h[47],h[55]); // <6714
  t[8] = _mm256_add_epi16(t[0],h[56]); // <9361
  t[9] = _mm256_add_epi16(t[1],h[57]); // <11387
  t[10] = _mm256_add_epi16(t[2],h[58]); // <7830
  t[11] = _mm256_add_epi16(t[3],h[59]); // <7650
  t[12] = _mm256_add_epi16(t[4],h[60]); // <7740
  t[13] = _mm256_add_epi16(t[5],h[61]); // <7830
  t[14] = _mm256_add_epi16(t[6],h[62]); // <14962
  t[15] = _mm256_add_epi16(t[7],h[63]); // <10908
  t[0] = _mm256_sub_epi16(t[0],h[32]); // <11162
  t[1] = _mm256_sub_epi16(t[1],h[33]); // <15214
  t[2] = _mm256_sub_epi16(t[2],h[34]); // <7830
  t[3] = _mm256_sub_epi16(t[3],h[35]); // <7740
  t[4] = _mm256_sub_epi16(t[4],h[36]); // <7650
  t[5] = _mm256_sub_epi16(t[5],h[37]); // <7830
  t[6] = _mm256_sub_epi16(t[6],h[38]); // <11261
  t[7] = _mm256_sub_epi16(t[7],h[39]); // <9234
  h[48] = _mm256_sub_epi16(hh[56],t[8]); // <11791
  h[49] = _mm256_sub_epi16(hh[57],t[9]); // <13817
  h[50] = _mm256_sub_epi16(hh[58],t[10]); // <10350
  h[51] = _mm256_sub_epi16(hh[59],t[11]); // <10080
  h[52] = _mm256_sub_epi16(hh[60],t[12]); // <10260
  h[53] = _mm256_sub_epi16(hh[61],t[13]); // <10260
  h[54] = _mm256_sub_epi16(hh[62],t[14]); // <17572
  h[55] = _mm256_sub_epi16(hh[63],t[15]); // <13338
  h[40] = _mm256_add_epi16(hh[48],t[0]); // <13592
  h[41] = _mm256_add_epi16(hh[49],t[1]); // <17824
  h[42] = _mm256_add_epi16(hh[50],t[2]); // <10260
  h[43] = _mm256_add_epi16(hh[51],t[3]); // <10260
  h[44] = _mm256_add_epi16(hh[52],t[4]); // <10080
  h[45] = _mm256_add_epi16(hh[53],t[5]); // <10350
  h[46] = _mm256_add_epi16(hh[54],t[6]); // <13691
  h[47] = _mm256_add_epi16(hh[55],t[7]); // <11664
  t[0] = _mm256_sub_epi16(hh[8],hh[16]); // <4860
  t[1] = _mm256_sub_epi16(hh[9],hh[17]); // <5040
  t[2] = _mm256_sub_epi16(hh[10],hh[18]); // <4950
  t[3] = _mm256_sub_epi16(hh[11],hh[19]); // <4950
  t[4] = _mm256_sub_epi16(hh[12],hh[20]); // <4950
  t[5] = _mm256_sub_epi16(hh[13],hh[21]); // <4950
  t[6] = _mm256_sub_epi16(hh[14],hh[22]); // <5040
  t[7] = _mm256_sub_epi16(hh[15],hh[23]); // <4860
  t[8] = _mm256_add_epi16(t[0],hh[24]); // <7290
  t[9] = _mm256_add_epi16(t[1],hh[25]); // <7470
  t[10] = _mm256_add_epi16(t[2],hh[26]); // <7470
  t[11] = _mm256_add_epi16(t[3],hh[27]); // <7380
  t[12] = _mm256_add_epi16(t[4],hh[28]); // <7470
  t[13] = _mm256_add_epi16(t[5],hh[29]); // <7380
  t[14] = _mm256_add_epi16(t[6],hh[30]); // <7650
  t[15] = _mm256_add_epi16(t[7],hh[31]); // <7290
  t[0] = _mm256_sub_epi16(t[0],hh[0]); // <7290
  t[1] = _mm256_sub_epi16(t[1],hh[1]); // <7650
  t[2] = _mm256_sub_epi16(t[2],hh[2]); // <7380
  t[3] = _mm256_sub_epi16(t[3],hh[3]); // <7470
  t[4] = _mm256_sub_epi16(t[4],hh[4]); // <7380
  t[5] = _mm256_sub_epi16(t[5],hh[5]); // <7470
  t[6] = _mm256_sub_epi16(t[6],hh[6]); // <7470
  t[7] = _mm256_sub_epi16(t[7],hh[7]); // <7290
  hh[16] = _mm256_sub_epi16(hh[72],t[8]); // <9810
  hh[17] = _mm256_sub_epi16(hh[73],t[9]); // <9990
  hh[18] = _mm256_sub_epi16(hh[74],t[10]); // <10080
  hh[19] = _mm256_sub_epi16(hh[75],t[11]); // <9900
  hh[20] = _mm256_sub_epi16(hh[76],t[12]); // <10080
  hh[21] = _mm256_sub_epi16(hh[77],t[13]); // <9990
  hh[22] = _mm256_sub_epi16(hh[78],t[14]); // <12738
  hh[23] = _mm256_sub_epi16(hh[79],t[15]); // <10936
  hh[8] = _mm256_add_epi16(hh[64],t[0]); // <11026
  hh[9] = _mm256_add_epi16(hh[65],t[1]); // <12828
  hh[10] = _mm256_add_epi16(hh[66],t[2]); // <9990
  hh[11] = _mm256_add_epi16(hh[67],t[3]); // <10080
  hh[12] = _mm256_add_epi16(hh[68],t[4]); // <9900
  hh[13] = _mm256_add_epi16(hh[69],t[5]); // <10080
  hh[14] = _mm256_add_epi16(hh[70],t[6]); // <9990
  hh[15] = _mm256_add_epi16(hh[71],t[7]); // <9720

  h[8] = barrett_fake(h[8]); // <2520
  h[9] = barrett_fake(h[9]); // <2610
  h[10] = barrett_fake(h[10]); // <2430
  h[11] = barrett_fake(h[11]); // <2430
  h[13] = barrett_fake(h[13]); // <2430
  h[14] = barrett_fake(h[14]); // <2520
  h[15] = barrett_fake(h[15]); // <2430
  h[16] = barrett_fake(h[16]); // <2520
  h[17] = barrett_fake(h[17]); // <2520
  h[18] = barrett_fake(h[18]); // <2430
  h[20] = barrett_fake(h[20]); // <2430
  h[21] = barrett_fake(h[21]); // <2430
  h[22] = barrett_fake(h[22]); // <2610
  h[23] = barrett_fake(h[23]); // <2520
  h[40] = barrett_fake(h[40]); // <2520
  h[41] = barrett_fake(h[41]); // <2610
  h[42] = barrett_fake(h[42]); // <2430
  h[43] = barrett_fake(h[43]); // <2430
  h[45] = barrett_fake(h[45]); // <2430
  h[46] = barrett_fake(h[46]); // <2520
  h[47] = barrett_fake(h[47]); // <2430
  h[48] = barrett_fake(h[48]); // <2520
  h[49] = barrett_fake(h[49]); // <2520
  h[50] = barrett_fake(h[50]); // <2430
  h[52] = barrett_fake(h[52]); // <2430
  h[53] = barrett_fake(h[53]); // <2430
  h[54] = barrett_fake(h[54]); // <2610
  h[55] = barrett_fake(h[55]); // <2520
  hh[8] = barrett_fake(hh[8]); // <2430
  hh[9] = barrett_fake(hh[9]); // <2520
  hh[10] = barrett_fake(hh[10]); // <2430
  hh[11] = barrett_fake(hh[11]); // <2430
  hh[13] = barrett_fake(hh[13]); // <2430
  hh[14] = barrett_fake(hh[14]); // <2430
  hh[15] = barrett_fake(hh[15]); // <2430
  hh[16] = barrett_fake(hh[16]); // <2430
  hh[17] = barrett_fake(hh[17]); // <2430
  hh[18] = barrett_fake(hh[18]); // <2430
  hh[20] = barrett_fake(hh[20]); // <2430
  hh[21] = barrett_fake(hh[21]); // <2430
  hh[22] = barrett_fake(hh[22]); // <2520
  hh[23] = barrett_fake(hh[23]); // <2430
  t[0] = _mm256_sub_epi16(h[16],h[32]); // <6841
  t[1] = _mm256_sub_epi16(h[17],h[33]); // <8867
  t[2] = _mm256_sub_epi16(h[18],h[34]); // <5040
  t[3] = _mm256_sub_epi16(h[19],h[35]); // <12690
  t[4] = _mm256_sub_epi16(h[20],h[36]); // <4950
  t[5] = _mm256_sub_epi16(h[21],h[37]); // <5040
  t[6] = _mm256_sub_epi16(h[22],h[38]); // <5130
  t[7] = _mm256_sub_epi16(h[23],h[39]); // <5040
  t[8] = _mm256_sub_epi16(h[24],h[40]); // <5040
  t[9] = _mm256_sub_epi16(h[25],h[41]); // <5130
  t[10] = _mm256_sub_epi16(h[26],h[42]); // <5040
  t[11] = _mm256_sub_epi16(h[27],h[43]); // <4950
  t[12] = _mm256_sub_epi16(h[28],h[44]); // <12690
  t[13] = _mm256_sub_epi16(h[29],h[45]); // <5040
  t[14] = _mm256_sub_epi16(h[30],h[46]); // <8741
  t[15] = _mm256_sub_epi16(h[31],h[47]); // <6624
  t[16] = _mm256_add_epi16(t[0],h[48]); // <9361
  t[17] = _mm256_add_epi16(t[1],h[49]); // <11387
  t[18] = _mm256_add_epi16(t[2],h[50]); // <7470
  t[19] = _mm256_add_epi16(t[3],h[51]); // <22770
  t[20] = _mm256_add_epi16(t[4],h[52]); // <7380
  t[21] = _mm256_add_epi16(t[5],h[53]); // <7470
  t[22] = _mm256_add_epi16(t[6],h[54]); // <7740
  t[23] = _mm256_add_epi16(t[7],h[55]); // <7560
  t[24] = _mm256_add_epi16(t[8],h[56]); // <7560
  t[25] = _mm256_add_epi16(t[9],h[57]); // <7650
  t[26] = _mm256_add_epi16(t[10],h[58]); // <7650
  t[27] = _mm256_add_epi16(t[11],h[59]); // <7470
  t[28] = _mm256_add_epi16(t[12],h[60]); // <15300
  t[29] = _mm256_add_epi16(t[13],h[61]); // <7650
  t[30] = _mm256_add_epi16(t[14],h[62]); // <14962
  t[31] = _mm256_add_epi16(t[15],h[63]); // <10818
  t[0] = _mm256_sub_epi16(t[0],h[0]); // <11162
  t[1] = _mm256_sub_epi16(t[1],h[1]); // <15214
  t[2] = _mm256_sub_epi16(t[2],h[2]); // <7650
  t[3] = _mm256_sub_epi16(t[3],h[3]); // <15300
  t[4] = _mm256_sub_epi16(t[4],h[4]); // <7470
  t[5] = _mm256_sub_epi16(t[5],h[5]); // <7650
  t[6] = _mm256_sub_epi16(t[6],h[6]); // <7650
  t[7] = _mm256_sub_epi16(t[7],h[7]); // <7560
  t[8] = _mm256_sub_epi16(t[8],h[8]); // <7560
  t[9] = _mm256_sub_epi16(t[9],h[9]); // <7740
  t[10] = _mm256_sub_epi16(t[10],h[10]); // <7470
  t[11] = _mm256_sub_epi16(t[11],h[11]); // <7380
  t[12] = _mm256_sub_epi16(t[12],h[12]); // <22770
  t[13] = _mm256_sub_epi16(t[13],h[13]); // <7470
  t[14] = _mm256_sub_epi16(t[14],h[14]); // <11261
  t[15] = _mm256_sub_epi16(t[15],h[15]); // <9054
  h[32] = _mm256_sub_epi16(hh[16],t[16]); // <11791
  h[33] = _mm256_sub_epi16(hh[17],t[17]); // <13817
  h[34] = _mm256_sub_epi16(hh[18],t[18]); // <9900
  h[35] = _mm256_sub_epi16(hh[19],t[19]); // <32670
  h[36] = _mm256_sub_epi16(hh[20],t[20]); // <9810
  h[37] = _mm256_sub_epi16(hh[21],t[21]); // <9900
  h[38] = _mm256_sub_epi16(hh[22],t[22]); // <10260
  h[39] = _mm256_sub_epi16(hh[23],t[23]); // <9990
  h[40] = _mm256_sub_epi16(hh[24],t[24]); // <9990
  h[41] = _mm256_sub_epi16(hh[25],t[25]); // <10080
  h[42] = _mm256_sub_epi16(hh[26],t[26]); // <10170
  h[43] = _mm256_sub_epi16(hh[27],t[27]); // <9900
  h[44] = _mm256_sub_epi16(hh[28],t[28]); // <17820
  h[45] = _mm256_sub_epi16(hh[29],t[29]); // <10080
  h[46] = _mm256_sub_epi16(hh[30],t[30]); // <17572
  h[47] = _mm256_sub_epi16(hh[31],t[31]); // <13248
  h[16] = _mm256_add_epi16(hh[0],t[0]); // <13592
  h[17] = _mm256_add_epi16(hh[1],t[1]); // <17824
  h[18] = _mm256_add_epi16(hh[2],t[2]); // <10080
  h[19] = _mm256_add_epi16(hh[3],t[3]); // <17820
  h[20] = _mm256_add_epi16(hh[4],t[4]); // <9900
  h[21] = _mm256_add_epi16(hh[5],t[5]); // <10170
  h[22] = _mm256_add_epi16(hh[6],t[6]); // <10080
  h[23] = _mm256_add_epi16(hh[7],t[7]); // <9990
  h[24] = _mm256_add_epi16(hh[8],t[8]); // <9990
  h[25] = _mm256_add_epi16(hh[9],t[9]); // <10260
  h[26] = _mm256_add_epi16(hh[10],t[10]); // <9900
  h[27] = _mm256_add_epi16(hh[11],t[11]); // <9810
  h[28] = _mm256_add_epi16(hh[12],t[12]); // <32670
  h[29] = _mm256_add_epi16(hh[13],t[13]); // <9900
  h[30] = _mm256_add_epi16(hh[14],t[14]); // <13691
  h[31] = _mm256_add_epi16(hh[15],t[15]); // <11484

}
void gf_polymul_512x512_avx2 (__m256i *h, __m256i *f, __m256i *g){
  gf_polymul_512x512_avx2_divR(h,f,g);
  h[0]=montproduct(h[0],v4158_16); // <2340
  h[1]=montproduct(h[1],v4158_16); // <2340
  h[2]=montproduct(h[2],v4158_16); // <2340
  h[3]=montproduct(h[3],v4158_16); // <2340
  h[4]=montproduct(h[4],v4158_16); // <2340
  h[5]=montproduct(h[5],v4158_16); // <2340
  h[6]=montproduct(h[6],v4158_16); // <2340
  h[7]=montproduct(h[7],v4158_16); // <2340
  h[8]=montproduct(h[8],v4158_16); // <2340
  h[9]=montproduct(h[9],v4158_16); // <2340
  h[10]=montproduct(h[10],v4158_16); // <2340
  h[11]=montproduct(h[11],v4158_16); // <2340
  h[12]=montproduct(h[12],v4158_16); // <2430
  h[13]=montproduct(h[13],v4158_16); // <2340
  h[14]=montproduct(h[14],v4158_16); // <2340
  h[15]=montproduct(h[15],v4158_16); // <2340
  h[16]=montproduct(h[16],v4158_16); // <2520
  h[17]=montproduct(h[17],v4158_16); // <2610
  h[18]=montproduct(h[18],v4158_16); // <2430
  h[19]=montproduct(h[19],v4158_16); // <2610
  h[20]=montproduct(h[20],v4158_16); // <2430
  h[21]=montproduct(h[21],v4158_16); // <2430
  h[22]=montproduct(h[22],v4158_16); // <2430
  h[23]=montproduct(h[23],v4158_16); // <2430
  h[24]=montproduct(h[24],v4158_16); // <2430
  h[25]=montproduct(h[25],v4158_16); // <2430
  h[26]=montproduct(h[26],v4158_16); // <2430
  h[27]=montproduct(h[27],v4158_16); // <2430
  h[28]=montproduct(h[28],v4158_16); // <2881
  h[29]=montproduct(h[29],v4158_16); // <2430
  h[30]=montproduct(h[30],v4158_16); // <2520
  h[31]=montproduct(h[31],v4158_16); // <2430
  h[32]=montproduct(h[32],v4158_16); // <2520
  h[33]=montproduct(h[33],v4158_16); // <2520
  h[34]=montproduct(h[34],v4158_16); // <2430
  h[35]=montproduct(h[35],v4158_16); // <2881
  h[36]=montproduct(h[36],v4158_16); // <2430
  h[37]=montproduct(h[37],v4158_16); // <2430
  h[38]=montproduct(h[38],v4158_16); // <2430
  h[39]=montproduct(h[39],v4158_16); // <2430
  h[40]=montproduct(h[40],v4158_16); // <2430
  h[41]=montproduct(h[41],v4158_16); // <2430
  h[42]=montproduct(h[42],v4158_16); // <2430
  h[43]=montproduct(h[43],v4158_16); // <2430
  h[44]=montproduct(h[44],v4158_16); // <2610
  h[45]=montproduct(h[45],v4158_16); // <2430
  h[46]=montproduct(h[46],v4158_16); // <2610
  h[47]=montproduct(h[47],v4158_16); // <2520
  h[48]=montproduct(h[48],v4158_16); // <2340
  h[49]=montproduct(h[49],v4158_16); // <2340
  h[50]=montproduct(h[50],v4158_16); // <2340
  h[51]=montproduct(h[51],v4158_16); // <2430
  h[52]=montproduct(h[52],v4158_16); // <2340
  h[53]=montproduct(h[53],v4158_16); // <2340
  h[54]=montproduct(h[54],v4158_16); // <2340
  h[55]=montproduct(h[55],v4158_16); // <2340
  h[56]=montproduct(h[56],v4158_16); // <2340
  h[57]=montproduct(h[57],v4158_16); // <2340
  h[58]=montproduct(h[58],v4158_16); // <2340
  h[59]=montproduct(h[59],v4158_16); // <2340
  h[60]=montproduct(h[60],v4158_16); // <2340
  h[61]=montproduct(h[61],v4158_16); // <2340
  h[62]=montproduct(h[62],v4158_16); // <2340
  h[63]=montproduct(h[63],v4158_16); // <2340
}
void gf_polymul_512x512_avx2_uvqr_fg (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[64];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+32);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);

  gf_polymul_512x512_avx2_divR(ff,uvqr,f);
  gf_polymul_512x512_avx2_divR(t,uvqr+32,g);
  ff[17] = barrett_fake(ff[17]); // <2610
  t[17] = barrett_fake(t[17]); // <2610
  ff[19] = barrett_fake(ff[19]); // <2610
  t[19] = barrett_fake(t[19]); // <2610
  ff[28] = barrett_fake(ff[28]); // <2881
  t[28] = barrett_fake(t[28]); // <2881
  ff[35] = barrett_fake(ff[35]); // <2881
  t[35] = barrett_fake(t[35]); // <2881
  ff[44] = barrett_fake(ff[44]); // <2610
  t[44] = barrett_fake(t[44]); // <2610
  ff[46] = barrett_fake(ff[46]); // <2610
  t[46] = barrett_fake(t[46]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);
  ff[16]=_mm256_add_epi16(ff[16],t[16]);
  ff[17]=_mm256_add_epi16(ff[17],t[17]);
  ff[18]=_mm256_add_epi16(ff[18],t[18]);
  ff[19]=_mm256_add_epi16(ff[19],t[19]);
  ff[20]=_mm256_add_epi16(ff[20],t[20]);
  ff[21]=_mm256_add_epi16(ff[21],t[21]);
  ff[22]=_mm256_add_epi16(ff[22],t[22]);
  ff[23]=_mm256_add_epi16(ff[23],t[23]);
  ff[24]=_mm256_add_epi16(ff[24],t[24]);
  ff[25]=_mm256_add_epi16(ff[25],t[25]);
  ff[26]=_mm256_add_epi16(ff[26],t[26]);
  ff[27]=_mm256_add_epi16(ff[27],t[27]);
  ff[28]=_mm256_add_epi16(ff[28],t[28]);
  ff[29]=_mm256_add_epi16(ff[29],t[29]);
  ff[30]=_mm256_add_epi16(ff[30],t[30]);
  ff[31]=_mm256_add_epi16(ff[31],t[31]);
  ff[32]=_mm256_add_epi16(ff[32],t[32]);
  ff[33]=_mm256_add_epi16(ff[33],t[33]);
  ff[34]=_mm256_add_epi16(ff[34],t[34]);
  ff[35]=_mm256_add_epi16(ff[35],t[35]);
  ff[36]=_mm256_add_epi16(ff[36],t[36]);
  ff[37]=_mm256_add_epi16(ff[37],t[37]);
  ff[38]=_mm256_add_epi16(ff[38],t[38]);
  ff[39]=_mm256_add_epi16(ff[39],t[39]);
  ff[40]=_mm256_add_epi16(ff[40],t[40]);
  ff[41]=_mm256_add_epi16(ff[41],t[41]);
  ff[42]=_mm256_add_epi16(ff[42],t[42]);
  ff[43]=_mm256_add_epi16(ff[43],t[43]);
  ff[44]=_mm256_add_epi16(ff[44],t[44]);
  ff[45]=_mm256_add_epi16(ff[45],t[45]);
  ff[46]=_mm256_add_epi16(ff[46],t[46]);
  ff[47]=_mm256_add_epi16(ff[47],t[47]);
  ff[48]=_mm256_add_epi16(ff[48],t[48]);
  ff[49]=_mm256_add_epi16(ff[49],t[49]);
  ff[50]=_mm256_add_epi16(ff[50],t[50]);
  ff[51]=_mm256_add_epi16(ff[51],t[51]);
  ff[52]=_mm256_add_epi16(ff[52],t[52]);
  ff[53]=_mm256_add_epi16(ff[53],t[53]);
  ff[54]=_mm256_add_epi16(ff[54],t[54]);
  ff[55]=_mm256_add_epi16(ff[55],t[55]);
  ff[56]=_mm256_add_epi16(ff[56],t[56]);
  ff[57]=_mm256_add_epi16(ff[57],t[57]);
  ff[58]=_mm256_add_epi16(ff[58],t[58]);
  ff[59]=_mm256_add_epi16(ff[59],t[59]);
  ff[60]=_mm256_add_epi16(ff[60],t[60]);
  ff[61]=_mm256_add_epi16(ff[61],t[61]);
  ff[62]=_mm256_add_epi16(ff[62],t[62]);
  ff[63]=_mm256_add_epi16(ff[63],t[63]);

  ff[32]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[0]),ff[32]);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[33]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[1]),ff[33]);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[34]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[2]),ff[34]);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[35]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[3]),ff[35]);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[36]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[4]),ff[36]);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[37]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[5]),ff[37]);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[38]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[6]),ff[38]);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[39]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[7]),ff[39]);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);
  ff[40]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[8]),ff[40]);
  ff[8]=_mm256_andnot_si256(uv_mask,ff[8]);
  ff[41]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[9]),ff[41]);
  ff[9]=_mm256_andnot_si256(uv_mask,ff[9]);
  ff[42]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[10]),ff[42]);
  ff[10]=_mm256_andnot_si256(uv_mask,ff[10]);
  ff[43]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[11]),ff[43]);
  ff[11]=_mm256_andnot_si256(uv_mask,ff[11]);
  ff[44]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[12]),ff[44]);
  ff[12]=_mm256_andnot_si256(uv_mask,ff[12]);
  ff[45]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[13]),ff[45]);
  ff[13]=_mm256_andnot_si256(uv_mask,ff[13]);
  ff[46]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[14]),ff[46]);
  ff[14]=_mm256_andnot_si256(uv_mask,ff[14]);
  ff[47]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[15]),ff[47]);
  ff[15]=_mm256_andnot_si256(uv_mask,ff[15]);
  ff[48]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[16]),ff[48]);
  ff[16]=_mm256_andnot_si256(uv_mask,ff[16]);
  ff[49]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[17]),ff[49]);
  ff[17]=_mm256_andnot_si256(uv_mask,ff[17]);
  ff[50]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[18]),ff[50]);
  ff[18]=_mm256_andnot_si256(uv_mask,ff[18]);
  ff[51]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[19]),ff[51]);
  ff[19]=_mm256_andnot_si256(uv_mask,ff[19]);
  ff[52]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[20]),ff[52]);
  ff[20]=_mm256_andnot_si256(uv_mask,ff[20]);
  ff[53]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[21]),ff[53]);
  ff[21]=_mm256_andnot_si256(uv_mask,ff[21]);
  ff[54]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[22]),ff[54]);
  ff[22]=_mm256_andnot_si256(uv_mask,ff[22]);
  ff[55]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[23]),ff[55]);
  ff[23]=_mm256_andnot_si256(uv_mask,ff[23]);
  ff[56]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[24]),ff[56]);
  ff[24]=_mm256_andnot_si256(uv_mask,ff[24]);
  ff[57]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[25]),ff[57]);
  ff[25]=_mm256_andnot_si256(uv_mask,ff[25]);
  ff[58]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[26]),ff[58]);
  ff[26]=_mm256_andnot_si256(uv_mask,ff[26]);
  ff[59]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[27]),ff[59]);
  ff[27]=_mm256_andnot_si256(uv_mask,ff[27]);
  ff[60]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[28]),ff[60]);
  ff[28]=_mm256_andnot_si256(uv_mask,ff[28]);
  ff[61]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[29]),ff[61]);
  ff[29]=_mm256_andnot_si256(uv_mask,ff[29]);
  ff[62]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[30]),ff[62]);
  ff[30]=_mm256_andnot_si256(uv_mask,ff[30]);
  ff[63]=_mm256_or_si256(_mm256_and_si256(uv_mask,ff[31]),ff[63]);
  ff[31]=_mm256_andnot_si256(uv_mask,ff[31]);

  gf_polymul_512x512_avx2_divR(gg,uvqr+64,f);
  gf_polymul_512x512_avx2_divR(t,uvqr+96,g);
  gg[17] = barrett_fake(gg[17]); // <2610
  t[17] = barrett_fake(t[17]); // <2610
  gg[19] = barrett_fake(gg[19]); // <2610
  t[19] = barrett_fake(t[19]); // <2610
  gg[28] = barrett_fake(gg[28]); // <2881
  t[28] = barrett_fake(t[28]); // <2881
  gg[35] = barrett_fake(gg[35]); // <2881
  t[35] = barrett_fake(t[35]); // <2881
  gg[44] = barrett_fake(gg[44]); // <2610
  t[44] = barrett_fake(t[44]); // <2610
  gg[46] = barrett_fake(gg[46]); // <2610
  t[46] = barrett_fake(t[46]); // <2610

  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);
  gg[8]=_mm256_add_epi16(gg[8],t[8]);
  gg[9]=_mm256_add_epi16(gg[9],t[9]);
  gg[10]=_mm256_add_epi16(gg[10],t[10]);
  gg[11]=_mm256_add_epi16(gg[11],t[11]);
  gg[12]=_mm256_add_epi16(gg[12],t[12]);
  gg[13]=_mm256_add_epi16(gg[13],t[13]);
  gg[14]=_mm256_add_epi16(gg[14],t[14]);
  gg[15]=_mm256_add_epi16(gg[15],t[15]);
  gg[16]=_mm256_add_epi16(gg[16],t[16]);
  gg[17]=_mm256_add_epi16(gg[17],t[17]);
  gg[18]=_mm256_add_epi16(gg[18],t[18]);
  gg[19]=_mm256_add_epi16(gg[19],t[19]);
  gg[20]=_mm256_add_epi16(gg[20],t[20]);
  gg[21]=_mm256_add_epi16(gg[21],t[21]);
  gg[22]=_mm256_add_epi16(gg[22],t[22]);
  gg[23]=_mm256_add_epi16(gg[23],t[23]);
  gg[24]=_mm256_add_epi16(gg[24],t[24]);
  gg[25]=_mm256_add_epi16(gg[25],t[25]);
  gg[26]=_mm256_add_epi16(gg[26],t[26]);
  gg[27]=_mm256_add_epi16(gg[27],t[27]);
  gg[28]=_mm256_add_epi16(gg[28],t[28]);
  gg[29]=_mm256_add_epi16(gg[29],t[29]);
  gg[30]=_mm256_add_epi16(gg[30],t[30]);
  gg[31]=_mm256_add_epi16(gg[31],t[31]);
  gg[32]=_mm256_add_epi16(gg[32],t[32]);
  gg[33]=_mm256_add_epi16(gg[33],t[33]);
  gg[34]=_mm256_add_epi16(gg[34],t[34]);
  gg[35]=_mm256_add_epi16(gg[35],t[35]);
  gg[36]=_mm256_add_epi16(gg[36],t[36]);
  gg[37]=_mm256_add_epi16(gg[37],t[37]);
  gg[38]=_mm256_add_epi16(gg[38],t[38]);
  gg[39]=_mm256_add_epi16(gg[39],t[39]);
  gg[40]=_mm256_add_epi16(gg[40],t[40]);
  gg[41]=_mm256_add_epi16(gg[41],t[41]);
  gg[42]=_mm256_add_epi16(gg[42],t[42]);
  gg[43]=_mm256_add_epi16(gg[43],t[43]);
  gg[44]=_mm256_add_epi16(gg[44],t[44]);
  gg[45]=_mm256_add_epi16(gg[45],t[45]);
  gg[46]=_mm256_add_epi16(gg[46],t[46]);
  gg[47]=_mm256_add_epi16(gg[47],t[47]);
  gg[48]=_mm256_add_epi16(gg[48],t[48]);
  gg[49]=_mm256_add_epi16(gg[49],t[49]);
  gg[50]=_mm256_add_epi16(gg[50],t[50]);
  gg[51]=_mm256_add_epi16(gg[51],t[51]);
  gg[52]=_mm256_add_epi16(gg[52],t[52]);
  gg[53]=_mm256_add_epi16(gg[53],t[53]);
  gg[54]=_mm256_add_epi16(gg[54],t[54]);
  gg[55]=_mm256_add_epi16(gg[55],t[55]);
  gg[56]=_mm256_add_epi16(gg[56],t[56]);
  gg[57]=_mm256_add_epi16(gg[57],t[57]);
  gg[58]=_mm256_add_epi16(gg[58],t[58]);
  gg[59]=_mm256_add_epi16(gg[59],t[59]);
  gg[60]=_mm256_add_epi16(gg[60],t[60]);
  gg[61]=_mm256_add_epi16(gg[61],t[61]);
  gg[62]=_mm256_add_epi16(gg[62],t[62]);
  gg[63]=_mm256_add_epi16(gg[63],t[63]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  gg[0] = montproduct(gg[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  gg[1] = montproduct(gg[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  gg[2] = montproduct(gg[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  gg[3] = montproduct(gg[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2614
  gg[4] = montproduct(gg[4],v4158_16); // <2614
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  gg[5] = montproduct(gg[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <2614
  gg[6] = montproduct(gg[6],v4158_16); // <2614
  ff[7] = montproduct(ff[7],v4158_16); // <2614
  gg[7] = montproduct(gg[7],v4158_16); // <2614
  ff[8] = montproduct(ff[8],v4158_16); // <2614
  gg[8] = montproduct(gg[8],v4158_16); // <2614
  ff[9] = montproduct(ff[9],v4158_16); // <2626
  gg[9] = montproduct(gg[9],v4158_16); // <2626
  ff[10] = montproduct(ff[10],v4158_16); // <2603
  gg[10] = montproduct(gg[10],v4158_16); // <2603
  ff[11] = montproduct(ff[11],v4158_16); // <2603
  gg[11] = montproduct(gg[11],v4158_16); // <2603
  ff[12] = montproduct(ff[12],v4158_16); // <3574
  gg[12] = montproduct(gg[12],v4158_16); // <3574
  ff[13] = montproduct(ff[13],v4158_16); // <2603
  gg[13] = montproduct(gg[13],v4158_16); // <2603
  ff[14] = montproduct(ff[14],v4158_16); // <2614
  gg[14] = montproduct(gg[14],v4158_16); // <2614
  ff[15] = montproduct(ff[15],v4158_16); // <2603
  gg[15] = montproduct(gg[15],v4158_16); // <2603
  ff[16] = montproduct(ff[16],v4158_16); // <4019
  gg[16] = montproduct(gg[16],v4158_16); // <4019
  ff[17] = montproduct(ff[17],v4158_16); // <2626
  gg[17] = montproduct(gg[17],v4158_16); // <2626
  ff[18] = montproduct(ff[18],v4158_16); // <3574
  gg[18] = montproduct(gg[18],v4158_16); // <3574
  ff[19] = montproduct(ff[19],v4158_16); // <2626
  gg[19] = montproduct(gg[19],v4158_16); // <2626
  ff[20] = montproduct(ff[20],v4158_16); // <3551
  gg[20] = montproduct(gg[20],v4158_16); // <3551
  ff[21] = montproduct(ff[21],v4158_16); // <3585
  gg[21] = montproduct(gg[21],v4158_16); // <3585
  ff[22] = montproduct(ff[22],v4158_16); // <3574
  gg[22] = montproduct(gg[22],v4158_16); // <3574
  ff[23] = montproduct(ff[23],v4158_16); // <3562
  gg[23] = montproduct(gg[23],v4158_16); // <3562
  ff[24] = montproduct(ff[24],v4158_16); // <3562
  gg[24] = montproduct(gg[24],v4158_16); // <3562
  ff[25] = montproduct(ff[25],v4158_16); // <3596
  gg[25] = montproduct(gg[25],v4158_16); // <3596
  ff[26] = montproduct(ff[26],v4158_16); // <3551
  gg[26] = montproduct(gg[26],v4158_16); // <3551
  ff[27] = montproduct(ff[27],v4158_16); // <3539
  gg[27] = montproduct(gg[27],v4158_16); // <3539
  ff[28] = montproduct(ff[28],v4158_16); // <2660
  gg[28] = montproduct(gg[28],v4158_16); // <2660
  ff[29] = montproduct(ff[29],v4158_16); // <3551
  gg[29] = montproduct(gg[29],v4158_16); // <3551
  ff[30] = montproduct(ff[30],v4158_16); // <4032
  gg[30] = montproduct(gg[30],v4158_16); // <4032
  ff[31] = montproduct(ff[31],v4158_16); // <3752
  gg[31] = montproduct(gg[31],v4158_16); // <3752
  ff[32] = montproduct(ff[32],v4158_16); // <3791
  gg[32] = montproduct(gg[32],v4158_16); // <3791
  ff[33] = montproduct(ff[33],v4158_16); // <4048
  gg[33] = montproduct(gg[33],v4158_16); // <4048
  ff[34] = montproduct(ff[34],v4158_16); // <3551
  gg[34] = montproduct(gg[34],v4158_16); // <3551
  ff[35] = montproduct(ff[35],v4158_16); // <2660
  gg[35] = montproduct(gg[35],v4158_16); // <2660
  ff[36] = montproduct(ff[36],v4158_16); // <3539
  gg[36] = montproduct(gg[36],v4158_16); // <3539
  ff[37] = montproduct(ff[37],v4158_16); // <3551
  gg[37] = montproduct(gg[37],v4158_16); // <3551
  ff[38] = montproduct(ff[38],v4158_16); // <3596
  gg[38] = montproduct(gg[38],v4158_16); // <3596
  ff[39] = montproduct(ff[39],v4158_16); // <3562
  gg[39] = montproduct(gg[39],v4158_16); // <3562
  ff[40] = montproduct(ff[40],v4158_16); // <3562
  gg[40] = montproduct(gg[40],v4158_16); // <3562
  ff[41] = montproduct(ff[41],v4158_16); // <3574
  gg[41] = montproduct(gg[41],v4158_16); // <3574
  ff[42] = montproduct(ff[42],v4158_16); // <3585
  gg[42] = montproduct(gg[42],v4158_16); // <3585
  ff[43] = montproduct(ff[43],v4158_16); // <3551
  gg[43] = montproduct(gg[43],v4158_16); // <3551
  ff[44] = montproduct(ff[44],v4158_16); // <2626
  gg[44] = montproduct(gg[44],v4158_16); // <2626
  ff[45] = montproduct(ff[45],v4158_16); // <3574
  gg[45] = montproduct(gg[45],v4158_16); // <3574
  ff[46] = montproduct(ff[46],v4158_16); // <2626
  gg[46] = montproduct(gg[46],v4158_16); // <2626
  ff[47] = montproduct(ff[47],v4158_16); // <3976
  gg[47] = montproduct(gg[47],v4158_16); // <3976
  ff[48] = montproduct(ff[48],v4158_16); // <2614
  gg[48] = montproduct(gg[48],v4158_16); // <2614
  ff[49] = montproduct(ff[49],v4158_16); // <2614
  gg[49] = montproduct(gg[49],v4158_16); // <2614
  ff[50] = montproduct(ff[50],v4158_16); // <2603
  gg[50] = montproduct(gg[50],v4158_16); // <2603
  ff[51] = montproduct(ff[51],v4158_16); // <3574
  gg[51] = montproduct(gg[51],v4158_16); // <3574
  ff[52] = montproduct(ff[52],v4158_16); // <2603
  gg[52] = montproduct(gg[52],v4158_16); // <2603
  ff[53] = montproduct(ff[53],v4158_16); // <2603
  gg[53] = montproduct(gg[53],v4158_16); // <2603
  ff[54] = montproduct(ff[54],v4158_16); // <2626
  gg[54] = montproduct(gg[54],v4158_16); // <2626
  ff[55] = montproduct(ff[55],v4158_16); // <2614
  gg[55] = montproduct(gg[55],v4158_16); // <2614
  ff[56] = montproduct(ff[56],v4158_16); // <2614
  gg[56] = montproduct(gg[56],v4158_16); // <2614
  ff[57] = montproduct(ff[57],v4158_16); // <2614
  gg[57] = montproduct(gg[57],v4158_16); // <2614
  ff[58] = montproduct(ff[58],v4158_16); // <2626
  gg[58] = montproduct(gg[58],v4158_16); // <2626
  ff[59] = montproduct(ff[59],v4158_16); // <2614
  gg[59] = montproduct(gg[59],v4158_16); // <2614
  ff[60] = montproduct(ff[60],v4158_16); // <2626
  gg[60] = montproduct(gg[60],v4158_16); // <2626
  ff[61] = montproduct(ff[61],v4158_16); // <2626
  gg[61] = montproduct(gg[61],v4158_16); // <2626
  ff[62] = montproduct(ff[62],v4158_16); // <3084
  gg[62] = montproduct(gg[62],v4158_16); // <3084
  ff[63] = montproduct(ff[63],v4158_16); // <2827
  gg[63] = montproduct(gg[63],v4158_16); // <2827
}
void gf_polymul_512x512_avx2_uvqr_vr (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[64];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+32);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);
  __m256i f_mask = uv_over(f);

  gf_polymul_512x512_avx2_divR(ff,uvqr,f);
  ff[32]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[0]),ff[32]);
  ff[0]=_mm256_andnot_si256(f_mask,ff[0]);
  ff[33]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[1]),ff[33]);
  ff[1]=_mm256_andnot_si256(f_mask,ff[1]);
  ff[34]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[2]),ff[34]);
  ff[2]=_mm256_andnot_si256(f_mask,ff[2]);
  ff[35]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[3]),ff[35]);
  ff[3]=_mm256_andnot_si256(f_mask,ff[3]);
  ff[36]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[4]),ff[36]);
  ff[4]=_mm256_andnot_si256(f_mask,ff[4]);
  ff[37]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[5]),ff[37]);
  ff[5]=_mm256_andnot_si256(f_mask,ff[5]);
  ff[38]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[6]),ff[38]);
  ff[6]=_mm256_andnot_si256(f_mask,ff[6]);
  ff[39]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[7]),ff[39]);
  ff[7]=_mm256_andnot_si256(f_mask,ff[7]);
  ff[40]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[8]),ff[40]);
  ff[8]=_mm256_andnot_si256(f_mask,ff[8]);
  ff[41]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[9]),ff[41]);
  ff[9]=_mm256_andnot_si256(f_mask,ff[9]);
  ff[42]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[10]),ff[42]);
  ff[10]=_mm256_andnot_si256(f_mask,ff[10]);
  ff[43]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[11]),ff[43]);
  ff[11]=_mm256_andnot_si256(f_mask,ff[11]);
  ff[44]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[12]),ff[44]);
  ff[12]=_mm256_andnot_si256(f_mask,ff[12]);
  ff[45]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[13]),ff[45]);
  ff[13]=_mm256_andnot_si256(f_mask,ff[13]);
  ff[46]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[14]),ff[46]);
  ff[14]=_mm256_andnot_si256(f_mask,ff[14]);
  ff[47]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[15]),ff[47]);
  ff[15]=_mm256_andnot_si256(f_mask,ff[15]);
  ff[48]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[16]),ff[48]);
  ff[16]=_mm256_andnot_si256(f_mask,ff[16]);
  ff[49]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[17]),ff[49]);
  ff[17]=_mm256_andnot_si256(f_mask,ff[17]);
  ff[50]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[18]),ff[50]);
  ff[18]=_mm256_andnot_si256(f_mask,ff[18]);
  ff[51]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[19]),ff[51]);
  ff[19]=_mm256_andnot_si256(f_mask,ff[19]);
  ff[52]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[20]),ff[52]);
  ff[20]=_mm256_andnot_si256(f_mask,ff[20]);
  ff[53]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[21]),ff[53]);
  ff[21]=_mm256_andnot_si256(f_mask,ff[21]);
  ff[54]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[22]),ff[54]);
  ff[22]=_mm256_andnot_si256(f_mask,ff[22]);
  ff[55]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[23]),ff[55]);
  ff[23]=_mm256_andnot_si256(f_mask,ff[23]);
  ff[56]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[24]),ff[56]);
  ff[24]=_mm256_andnot_si256(f_mask,ff[24]);
  ff[57]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[25]),ff[57]);
  ff[25]=_mm256_andnot_si256(f_mask,ff[25]);
  ff[58]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[26]),ff[58]);
  ff[26]=_mm256_andnot_si256(f_mask,ff[26]);
  ff[59]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[27]),ff[59]);
  ff[27]=_mm256_andnot_si256(f_mask,ff[27]);
  ff[60]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[28]),ff[60]);
  ff[28]=_mm256_andnot_si256(f_mask,ff[28]);
  ff[61]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[29]),ff[61]);
  ff[29]=_mm256_andnot_si256(f_mask,ff[29]);
  ff[62]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[30]),ff[62]);
  ff[30]=_mm256_andnot_si256(f_mask,ff[30]);
  ff[63]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[31]),ff[63]);
  ff[31]=_mm256_andnot_si256(f_mask,ff[31]);
  gf_polymul_512x512_avx2_divR(t,uvqr+32,g);
  ff[17] = barrett_fake(ff[17]); // <2610
  t[17] = barrett_fake(t[17]); // <2610
  ff[19] = barrett_fake(ff[19]); // <2610
  t[19] = barrett_fake(t[19]); // <2610
  ff[28] = barrett_fake(ff[28]); // <2881
  t[28] = barrett_fake(t[28]); // <2881
  ff[35] = barrett_fake(ff[35]); // <2881
  t[35] = barrett_fake(t[35]); // <2881
  ff[44] = barrett_fake(ff[44]); // <2610
  t[44] = barrett_fake(t[44]); // <2610
  ff[46] = barrett_fake(ff[46]); // <2610
  t[46] = barrett_fake(t[46]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);
  ff[16]=_mm256_add_epi16(ff[16],t[16]);
  ff[17]=_mm256_add_epi16(ff[17],t[17]);
  ff[18]=_mm256_add_epi16(ff[18],t[18]);
  ff[19]=_mm256_add_epi16(ff[19],t[19]);
  ff[20]=_mm256_add_epi16(ff[20],t[20]);
  ff[21]=_mm256_add_epi16(ff[21],t[21]);
  ff[22]=_mm256_add_epi16(ff[22],t[22]);
  ff[23]=_mm256_add_epi16(ff[23],t[23]);
  ff[24]=_mm256_add_epi16(ff[24],t[24]);
  ff[25]=_mm256_add_epi16(ff[25],t[25]);
  ff[26]=_mm256_add_epi16(ff[26],t[26]);
  ff[27]=_mm256_add_epi16(ff[27],t[27]);
  ff[28]=_mm256_add_epi16(ff[28],t[28]);
  ff[29]=_mm256_add_epi16(ff[29],t[29]);
  ff[30]=_mm256_add_epi16(ff[30],t[30]);
  ff[31]=_mm256_add_epi16(ff[31],t[31]);
  ff[32]=_mm256_add_epi16(ff[32],t[32]);
  ff[33]=_mm256_add_epi16(ff[33],t[33]);
  ff[34]=_mm256_add_epi16(ff[34],t[34]);
  ff[35]=_mm256_add_epi16(ff[35],t[35]);
  ff[36]=_mm256_add_epi16(ff[36],t[36]);
  ff[37]=_mm256_add_epi16(ff[37],t[37]);
  ff[38]=_mm256_add_epi16(ff[38],t[38]);
  ff[39]=_mm256_add_epi16(ff[39],t[39]);
  ff[40]=_mm256_add_epi16(ff[40],t[40]);
  ff[41]=_mm256_add_epi16(ff[41],t[41]);
  ff[42]=_mm256_add_epi16(ff[42],t[42]);
  ff[43]=_mm256_add_epi16(ff[43],t[43]);
  ff[44]=_mm256_add_epi16(ff[44],t[44]);
  ff[45]=_mm256_add_epi16(ff[45],t[45]);
  ff[46]=_mm256_add_epi16(ff[46],t[46]);
  ff[47]=_mm256_add_epi16(ff[47],t[47]);
  ff[48]=_mm256_add_epi16(ff[48],t[48]);
  ff[49]=_mm256_add_epi16(ff[49],t[49]);
  ff[50]=_mm256_add_epi16(ff[50],t[50]);
  ff[51]=_mm256_add_epi16(ff[51],t[51]);
  ff[52]=_mm256_add_epi16(ff[52],t[52]);
  ff[53]=_mm256_add_epi16(ff[53],t[53]);
  ff[54]=_mm256_add_epi16(ff[54],t[54]);
  ff[55]=_mm256_add_epi16(ff[55],t[55]);
  ff[56]=_mm256_add_epi16(ff[56],t[56]);
  ff[57]=_mm256_add_epi16(ff[57],t[57]);
  ff[58]=_mm256_add_epi16(ff[58],t[58]);
  ff[59]=_mm256_add_epi16(ff[59],t[59]);
  ff[60]=_mm256_add_epi16(ff[60],t[60]);
  ff[61]=_mm256_add_epi16(ff[61],t[61]);
  ff[62]=_mm256_add_epi16(ff[62],t[62]);
  ff[63]=_mm256_add_epi16(ff[63],t[63]);

  ff[32]=_mm256_blendv_epi8(ff[32],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[33]=_mm256_blendv_epi8(ff[33],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[34]=_mm256_blendv_epi8(ff[34],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[35]=_mm256_blendv_epi8(ff[35],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[36]=_mm256_blendv_epi8(ff[36],ff[4],uv_mask);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[37]=_mm256_blendv_epi8(ff[37],ff[5],uv_mask);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[38]=_mm256_blendv_epi8(ff[38],ff[6],uv_mask);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[39]=_mm256_blendv_epi8(ff[39],ff[7],uv_mask);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);
  ff[40]=_mm256_blendv_epi8(ff[40],ff[8],uv_mask);
  ff[8]=_mm256_andnot_si256(uv_mask,ff[8]);
  ff[41]=_mm256_blendv_epi8(ff[41],ff[9],uv_mask);
  ff[9]=_mm256_andnot_si256(uv_mask,ff[9]);
  ff[42]=_mm256_blendv_epi8(ff[42],ff[10],uv_mask);
  ff[10]=_mm256_andnot_si256(uv_mask,ff[10]);
  ff[43]=_mm256_blendv_epi8(ff[43],ff[11],uv_mask);
  ff[11]=_mm256_andnot_si256(uv_mask,ff[11]);
  ff[44]=_mm256_blendv_epi8(ff[44],ff[12],uv_mask);
  ff[12]=_mm256_andnot_si256(uv_mask,ff[12]);
  ff[45]=_mm256_blendv_epi8(ff[45],ff[13],uv_mask);
  ff[13]=_mm256_andnot_si256(uv_mask,ff[13]);
  ff[46]=_mm256_blendv_epi8(ff[46],ff[14],uv_mask);
  ff[14]=_mm256_andnot_si256(uv_mask,ff[14]);
  ff[47]=_mm256_blendv_epi8(ff[47],ff[15],uv_mask);
  ff[15]=_mm256_andnot_si256(uv_mask,ff[15]);
  ff[48]=_mm256_blendv_epi8(ff[48],ff[16],uv_mask);
  ff[16]=_mm256_andnot_si256(uv_mask,ff[16]);
  ff[49]=_mm256_blendv_epi8(ff[49],ff[17],uv_mask);
  ff[17]=_mm256_andnot_si256(uv_mask,ff[17]);
  ff[50]=_mm256_blendv_epi8(ff[50],ff[18],uv_mask);
  ff[18]=_mm256_andnot_si256(uv_mask,ff[18]);
  ff[51]=_mm256_blendv_epi8(ff[51],ff[19],uv_mask);
  ff[19]=_mm256_andnot_si256(uv_mask,ff[19]);
  ff[52]=_mm256_blendv_epi8(ff[52],ff[20],uv_mask);
  ff[20]=_mm256_andnot_si256(uv_mask,ff[20]);
  ff[53]=_mm256_blendv_epi8(ff[53],ff[21],uv_mask);
  ff[21]=_mm256_andnot_si256(uv_mask,ff[21]);
  ff[54]=_mm256_blendv_epi8(ff[54],ff[22],uv_mask);
  ff[22]=_mm256_andnot_si256(uv_mask,ff[22]);
  ff[55]=_mm256_blendv_epi8(ff[55],ff[23],uv_mask);
  ff[23]=_mm256_andnot_si256(uv_mask,ff[23]);
  ff[56]=_mm256_blendv_epi8(ff[56],ff[24],uv_mask);
  ff[24]=_mm256_andnot_si256(uv_mask,ff[24]);
  ff[57]=_mm256_blendv_epi8(ff[57],ff[25],uv_mask);
  ff[25]=_mm256_andnot_si256(uv_mask,ff[25]);
  ff[58]=_mm256_blendv_epi8(ff[58],ff[26],uv_mask);
  ff[26]=_mm256_andnot_si256(uv_mask,ff[26]);
  ff[59]=_mm256_blendv_epi8(ff[59],ff[27],uv_mask);
  ff[27]=_mm256_andnot_si256(uv_mask,ff[27]);
  ff[60]=_mm256_blendv_epi8(ff[60],ff[28],uv_mask);
  ff[28]=_mm256_andnot_si256(uv_mask,ff[28]);
  ff[61]=_mm256_blendv_epi8(ff[61],ff[29],uv_mask);
  ff[29]=_mm256_andnot_si256(uv_mask,ff[29]);
  ff[62]=_mm256_blendv_epi8(ff[62],ff[30],uv_mask);
  ff[30]=_mm256_andnot_si256(uv_mask,ff[30]);
  ff[63]=_mm256_blendv_epi8(ff[63],ff[31],uv_mask);
  ff[31]=_mm256_andnot_si256(uv_mask,ff[31]);

  gf_polymul_512x512_avx2_divR(gg,uvqr+64,f);
  gg[32]=_mm256_blendv_epi8(gg[32],gg[0],f_mask);
  gg[0]=_mm256_andnot_si256(f_mask,gg[0]);
  gg[33]=_mm256_blendv_epi8(gg[33],gg[1],f_mask);
  gg[1]=_mm256_andnot_si256(f_mask,gg[1]);
  gg[34]=_mm256_blendv_epi8(gg[34],gg[2],f_mask);
  gg[2]=_mm256_andnot_si256(f_mask,gg[2]);
  gg[35]=_mm256_blendv_epi8(gg[35],gg[3],f_mask);
  gg[3]=_mm256_andnot_si256(f_mask,gg[3]);
  gg[36]=_mm256_blendv_epi8(gg[36],gg[4],f_mask);
  gg[4]=_mm256_andnot_si256(f_mask,gg[4]);
  gg[37]=_mm256_blendv_epi8(gg[37],gg[5],f_mask);
  gg[5]=_mm256_andnot_si256(f_mask,gg[5]);
  gg[38]=_mm256_blendv_epi8(gg[38],gg[6],f_mask);
  gg[6]=_mm256_andnot_si256(f_mask,gg[6]);
  gg[39]=_mm256_blendv_epi8(gg[39],gg[7],f_mask);
  gg[7]=_mm256_andnot_si256(f_mask,gg[7]);
  gg[40]=_mm256_blendv_epi8(gg[40],gg[8],f_mask);
  gg[8]=_mm256_andnot_si256(f_mask,gg[8]);
  gg[41]=_mm256_blendv_epi8(gg[41],gg[9],f_mask);
  gg[9]=_mm256_andnot_si256(f_mask,gg[9]);
  gg[42]=_mm256_blendv_epi8(gg[42],gg[10],f_mask);
  gg[10]=_mm256_andnot_si256(f_mask,gg[10]);
  gg[43]=_mm256_blendv_epi8(gg[43],gg[11],f_mask);
  gg[11]=_mm256_andnot_si256(f_mask,gg[11]);
  gg[44]=_mm256_blendv_epi8(gg[44],gg[12],f_mask);
  gg[12]=_mm256_andnot_si256(f_mask,gg[12]);
  gg[45]=_mm256_blendv_epi8(gg[45],gg[13],f_mask);
  gg[13]=_mm256_andnot_si256(f_mask,gg[13]);
  gg[46]=_mm256_blendv_epi8(gg[46],gg[14],f_mask);
  gg[14]=_mm256_andnot_si256(f_mask,gg[14]);
  gg[47]=_mm256_blendv_epi8(gg[47],gg[15],f_mask);
  gg[15]=_mm256_andnot_si256(f_mask,gg[15]);
  gg[48]=_mm256_blendv_epi8(gg[48],gg[16],f_mask);
  gg[16]=_mm256_andnot_si256(f_mask,gg[16]);
  gg[49]=_mm256_blendv_epi8(gg[49],gg[17],f_mask);
  gg[17]=_mm256_andnot_si256(f_mask,gg[17]);
  gg[50]=_mm256_blendv_epi8(gg[50],gg[18],f_mask);
  gg[18]=_mm256_andnot_si256(f_mask,gg[18]);
  gg[51]=_mm256_blendv_epi8(gg[51],gg[19],f_mask);
  gg[19]=_mm256_andnot_si256(f_mask,gg[19]);
  gg[52]=_mm256_blendv_epi8(gg[52],gg[20],f_mask);
  gg[20]=_mm256_andnot_si256(f_mask,gg[20]);
  gg[53]=_mm256_blendv_epi8(gg[53],gg[21],f_mask);
  gg[21]=_mm256_andnot_si256(f_mask,gg[21]);
  gg[54]=_mm256_blendv_epi8(gg[54],gg[22],f_mask);
  gg[22]=_mm256_andnot_si256(f_mask,gg[22]);
  gg[55]=_mm256_blendv_epi8(gg[55],gg[23],f_mask);
  gg[23]=_mm256_andnot_si256(f_mask,gg[23]);
  gg[56]=_mm256_blendv_epi8(gg[56],gg[24],f_mask);
  gg[24]=_mm256_andnot_si256(f_mask,gg[24]);
  gg[57]=_mm256_blendv_epi8(gg[57],gg[25],f_mask);
  gg[25]=_mm256_andnot_si256(f_mask,gg[25]);
  gg[58]=_mm256_blendv_epi8(gg[58],gg[26],f_mask);
  gg[26]=_mm256_andnot_si256(f_mask,gg[26]);
  gg[59]=_mm256_blendv_epi8(gg[59],gg[27],f_mask);
  gg[27]=_mm256_andnot_si256(f_mask,gg[27]);
  gg[60]=_mm256_blendv_epi8(gg[60],gg[28],f_mask);
  gg[28]=_mm256_andnot_si256(f_mask,gg[28]);
  gg[61]=_mm256_blendv_epi8(gg[61],gg[29],f_mask);
  gg[29]=_mm256_andnot_si256(f_mask,gg[29]);
  gg[62]=_mm256_blendv_epi8(gg[62],gg[30],f_mask);
  gg[30]=_mm256_andnot_si256(f_mask,gg[30]);
  gg[63]=_mm256_blendv_epi8(gg[63],gg[31],f_mask);
  gg[31]=_mm256_andnot_si256(f_mask,gg[31]);
  gf_polymul_512x512_avx2_divR(t,uvqr+96,g);
  gg[17] = barrett_fake(gg[17]); // <2610
  t[17] = barrett_fake(t[17]); // <2610
  gg[19] = barrett_fake(gg[19]); // <2610
  t[19] = barrett_fake(t[19]); // <2610
  gg[28] = barrett_fake(gg[28]); // <2881
  t[28] = barrett_fake(t[28]); // <2881
  gg[35] = barrett_fake(gg[35]); // <2881
  t[35] = barrett_fake(t[35]); // <2881
  gg[44] = barrett_fake(gg[44]); // <2610
  t[44] = barrett_fake(t[44]); // <2610
  gg[46] = barrett_fake(gg[46]); // <2610
  t[46] = barrett_fake(t[46]); // <2610

  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);
  gg[8]=_mm256_add_epi16(gg[8],t[8]);
  gg[9]=_mm256_add_epi16(gg[9],t[9]);
  gg[10]=_mm256_add_epi16(gg[10],t[10]);
  gg[11]=_mm256_add_epi16(gg[11],t[11]);
  gg[12]=_mm256_add_epi16(gg[12],t[12]);
  gg[13]=_mm256_add_epi16(gg[13],t[13]);
  gg[14]=_mm256_add_epi16(gg[14],t[14]);
  gg[15]=_mm256_add_epi16(gg[15],t[15]);
  gg[16]=_mm256_add_epi16(gg[16],t[16]);
  gg[17]=_mm256_add_epi16(gg[17],t[17]);
  gg[18]=_mm256_add_epi16(gg[18],t[18]);
  gg[19]=_mm256_add_epi16(gg[19],t[19]);
  gg[20]=_mm256_add_epi16(gg[20],t[20]);
  gg[21]=_mm256_add_epi16(gg[21],t[21]);
  gg[22]=_mm256_add_epi16(gg[22],t[22]);
  gg[23]=_mm256_add_epi16(gg[23],t[23]);
  gg[24]=_mm256_add_epi16(gg[24],t[24]);
  gg[25]=_mm256_add_epi16(gg[25],t[25]);
  gg[26]=_mm256_add_epi16(gg[26],t[26]);
  gg[27]=_mm256_add_epi16(gg[27],t[27]);
  gg[28]=_mm256_add_epi16(gg[28],t[28]);
  gg[29]=_mm256_add_epi16(gg[29],t[29]);
  gg[30]=_mm256_add_epi16(gg[30],t[30]);
  gg[31]=_mm256_add_epi16(gg[31],t[31]);
  gg[32]=_mm256_add_epi16(gg[32],t[32]);
  gg[33]=_mm256_add_epi16(gg[33],t[33]);
  gg[34]=_mm256_add_epi16(gg[34],t[34]);
  gg[35]=_mm256_add_epi16(gg[35],t[35]);
  gg[36]=_mm256_add_epi16(gg[36],t[36]);
  gg[37]=_mm256_add_epi16(gg[37],t[37]);
  gg[38]=_mm256_add_epi16(gg[38],t[38]);
  gg[39]=_mm256_add_epi16(gg[39],t[39]);
  gg[40]=_mm256_add_epi16(gg[40],t[40]);
  gg[41]=_mm256_add_epi16(gg[41],t[41]);
  gg[42]=_mm256_add_epi16(gg[42],t[42]);
  gg[43]=_mm256_add_epi16(gg[43],t[43]);
  gg[44]=_mm256_add_epi16(gg[44],t[44]);
  gg[45]=_mm256_add_epi16(gg[45],t[45]);
  gg[46]=_mm256_add_epi16(gg[46],t[46]);
  gg[47]=_mm256_add_epi16(gg[47],t[47]);
  gg[48]=_mm256_add_epi16(gg[48],t[48]);
  gg[49]=_mm256_add_epi16(gg[49],t[49]);
  gg[50]=_mm256_add_epi16(gg[50],t[50]);
  gg[51]=_mm256_add_epi16(gg[51],t[51]);
  gg[52]=_mm256_add_epi16(gg[52],t[52]);
  gg[53]=_mm256_add_epi16(gg[53],t[53]);
  gg[54]=_mm256_add_epi16(gg[54],t[54]);
  gg[55]=_mm256_add_epi16(gg[55],t[55]);
  gg[56]=_mm256_add_epi16(gg[56],t[56]);
  gg[57]=_mm256_add_epi16(gg[57],t[57]);
  gg[58]=_mm256_add_epi16(gg[58],t[58]);
  gg[59]=_mm256_add_epi16(gg[59],t[59]);
  gg[60]=_mm256_add_epi16(gg[60],t[60]);
  gg[61]=_mm256_add_epi16(gg[61],t[61]);
  gg[62]=_mm256_add_epi16(gg[62],t[62]);
  gg[63]=_mm256_add_epi16(gg[63],t[63]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  gg[0] = montproduct(gg[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  gg[1] = montproduct(gg[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  gg[2] = montproduct(gg[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  gg[3] = montproduct(gg[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2614
  gg[4] = montproduct(gg[4],v4158_16); // <2614
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  gg[5] = montproduct(gg[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <2614
  gg[6] = montproduct(gg[6],v4158_16); // <2614
  ff[7] = montproduct(ff[7],v4158_16); // <2614
  gg[7] = montproduct(gg[7],v4158_16); // <2614
  ff[8] = montproduct(ff[8],v4158_16); // <2614
  gg[8] = montproduct(gg[8],v4158_16); // <2614
  ff[9] = montproduct(ff[9],v4158_16); // <2626
  gg[9] = montproduct(gg[9],v4158_16); // <2626
  ff[10] = montproduct(ff[10],v4158_16); // <2603
  gg[10] = montproduct(gg[10],v4158_16); // <2603
  ff[11] = montproduct(ff[11],v4158_16); // <2603
  gg[11] = montproduct(gg[11],v4158_16); // <2603
  ff[12] = montproduct(ff[12],v4158_16); // <3574
  gg[12] = montproduct(gg[12],v4158_16); // <3574
  ff[13] = montproduct(ff[13],v4158_16); // <2603
  gg[13] = montproduct(gg[13],v4158_16); // <2603
  ff[14] = montproduct(ff[14],v4158_16); // <2614
  gg[14] = montproduct(gg[14],v4158_16); // <2614
  ff[15] = montproduct(ff[15],v4158_16); // <2603
  gg[15] = montproduct(gg[15],v4158_16); // <2603
  ff[16] = montproduct(ff[16],v4158_16); // <4019
  gg[16] = montproduct(gg[16],v4158_16); // <4019
  ff[17] = montproduct(ff[17],v4158_16); // <2626
  gg[17] = montproduct(gg[17],v4158_16); // <2626
  ff[18] = montproduct(ff[18],v4158_16); // <3574
  gg[18] = montproduct(gg[18],v4158_16); // <3574
  ff[19] = montproduct(ff[19],v4158_16); // <2626
  gg[19] = montproduct(gg[19],v4158_16); // <2626
  ff[20] = montproduct(ff[20],v4158_16); // <3551
  gg[20] = montproduct(gg[20],v4158_16); // <3551
  ff[21] = montproduct(ff[21],v4158_16); // <3585
  gg[21] = montproduct(gg[21],v4158_16); // <3585
  ff[22] = montproduct(ff[22],v4158_16); // <3574
  gg[22] = montproduct(gg[22],v4158_16); // <3574
  ff[23] = montproduct(ff[23],v4158_16); // <3562
  gg[23] = montproduct(gg[23],v4158_16); // <3562
  ff[24] = montproduct(ff[24],v4158_16); // <3562
  gg[24] = montproduct(gg[24],v4158_16); // <3562
  ff[25] = montproduct(ff[25],v4158_16); // <3596
  gg[25] = montproduct(gg[25],v4158_16); // <3596
  ff[26] = montproduct(ff[26],v4158_16); // <3551
  gg[26] = montproduct(gg[26],v4158_16); // <3551
  ff[27] = montproduct(ff[27],v4158_16); // <3539
  gg[27] = montproduct(gg[27],v4158_16); // <3539
  ff[28] = montproduct(ff[28],v4158_16); // <2660
  gg[28] = montproduct(gg[28],v4158_16); // <2660
  ff[29] = montproduct(ff[29],v4158_16); // <3551
  gg[29] = montproduct(gg[29],v4158_16); // <3551
  ff[30] = montproduct(ff[30],v4158_16); // <4032
  gg[30] = montproduct(gg[30],v4158_16); // <4032
  ff[31] = montproduct(ff[31],v4158_16); // <3752
  gg[31] = montproduct(gg[31],v4158_16); // <3752
  ff[32] = montproduct(ff[32],v4158_16); // <3791
  gg[32] = montproduct(gg[32],v4158_16); // <3791
  ff[33] = montproduct(ff[33],v4158_16); // <4048
  gg[33] = montproduct(gg[33],v4158_16); // <4048
  ff[34] = montproduct(ff[34],v4158_16); // <3551
  gg[34] = montproduct(gg[34],v4158_16); // <3551
  ff[35] = montproduct(ff[35],v4158_16); // <2660
  gg[35] = montproduct(gg[35],v4158_16); // <2660
  ff[36] = montproduct(ff[36],v4158_16); // <3539
  gg[36] = montproduct(gg[36],v4158_16); // <3539
  ff[37] = montproduct(ff[37],v4158_16); // <3551
  gg[37] = montproduct(gg[37],v4158_16); // <3551
  ff[38] = montproduct(ff[38],v4158_16); // <3596
  gg[38] = montproduct(gg[38],v4158_16); // <3596
  ff[39] = montproduct(ff[39],v4158_16); // <3562
  gg[39] = montproduct(gg[39],v4158_16); // <3562
  ff[40] = montproduct(ff[40],v4158_16); // <3562
  gg[40] = montproduct(gg[40],v4158_16); // <3562
  ff[41] = montproduct(ff[41],v4158_16); // <3574
  gg[41] = montproduct(gg[41],v4158_16); // <3574
  ff[42] = montproduct(ff[42],v4158_16); // <3585
  gg[42] = montproduct(gg[42],v4158_16); // <3585
  ff[43] = montproduct(ff[43],v4158_16); // <3551
  gg[43] = montproduct(gg[43],v4158_16); // <3551
  ff[44] = montproduct(ff[44],v4158_16); // <2626
  gg[44] = montproduct(gg[44],v4158_16); // <2626
  ff[45] = montproduct(ff[45],v4158_16); // <3574
  gg[45] = montproduct(gg[45],v4158_16); // <3574
  ff[46] = montproduct(ff[46],v4158_16); // <2626
  gg[46] = montproduct(gg[46],v4158_16); // <2626
  ff[47] = montproduct(ff[47],v4158_16); // <3976
  gg[47] = montproduct(gg[47],v4158_16); // <3976
  ff[48] = montproduct(ff[48],v4158_16); // <2614
  gg[48] = montproduct(gg[48],v4158_16); // <2614
  ff[49] = montproduct(ff[49],v4158_16); // <2614
  gg[49] = montproduct(gg[49],v4158_16); // <2614
  ff[50] = montproduct(ff[50],v4158_16); // <2603
  gg[50] = montproduct(gg[50],v4158_16); // <2603
  ff[51] = montproduct(ff[51],v4158_16); // <3574
  gg[51] = montproduct(gg[51],v4158_16); // <3574
  ff[52] = montproduct(ff[52],v4158_16); // <2603
  gg[52] = montproduct(gg[52],v4158_16); // <2603
  ff[53] = montproduct(ff[53],v4158_16); // <2603
  gg[53] = montproduct(gg[53],v4158_16); // <2603
  ff[54] = montproduct(ff[54],v4158_16); // <2626
  gg[54] = montproduct(gg[54],v4158_16); // <2626
  ff[55] = montproduct(ff[55],v4158_16); // <2614
  gg[55] = montproduct(gg[55],v4158_16); // <2614
  ff[56] = montproduct(ff[56],v4158_16); // <2614
  gg[56] = montproduct(gg[56],v4158_16); // <2614
  ff[57] = montproduct(ff[57],v4158_16); // <2614
  gg[57] = montproduct(gg[57],v4158_16); // <2614
  ff[58] = montproduct(ff[58],v4158_16); // <2626
  gg[58] = montproduct(gg[58],v4158_16); // <2626
  ff[59] = montproduct(ff[59],v4158_16); // <2614
  gg[59] = montproduct(gg[59],v4158_16); // <2614
  ff[60] = montproduct(ff[60],v4158_16); // <2626
  gg[60] = montproduct(gg[60],v4158_16); // <2626
  ff[61] = montproduct(ff[61],v4158_16); // <2626
  gg[61] = montproduct(gg[61],v4158_16); // <2626
  ff[62] = montproduct(ff[62],v4158_16); // <3084
  gg[62] = montproduct(gg[62],v4158_16); // <3084
  ff[63] = montproduct(ff[63],v4158_16); // <2827
  gg[63] = montproduct(gg[63],v4158_16); // <2827

  ff[0] = _mm256_blendv_epi8(ff[0],v01,u_mask&f_mask);
}
void gf_polymul_512x512_avx2_uvqr_fg_x (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[64];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+32);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);

  gf_polymul_512x512_avx2_divR(ff,uvqr,f);
  gf_polymul_512x512_avx2_divR(t,uvqr+32,g);
  ff[17] = barrett_fake(ff[17]); // <2610
  t[17] = barrett_fake(t[17]); // <2610
  ff[19] = barrett_fake(ff[19]); // <2610
  t[19] = barrett_fake(t[19]); // <2610
  ff[28] = barrett_fake(ff[28]); // <2881
  t[28] = barrett_fake(t[28]); // <2881
  ff[35] = barrett_fake(ff[35]); // <2881
  t[35] = barrett_fake(t[35]); // <2881
  ff[44] = barrett_fake(ff[44]); // <2610
  t[44] = barrett_fake(t[44]); // <2610
  ff[46] = barrett_fake(ff[46]); // <2610
  t[46] = barrett_fake(t[46]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);
  ff[16]=_mm256_add_epi16(ff[16],t[16]);
  ff[17]=_mm256_add_epi16(ff[17],t[17]);
  ff[18]=_mm256_add_epi16(ff[18],t[18]);
  ff[19]=_mm256_add_epi16(ff[19],t[19]);
  ff[20]=_mm256_add_epi16(ff[20],t[20]);
  ff[21]=_mm256_add_epi16(ff[21],t[21]);
  ff[22]=_mm256_add_epi16(ff[22],t[22]);
  ff[23]=_mm256_add_epi16(ff[23],t[23]);
  ff[24]=_mm256_add_epi16(ff[24],t[24]);
  ff[25]=_mm256_add_epi16(ff[25],t[25]);
  ff[26]=_mm256_add_epi16(ff[26],t[26]);
  ff[27]=_mm256_add_epi16(ff[27],t[27]);
  ff[28]=_mm256_add_epi16(ff[28],t[28]);
  ff[29]=_mm256_add_epi16(ff[29],t[29]);
  ff[30]=_mm256_add_epi16(ff[30],t[30]);
  ff[31]=_mm256_add_epi16(ff[31],t[31]);
  ff[32]=_mm256_add_epi16(ff[32],t[32]);
  ff[33]=_mm256_add_epi16(ff[33],t[33]);
  ff[34]=_mm256_add_epi16(ff[34],t[34]);
  ff[35]=_mm256_add_epi16(ff[35],t[35]);
  ff[36]=_mm256_add_epi16(ff[36],t[36]);
  ff[37]=_mm256_add_epi16(ff[37],t[37]);
  ff[38]=_mm256_add_epi16(ff[38],t[38]);
  ff[39]=_mm256_add_epi16(ff[39],t[39]);
  ff[40]=_mm256_add_epi16(ff[40],t[40]);
  ff[41]=_mm256_add_epi16(ff[41],t[41]);
  ff[42]=_mm256_add_epi16(ff[42],t[42]);
  ff[43]=_mm256_add_epi16(ff[43],t[43]);
  ff[44]=_mm256_add_epi16(ff[44],t[44]);
  ff[45]=_mm256_add_epi16(ff[45],t[45]);
  ff[46]=_mm256_add_epi16(ff[46],t[46]);
  ff[47]=_mm256_add_epi16(ff[47],t[47]);
  ff[48]=_mm256_add_epi16(ff[48],t[48]);
  ff[49]=_mm256_add_epi16(ff[49],t[49]);
  ff[50]=_mm256_add_epi16(ff[50],t[50]);
  ff[51]=_mm256_add_epi16(ff[51],t[51]);
  ff[52]=_mm256_add_epi16(ff[52],t[52]);
  ff[53]=_mm256_add_epi16(ff[53],t[53]);
  ff[54]=_mm256_add_epi16(ff[54],t[54]);
  ff[55]=_mm256_add_epi16(ff[55],t[55]);
  ff[56]=_mm256_add_epi16(ff[56],t[56]);
  ff[57]=_mm256_add_epi16(ff[57],t[57]);
  ff[58]=_mm256_add_epi16(ff[58],t[58]);
  ff[59]=_mm256_add_epi16(ff[59],t[59]);
  ff[60]=_mm256_add_epi16(ff[60],t[60]);
  ff[61]=_mm256_add_epi16(ff[61],t[61]);
  ff[62]=_mm256_add_epi16(ff[62],t[62]);
  ff[63]=_mm256_add_epi16(ff[63],t[63]);

  ff[32]=_mm256_blendv_epi8(ff[32],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[33]=_mm256_blendv_epi8(ff[33],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[34]=_mm256_blendv_epi8(ff[34],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[35]=_mm256_blendv_epi8(ff[35],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[36]=_mm256_blendv_epi8(ff[36],ff[4],uv_mask);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[37]=_mm256_blendv_epi8(ff[37],ff[5],uv_mask);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[38]=_mm256_blendv_epi8(ff[38],ff[6],uv_mask);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[39]=_mm256_blendv_epi8(ff[39],ff[7],uv_mask);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);
  ff[40]=_mm256_blendv_epi8(ff[40],ff[8],uv_mask);
  ff[8]=_mm256_andnot_si256(uv_mask,ff[8]);
  ff[41]=_mm256_blendv_epi8(ff[41],ff[9],uv_mask);
  ff[9]=_mm256_andnot_si256(uv_mask,ff[9]);
  ff[42]=_mm256_blendv_epi8(ff[42],ff[10],uv_mask);
  ff[10]=_mm256_andnot_si256(uv_mask,ff[10]);
  ff[43]=_mm256_blendv_epi8(ff[43],ff[11],uv_mask);
  ff[11]=_mm256_andnot_si256(uv_mask,ff[11]);
  ff[44]=_mm256_blendv_epi8(ff[44],ff[12],uv_mask);
  ff[12]=_mm256_andnot_si256(uv_mask,ff[12]);
  ff[45]=_mm256_blendv_epi8(ff[45],ff[13],uv_mask);
  ff[13]=_mm256_andnot_si256(uv_mask,ff[13]);
  ff[46]=_mm256_blendv_epi8(ff[46],ff[14],uv_mask);
  ff[14]=_mm256_andnot_si256(uv_mask,ff[14]);
  ff[47]=_mm256_blendv_epi8(ff[47],ff[15],uv_mask);
  ff[15]=_mm256_andnot_si256(uv_mask,ff[15]);
  ff[48]=_mm256_blendv_epi8(ff[48],ff[16],uv_mask);
  ff[16]=_mm256_andnot_si256(uv_mask,ff[16]);
  ff[49]=_mm256_blendv_epi8(ff[49],ff[17],uv_mask);
  ff[17]=_mm256_andnot_si256(uv_mask,ff[17]);
  ff[50]=_mm256_blendv_epi8(ff[50],ff[18],uv_mask);
  ff[18]=_mm256_andnot_si256(uv_mask,ff[18]);
  ff[51]=_mm256_blendv_epi8(ff[51],ff[19],uv_mask);
  ff[19]=_mm256_andnot_si256(uv_mask,ff[19]);
  ff[52]=_mm256_blendv_epi8(ff[52],ff[20],uv_mask);
  ff[20]=_mm256_andnot_si256(uv_mask,ff[20]);
  ff[53]=_mm256_blendv_epi8(ff[53],ff[21],uv_mask);
  ff[21]=_mm256_andnot_si256(uv_mask,ff[21]);
  ff[54]=_mm256_blendv_epi8(ff[54],ff[22],uv_mask);
  ff[22]=_mm256_andnot_si256(uv_mask,ff[22]);
  ff[55]=_mm256_blendv_epi8(ff[55],ff[23],uv_mask);
  ff[23]=_mm256_andnot_si256(uv_mask,ff[23]);
  ff[56]=_mm256_blendv_epi8(ff[56],ff[24],uv_mask);
  ff[24]=_mm256_andnot_si256(uv_mask,ff[24]);
  ff[57]=_mm256_blendv_epi8(ff[57],ff[25],uv_mask);
  ff[25]=_mm256_andnot_si256(uv_mask,ff[25]);
  ff[58]=_mm256_blendv_epi8(ff[58],ff[26],uv_mask);
  ff[26]=_mm256_andnot_si256(uv_mask,ff[26]);
  ff[59]=_mm256_blendv_epi8(ff[59],ff[27],uv_mask);
  ff[27]=_mm256_andnot_si256(uv_mask,ff[27]);
  ff[60]=_mm256_blendv_epi8(ff[60],ff[28],uv_mask);
  ff[28]=_mm256_andnot_si256(uv_mask,ff[28]);
  ff[61]=_mm256_blendv_epi8(ff[61],ff[29],uv_mask);
  ff[29]=_mm256_andnot_si256(uv_mask,ff[29]);
  ff[62]=_mm256_blendv_epi8(ff[62],ff[30],uv_mask);
  ff[30]=_mm256_andnot_si256(uv_mask,ff[30]);
  ff[63]=_mm256_blendv_epi8(ff[63],ff[31],uv_mask);
  ff[31]=_mm256_andnot_si256(uv_mask,ff[31]);


  ff[0] = montproduct(ff[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2614
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <2614
  ff[7] = montproduct(ff[7],v4158_16); // <2614
  ff[8] = montproduct(ff[8],v4158_16); // <2614
  ff[9] = montproduct(ff[9],v4158_16); // <2626
  ff[10] = montproduct(ff[10],v4158_16); // <2603
  ff[11] = montproduct(ff[11],v4158_16); // <2603
  ff[12] = montproduct(ff[12],v4158_16); // <3574
  ff[13] = montproduct(ff[13],v4158_16); // <2603
  ff[14] = montproduct(ff[14],v4158_16); // <2614
  ff[15] = montproduct(ff[15],v4158_16); // <2603
  ff[16] = montproduct(ff[16],v4158_16); // <4019
  ff[17] = montproduct(ff[17],v4158_16); // <2626
  ff[18] = montproduct(ff[18],v4158_16); // <3574
  ff[19] = montproduct(ff[19],v4158_16); // <2626
  ff[20] = montproduct(ff[20],v4158_16); // <3551
  ff[21] = montproduct(ff[21],v4158_16); // <3585
  ff[22] = montproduct(ff[22],v4158_16); // <3574
  ff[23] = montproduct(ff[23],v4158_16); // <3562
  ff[24] = montproduct(ff[24],v4158_16); // <3562
  ff[25] = montproduct(ff[25],v4158_16); // <3596
  ff[26] = montproduct(ff[26],v4158_16); // <3551
  ff[27] = montproduct(ff[27],v4158_16); // <3539
  ff[28] = montproduct(ff[28],v4158_16); // <2660
  ff[29] = montproduct(ff[29],v4158_16); // <3551
  ff[30] = montproduct(ff[30],v4158_16); // <4032
  ff[31] = montproduct(ff[31],v4158_16); // <3752
  ff[32] = montproduct(ff[32],v4158_16); // <3791
  ff[33] = montproduct(ff[33],v4158_16); // <4048
  ff[34] = montproduct(ff[34],v4158_16); // <3551
  ff[35] = montproduct(ff[35],v4158_16); // <2660
  ff[36] = montproduct(ff[36],v4158_16); // <3539
  ff[37] = montproduct(ff[37],v4158_16); // <3551
  ff[38] = montproduct(ff[38],v4158_16); // <3596
  ff[39] = montproduct(ff[39],v4158_16); // <3562
  ff[40] = montproduct(ff[40],v4158_16); // <3562
  ff[41] = montproduct(ff[41],v4158_16); // <3574
  ff[42] = montproduct(ff[42],v4158_16); // <3585
  ff[43] = montproduct(ff[43],v4158_16); // <3551
  ff[44] = montproduct(ff[44],v4158_16); // <2626
  ff[45] = montproduct(ff[45],v4158_16); // <3574
  ff[46] = montproduct(ff[46],v4158_16); // <2626
  ff[47] = montproduct(ff[47],v4158_16); // <3976
  ff[48] = montproduct(ff[48],v4158_16); // <2614
  ff[49] = montproduct(ff[49],v4158_16); // <2614
  ff[50] = montproduct(ff[50],v4158_16); // <2603
  ff[51] = montproduct(ff[51],v4158_16); // <3574
  ff[52] = montproduct(ff[52],v4158_16); // <2603
  ff[53] = montproduct(ff[53],v4158_16); // <2603
  ff[54] = montproduct(ff[54],v4158_16); // <2626
  ff[55] = montproduct(ff[55],v4158_16); // <2614
  ff[56] = montproduct(ff[56],v4158_16); // <2614
  ff[57] = montproduct(ff[57],v4158_16); // <2614
  ff[58] = montproduct(ff[58],v4158_16); // <2626
  ff[59] = montproduct(ff[59],v4158_16); // <2614
  ff[60] = montproduct(ff[60],v4158_16); // <2626
  ff[61] = montproduct(ff[61],v4158_16); // <2626
  ff[62] = montproduct(ff[62],v4158_16); // <3084
  ff[63] = montproduct(ff[63],v4158_16); // <2827
}
void gf_polymul_512x512_avx2_uvqr_vr_x (__m256i *ff, __m256i *gg, __m256i *uvqr, __m256i *f, __m256i *g){
  __m256i t[64];
  __m256i u_mask = uv_over(uvqr);
  __m256i v_mask = uv_over(uvqr+32);
  __m256i uv_mask = _mm256_or_si256(u_mask,v_mask);
  __m256i f_mask = uv_over(f);

  gf_polymul_512x512_avx2_divR(ff,uvqr,f);
  ff[32]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[0]),ff[32]);
  ff[0]=_mm256_andnot_si256(f_mask,ff[0]);
  ff[33]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[1]),ff[33]);
  ff[1]=_mm256_andnot_si256(f_mask,ff[1]);
  ff[34]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[2]),ff[34]);
  ff[2]=_mm256_andnot_si256(f_mask,ff[2]);
  ff[35]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[3]),ff[35]);
  ff[3]=_mm256_andnot_si256(f_mask,ff[3]);
  ff[36]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[4]),ff[36]);
  ff[4]=_mm256_andnot_si256(f_mask,ff[4]);
  ff[37]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[5]),ff[37]);
  ff[5]=_mm256_andnot_si256(f_mask,ff[5]);
  ff[38]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[6]),ff[38]);
  ff[6]=_mm256_andnot_si256(f_mask,ff[6]);
  ff[39]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[7]),ff[39]);
  ff[7]=_mm256_andnot_si256(f_mask,ff[7]);
  ff[40]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[8]),ff[40]);
  ff[8]=_mm256_andnot_si256(f_mask,ff[8]);
  ff[41]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[9]),ff[41]);
  ff[9]=_mm256_andnot_si256(f_mask,ff[9]);
  ff[42]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[10]),ff[42]);
  ff[10]=_mm256_andnot_si256(f_mask,ff[10]);
  ff[43]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[11]),ff[43]);
  ff[11]=_mm256_andnot_si256(f_mask,ff[11]);
  ff[44]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[12]),ff[44]);
  ff[12]=_mm256_andnot_si256(f_mask,ff[12]);
  ff[45]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[13]),ff[45]);
  ff[13]=_mm256_andnot_si256(f_mask,ff[13]);
  ff[46]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[14]),ff[46]);
  ff[14]=_mm256_andnot_si256(f_mask,ff[14]);
  ff[47]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[15]),ff[47]);
  ff[15]=_mm256_andnot_si256(f_mask,ff[15]);
  ff[48]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[16]),ff[48]);
  ff[16]=_mm256_andnot_si256(f_mask,ff[16]);
  ff[49]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[17]),ff[49]);
  ff[17]=_mm256_andnot_si256(f_mask,ff[17]);
  ff[50]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[18]),ff[50]);
  ff[18]=_mm256_andnot_si256(f_mask,ff[18]);
  ff[51]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[19]),ff[51]);
  ff[19]=_mm256_andnot_si256(f_mask,ff[19]);
  ff[52]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[20]),ff[52]);
  ff[20]=_mm256_andnot_si256(f_mask,ff[20]);
  ff[53]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[21]),ff[53]);
  ff[21]=_mm256_andnot_si256(f_mask,ff[21]);
  ff[54]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[22]),ff[54]);
  ff[22]=_mm256_andnot_si256(f_mask,ff[22]);
  ff[55]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[23]),ff[55]);
  ff[23]=_mm256_andnot_si256(f_mask,ff[23]);
  ff[56]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[24]),ff[56]);
  ff[24]=_mm256_andnot_si256(f_mask,ff[24]);
  ff[57]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[25]),ff[57]);
  ff[25]=_mm256_andnot_si256(f_mask,ff[25]);
  ff[58]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[26]),ff[58]);
  ff[26]=_mm256_andnot_si256(f_mask,ff[26]);
  ff[59]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[27]),ff[59]);
  ff[27]=_mm256_andnot_si256(f_mask,ff[27]);
  ff[60]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[28]),ff[60]);
  ff[28]=_mm256_andnot_si256(f_mask,ff[28]);
  ff[61]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[29]),ff[61]);
  ff[29]=_mm256_andnot_si256(f_mask,ff[29]);
  ff[62]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[30]),ff[62]);
  ff[30]=_mm256_andnot_si256(f_mask,ff[30]);
  ff[63]=_mm256_or_si256(_mm256_and_si256(f_mask,ff[31]),ff[63]);
  ff[31]=_mm256_andnot_si256(f_mask,ff[31]);
  gf_polymul_512x512_avx2_divR(t,uvqr+32,g);
  ff[17] = barrett_fake(ff[17]); // <2610
  t[17] = barrett_fake(t[17]); // <2610
  ff[19] = barrett_fake(ff[19]); // <2610
  t[19] = barrett_fake(t[19]); // <2610
  ff[28] = barrett_fake(ff[28]); // <2881
  t[28] = barrett_fake(t[28]); // <2881
  ff[35] = barrett_fake(ff[35]); // <2881
  t[35] = barrett_fake(t[35]); // <2881
  ff[44] = barrett_fake(ff[44]); // <2610
  t[44] = barrett_fake(t[44]); // <2610
  ff[46] = barrett_fake(ff[46]); // <2610
  t[46] = barrett_fake(t[46]); // <2610
  ff[0]=_mm256_add_epi16(ff[0],t[0]);
  ff[1]=_mm256_add_epi16(ff[1],t[1]);
  ff[2]=_mm256_add_epi16(ff[2],t[2]);
  ff[3]=_mm256_add_epi16(ff[3],t[3]);
  ff[4]=_mm256_add_epi16(ff[4],t[4]);
  ff[5]=_mm256_add_epi16(ff[5],t[5]);
  ff[6]=_mm256_add_epi16(ff[6],t[6]);
  ff[7]=_mm256_add_epi16(ff[7],t[7]);
  ff[8]=_mm256_add_epi16(ff[8],t[8]);
  ff[9]=_mm256_add_epi16(ff[9],t[9]);
  ff[10]=_mm256_add_epi16(ff[10],t[10]);
  ff[11]=_mm256_add_epi16(ff[11],t[11]);
  ff[12]=_mm256_add_epi16(ff[12],t[12]);
  ff[13]=_mm256_add_epi16(ff[13],t[13]);
  ff[14]=_mm256_add_epi16(ff[14],t[14]);
  ff[15]=_mm256_add_epi16(ff[15],t[15]);
  ff[16]=_mm256_add_epi16(ff[16],t[16]);
  ff[17]=_mm256_add_epi16(ff[17],t[17]);
  ff[18]=_mm256_add_epi16(ff[18],t[18]);
  ff[19]=_mm256_add_epi16(ff[19],t[19]);
  ff[20]=_mm256_add_epi16(ff[20],t[20]);
  ff[21]=_mm256_add_epi16(ff[21],t[21]);
  ff[22]=_mm256_add_epi16(ff[22],t[22]);
  ff[23]=_mm256_add_epi16(ff[23],t[23]);
  ff[24]=_mm256_add_epi16(ff[24],t[24]);
  ff[25]=_mm256_add_epi16(ff[25],t[25]);
  ff[26]=_mm256_add_epi16(ff[26],t[26]);
  ff[27]=_mm256_add_epi16(ff[27],t[27]);
  ff[28]=_mm256_add_epi16(ff[28],t[28]);
  ff[29]=_mm256_add_epi16(ff[29],t[29]);
  ff[30]=_mm256_add_epi16(ff[30],t[30]);
  ff[31]=_mm256_add_epi16(ff[31],t[31]);
  ff[32]=_mm256_add_epi16(ff[32],t[32]);
  ff[33]=_mm256_add_epi16(ff[33],t[33]);
  ff[34]=_mm256_add_epi16(ff[34],t[34]);
  ff[35]=_mm256_add_epi16(ff[35],t[35]);
  ff[36]=_mm256_add_epi16(ff[36],t[36]);
  ff[37]=_mm256_add_epi16(ff[37],t[37]);
  ff[38]=_mm256_add_epi16(ff[38],t[38]);
  ff[39]=_mm256_add_epi16(ff[39],t[39]);
  ff[40]=_mm256_add_epi16(ff[40],t[40]);
  ff[41]=_mm256_add_epi16(ff[41],t[41]);
  ff[42]=_mm256_add_epi16(ff[42],t[42]);
  ff[43]=_mm256_add_epi16(ff[43],t[43]);
  ff[44]=_mm256_add_epi16(ff[44],t[44]);
  ff[45]=_mm256_add_epi16(ff[45],t[45]);
  ff[46]=_mm256_add_epi16(ff[46],t[46]);
  ff[47]=_mm256_add_epi16(ff[47],t[47]);
  ff[48]=_mm256_add_epi16(ff[48],t[48]);
  ff[49]=_mm256_add_epi16(ff[49],t[49]);
  ff[50]=_mm256_add_epi16(ff[50],t[50]);
  ff[51]=_mm256_add_epi16(ff[51],t[51]);
  ff[52]=_mm256_add_epi16(ff[52],t[52]);
  ff[53]=_mm256_add_epi16(ff[53],t[53]);
  ff[54]=_mm256_add_epi16(ff[54],t[54]);
  ff[55]=_mm256_add_epi16(ff[55],t[55]);
  ff[56]=_mm256_add_epi16(ff[56],t[56]);
  ff[57]=_mm256_add_epi16(ff[57],t[57]);
  ff[58]=_mm256_add_epi16(ff[58],t[58]);
  ff[59]=_mm256_add_epi16(ff[59],t[59]);
  ff[60]=_mm256_add_epi16(ff[60],t[60]);
  ff[61]=_mm256_add_epi16(ff[61],t[61]);
  ff[62]=_mm256_add_epi16(ff[62],t[62]);
  ff[63]=_mm256_add_epi16(ff[63],t[63]);

  ff[32]=_mm256_blendv_epi8(ff[32],ff[0],uv_mask);
  ff[0]=_mm256_andnot_si256(uv_mask,ff[0]);
  ff[33]=_mm256_blendv_epi8(ff[33],ff[1],uv_mask);
  ff[1]=_mm256_andnot_si256(uv_mask,ff[1]);
  ff[34]=_mm256_blendv_epi8(ff[34],ff[2],uv_mask);
  ff[2]=_mm256_andnot_si256(uv_mask,ff[2]);
  ff[35]=_mm256_blendv_epi8(ff[35],ff[3],uv_mask);
  ff[3]=_mm256_andnot_si256(uv_mask,ff[3]);
  ff[36]=_mm256_blendv_epi8(ff[36],ff[4],uv_mask);
  ff[4]=_mm256_andnot_si256(uv_mask,ff[4]);
  ff[37]=_mm256_blendv_epi8(ff[37],ff[5],uv_mask);
  ff[5]=_mm256_andnot_si256(uv_mask,ff[5]);
  ff[38]=_mm256_blendv_epi8(ff[38],ff[6],uv_mask);
  ff[6]=_mm256_andnot_si256(uv_mask,ff[6]);
  ff[39]=_mm256_blendv_epi8(ff[39],ff[7],uv_mask);
  ff[7]=_mm256_andnot_si256(uv_mask,ff[7]);
  ff[40]=_mm256_blendv_epi8(ff[40],ff[8],uv_mask);
  ff[8]=_mm256_andnot_si256(uv_mask,ff[8]);
  ff[41]=_mm256_blendv_epi8(ff[41],ff[9],uv_mask);
  ff[9]=_mm256_andnot_si256(uv_mask,ff[9]);
  ff[42]=_mm256_blendv_epi8(ff[42],ff[10],uv_mask);
  ff[10]=_mm256_andnot_si256(uv_mask,ff[10]);
  ff[43]=_mm256_blendv_epi8(ff[43],ff[11],uv_mask);
  ff[11]=_mm256_andnot_si256(uv_mask,ff[11]);
  ff[44]=_mm256_blendv_epi8(ff[44],ff[12],uv_mask);
  ff[12]=_mm256_andnot_si256(uv_mask,ff[12]);
  ff[45]=_mm256_blendv_epi8(ff[45],ff[13],uv_mask);
  ff[13]=_mm256_andnot_si256(uv_mask,ff[13]);
  ff[46]=_mm256_blendv_epi8(ff[46],ff[14],uv_mask);
  ff[14]=_mm256_andnot_si256(uv_mask,ff[14]);
  ff[47]=_mm256_blendv_epi8(ff[47],ff[15],uv_mask);
  ff[15]=_mm256_andnot_si256(uv_mask,ff[15]);
  ff[48]=_mm256_blendv_epi8(ff[48],ff[16],uv_mask);
  ff[16]=_mm256_andnot_si256(uv_mask,ff[16]);
  ff[49]=_mm256_blendv_epi8(ff[49],ff[17],uv_mask);
  ff[17]=_mm256_andnot_si256(uv_mask,ff[17]);
  ff[50]=_mm256_blendv_epi8(ff[50],ff[18],uv_mask);
  ff[18]=_mm256_andnot_si256(uv_mask,ff[18]);
  ff[51]=_mm256_blendv_epi8(ff[51],ff[19],uv_mask);
  ff[19]=_mm256_andnot_si256(uv_mask,ff[19]);
  ff[52]=_mm256_blendv_epi8(ff[52],ff[20],uv_mask);
  ff[20]=_mm256_andnot_si256(uv_mask,ff[20]);
  ff[53]=_mm256_blendv_epi8(ff[53],ff[21],uv_mask);
  ff[21]=_mm256_andnot_si256(uv_mask,ff[21]);
  ff[54]=_mm256_blendv_epi8(ff[54],ff[22],uv_mask);
  ff[22]=_mm256_andnot_si256(uv_mask,ff[22]);
  ff[55]=_mm256_blendv_epi8(ff[55],ff[23],uv_mask);
  ff[23]=_mm256_andnot_si256(uv_mask,ff[23]);
  ff[56]=_mm256_blendv_epi8(ff[56],ff[24],uv_mask);
  ff[24]=_mm256_andnot_si256(uv_mask,ff[24]);
  ff[57]=_mm256_blendv_epi8(ff[57],ff[25],uv_mask);
  ff[25]=_mm256_andnot_si256(uv_mask,ff[25]);
  ff[58]=_mm256_blendv_epi8(ff[58],ff[26],uv_mask);
  ff[26]=_mm256_andnot_si256(uv_mask,ff[26]);
  ff[59]=_mm256_blendv_epi8(ff[59],ff[27],uv_mask);
  ff[27]=_mm256_andnot_si256(uv_mask,ff[27]);
  ff[60]=_mm256_blendv_epi8(ff[60],ff[28],uv_mask);
  ff[28]=_mm256_andnot_si256(uv_mask,ff[28]);
  ff[61]=_mm256_blendv_epi8(ff[61],ff[29],uv_mask);
  ff[29]=_mm256_andnot_si256(uv_mask,ff[29]);
  ff[62]=_mm256_blendv_epi8(ff[62],ff[30],uv_mask);
  ff[30]=_mm256_andnot_si256(uv_mask,ff[30]);
  ff[63]=_mm256_blendv_epi8(ff[63],ff[31],uv_mask);
  ff[31]=_mm256_andnot_si256(uv_mask,ff[31]);


  gg[0]=_mm256_add_epi16(gg[0],t[0]);
  gg[1]=_mm256_add_epi16(gg[1],t[1]);
  gg[2]=_mm256_add_epi16(gg[2],t[2]);
  gg[3]=_mm256_add_epi16(gg[3],t[3]);
  gg[4]=_mm256_add_epi16(gg[4],t[4]);
  gg[5]=_mm256_add_epi16(gg[5],t[5]);
  gg[6]=_mm256_add_epi16(gg[6],t[6]);
  gg[7]=_mm256_add_epi16(gg[7],t[7]);
  gg[8]=_mm256_add_epi16(gg[8],t[8]);
  gg[9]=_mm256_add_epi16(gg[9],t[9]);
  gg[10]=_mm256_add_epi16(gg[10],t[10]);
  gg[11]=_mm256_add_epi16(gg[11],t[11]);
  gg[12]=_mm256_add_epi16(gg[12],t[12]);
  gg[13]=_mm256_add_epi16(gg[13],t[13]);
  gg[14]=_mm256_add_epi16(gg[14],t[14]);
  gg[15]=_mm256_add_epi16(gg[15],t[15]);
  gg[16]=_mm256_add_epi16(gg[16],t[16]);
  gg[17]=_mm256_add_epi16(gg[17],t[17]);
  gg[18]=_mm256_add_epi16(gg[18],t[18]);
  gg[19]=_mm256_add_epi16(gg[19],t[19]);
  gg[20]=_mm256_add_epi16(gg[20],t[20]);
  gg[21]=_mm256_add_epi16(gg[21],t[21]);
  gg[22]=_mm256_add_epi16(gg[22],t[22]);
  gg[23]=_mm256_add_epi16(gg[23],t[23]);
  gg[24]=_mm256_add_epi16(gg[24],t[24]);
  gg[25]=_mm256_add_epi16(gg[25],t[25]);
  gg[26]=_mm256_add_epi16(gg[26],t[26]);
  gg[27]=_mm256_add_epi16(gg[27],t[27]);
  gg[28]=_mm256_add_epi16(gg[28],t[28]);
  gg[29]=_mm256_add_epi16(gg[29],t[29]);
  gg[30]=_mm256_add_epi16(gg[30],t[30]);
  gg[31]=_mm256_add_epi16(gg[31],t[31]);
  gg[32]=_mm256_add_epi16(gg[32],t[32]);
  gg[33]=_mm256_add_epi16(gg[33],t[33]);
  gg[34]=_mm256_add_epi16(gg[34],t[34]);
  gg[35]=_mm256_add_epi16(gg[35],t[35]);
  gg[36]=_mm256_add_epi16(gg[36],t[36]);
  gg[37]=_mm256_add_epi16(gg[37],t[37]);
  gg[38]=_mm256_add_epi16(gg[38],t[38]);
  gg[39]=_mm256_add_epi16(gg[39],t[39]);
  gg[40]=_mm256_add_epi16(gg[40],t[40]);
  gg[41]=_mm256_add_epi16(gg[41],t[41]);
  gg[42]=_mm256_add_epi16(gg[42],t[42]);
  gg[43]=_mm256_add_epi16(gg[43],t[43]);
  gg[44]=_mm256_add_epi16(gg[44],t[44]);
  gg[45]=_mm256_add_epi16(gg[45],t[45]);
  gg[46]=_mm256_add_epi16(gg[46],t[46]);
  gg[47]=_mm256_add_epi16(gg[47],t[47]);
  gg[48]=_mm256_add_epi16(gg[48],t[48]);
  gg[49]=_mm256_add_epi16(gg[49],t[49]);
  gg[50]=_mm256_add_epi16(gg[50],t[50]);
  gg[51]=_mm256_add_epi16(gg[51],t[51]);
  gg[52]=_mm256_add_epi16(gg[52],t[52]);
  gg[53]=_mm256_add_epi16(gg[53],t[53]);
  gg[54]=_mm256_add_epi16(gg[54],t[54]);
  gg[55]=_mm256_add_epi16(gg[55],t[55]);
  gg[56]=_mm256_add_epi16(gg[56],t[56]);
  gg[57]=_mm256_add_epi16(gg[57],t[57]);
  gg[58]=_mm256_add_epi16(gg[58],t[58]);
  gg[59]=_mm256_add_epi16(gg[59],t[59]);
  gg[60]=_mm256_add_epi16(gg[60],t[60]);
  gg[61]=_mm256_add_epi16(gg[61],t[61]);
  gg[62]=_mm256_add_epi16(gg[62],t[62]);
  gg[63]=_mm256_add_epi16(gg[63],t[63]);

  ff[0] = montproduct(ff[0],v4158_16); // <2843
  ff[1] = montproduct(ff[1],v4158_16); // <3100
  ff[2] = montproduct(ff[2],v4158_16); // <2626
  ff[3] = montproduct(ff[3],v4158_16); // <2626
  ff[4] = montproduct(ff[4],v4158_16); // <2614
  ff[5] = montproduct(ff[5],v4158_16); // <2626
  ff[6] = montproduct(ff[6],v4158_16); // <2614
  ff[7] = montproduct(ff[7],v4158_16); // <2614
  ff[8] = montproduct(ff[8],v4158_16); // <2614
  ff[9] = montproduct(ff[9],v4158_16); // <2626
  ff[10] = montproduct(ff[10],v4158_16); // <2603
  ff[11] = montproduct(ff[11],v4158_16); // <2603
  ff[12] = montproduct(ff[12],v4158_16); // <3574
  ff[13] = montproduct(ff[13],v4158_16); // <2603
  ff[14] = montproduct(ff[14],v4158_16); // <2614
  ff[15] = montproduct(ff[15],v4158_16); // <2603
  ff[16] = montproduct(ff[16],v4158_16); // <4019
  ff[17] = montproduct(ff[17],v4158_16); // <2626
  ff[18] = montproduct(ff[18],v4158_16); // <3574
  ff[19] = montproduct(ff[19],v4158_16); // <2626
  ff[20] = montproduct(ff[20],v4158_16); // <3551
  ff[21] = montproduct(ff[21],v4158_16); // <3585
  ff[22] = montproduct(ff[22],v4158_16); // <3574
  ff[23] = montproduct(ff[23],v4158_16); // <3562
  ff[24] = montproduct(ff[24],v4158_16); // <3562
  ff[25] = montproduct(ff[25],v4158_16); // <3596
  ff[26] = montproduct(ff[26],v4158_16); // <3551
  ff[27] = montproduct(ff[27],v4158_16); // <3539
  ff[28] = montproduct(ff[28],v4158_16); // <2660
  ff[29] = montproduct(ff[29],v4158_16); // <3551
  ff[30] = montproduct(ff[30],v4158_16); // <4032
  ff[31] = montproduct(ff[31],v4158_16); // <3752
  ff[32] = montproduct(ff[32],v4158_16); // <3791
  ff[33] = montproduct(ff[33],v4158_16); // <4048
  ff[34] = montproduct(ff[34],v4158_16); // <3551
  ff[35] = montproduct(ff[35],v4158_16); // <2660
  ff[36] = montproduct(ff[36],v4158_16); // <3539
  ff[37] = montproduct(ff[37],v4158_16); // <3551
  ff[38] = montproduct(ff[38],v4158_16); // <3596
  ff[39] = montproduct(ff[39],v4158_16); // <3562
  ff[40] = montproduct(ff[40],v4158_16); // <3562
  ff[41] = montproduct(ff[41],v4158_16); // <3574
  ff[42] = montproduct(ff[42],v4158_16); // <3585
  ff[43] = montproduct(ff[43],v4158_16); // <3551
  ff[44] = montproduct(ff[44],v4158_16); // <2626
  ff[45] = montproduct(ff[45],v4158_16); // <3574
  ff[46] = montproduct(ff[46],v4158_16); // <2626
  ff[47] = montproduct(ff[47],v4158_16); // <3976
  ff[48] = montproduct(ff[48],v4158_16); // <2614
  ff[49] = montproduct(ff[49],v4158_16); // <2614
  ff[50] = montproduct(ff[50],v4158_16); // <2603
  ff[51] = montproduct(ff[51],v4158_16); // <3574
  ff[52] = montproduct(ff[52],v4158_16); // <2603
  ff[53] = montproduct(ff[53],v4158_16); // <2603
  ff[54] = montproduct(ff[54],v4158_16); // <2626
  ff[55] = montproduct(ff[55],v4158_16); // <2614
  ff[56] = montproduct(ff[56],v4158_16); // <2614
  ff[57] = montproduct(ff[57],v4158_16); // <2614
  ff[58] = montproduct(ff[58],v4158_16); // <2626
  ff[59] = montproduct(ff[59],v4158_16); // <2614
  ff[60] = montproduct(ff[60],v4158_16); // <2626
  ff[61] = montproduct(ff[61],v4158_16); // <2626
  ff[62] = montproduct(ff[62],v4158_16); // <3084
  ff[63] = montproduct(ff[63],v4158_16); // <2827

  ff[0] = _mm256_or_si256(_mm256_and_si256(_mm256_and_si256(u_mask,f_mask),v01),ff[0]);
}
